NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:34 2022
FILE NAME: orbanly_part_f.f

PROCEDURE NAME: ORBANLY
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     1:                 subroutine orbanly(my_rank,iband,ik,coef,rho1,rho2,ng2q,ng2
     2:                & ,g2,cwk,tau,ntauq,numty,ntyq,ntype,tpiba,mxofl,omega)
     3:                 implicit double precision (a-h,o-z)
     4:           c      PARAMETER(MESHQ=1000,ISPD=5,NCRQ=2,ntypq=4,eps=1.d-08)
     5:                 PARAMETER(MESHQ=1000,ISPD=8,NCRQ=2,ntypq=4,eps=1.d-08) ! see main
     6:                 dimension g2(4,ng2q),tau(3,ntauq),numty(ntyq)
     7:                 DIMENSION RAD(MESHQ),PSPOT(MESHQ,ISPD),PSPOT2(MESHQ,ISPD)
     8:           c      DIMENSION PHIL(MESHQ,2),WORK(MESHQ),RC0(NCRQ),COR(NCRQ)
     9:                 DIMENSION PHIL(MESHQ,4),WORK(MESHQ),RC0(NCRQ),COR(NCRQ)
    10:           c      dimension pssum(3),psrsum(9)
    11:                 dimension pssum(4),psrsum(16)
    12:           c      dimension rho1(ng2q),rho2(ng2q),rc(3,ntypq),zo(3,ntypq)
    13:                 dimension rho1(ng2q),rho2(ng2q),rc(4,ntypq),zo(4,ntypq)
    14:                &         ,mxofl(ntyq)
    15:           c      complex*16 coef(ng2q),covl(9),cwk(ng2q)
    16:                 complex*16 coef(ng2q),covl(16),cwk(ng2q)
    17:           c **** temp check
    18:           c      write(6,*)' in sub. orbanly :  omega = ',omega
    19:           c ****  check end
    20:                 if ( ntypq.lt.ntyq ) then
    21:                 if (my_rank.eq.0 ) then
    22:                 write(6,*)' in sub. orbanly: ntypq should be ',ntyq
    23:                 endif
    24:                 stop
    25:                 end if
    26:           c Wavefucntion's projection on each atom
    27:           c ****  psrsum( 1) -  s component
    28:           c ****  psrsum( 2) - Px component
    29:           c ****  psrsum( 3) - Py component
    30:           c ****  psrsum( 4) - Pz component
    31:           c ****  psrsum( 5) - D3z^2-1 component
    32:           c ****  psrsum( 6) - Dx^2-y^2 component
    33:           c ****  psrsum( 7) - Dxy component
    34:           c ****  psrsum( 8) - Dyz component
    35:           c ****  psrsum( 9) - Dzx component
    36:           c ****  psrsum(10) - Fz^3          component
    37:           c ****  psrsum(11) - Fx*(x^2-3y^2) component
    38:           c ****  psrsum(12) - Fy*(3x^2-y^2) component
    39:           c ****  psrsum(13) - Fz*(x^2-y-2 ) component
    40:           c ****  psrsum(14) - Fx*y*z        component
    41:           c ****  psrsum(15) - Fx*(5z^2-r^2) component
    42:           c ****  psrsum(16) - Fy*(5z^2-r^2) component
    43:           c
    44:           c   followings are up to you
    45:           c **** temp check for G-vectors
    46:           c      write(6,*)' G-vector check !!! '
    47:           c      gx=0
    48:           c      gy=0
    49:           c      gz=0
    50:           c      do ig=1,ng2
    51:           c      gx=gx+g2(1,ig)
    52:           c      gy=gy+g2(2,ig)
    53:           c      gz=gz+g2(3,ig)
    54:           c      enddo
    55:           c      write(6,*)' sum Gx Gy Gz = ',gx,gy,gz
    56:           c **** temp check end
    57:           c
    58:           c   rc : radial limitation for orbital analysis
    59:           c                  (a.u.)
    60:                 rc(1,1)=5.0d0     ! for type 1  Ce  -- s-orbital
    61:                 rc(2,1)=5.5d0     ! for type 1  Ce  -- p-orbital
    62:                 rc(3,1)=5.5d0     ! for type 1  Ce  -- d-orbital
    63:                 rc(4,1)=5.5d0     ! for type 1  Ce  -- f-orbital
    64:                 rc(1,2)=5.0d0     ! for type 2  V   -- s-orbital
    65:                 rc(2,2)=5.5d0     ! for type 2  V   -- p-orbital
    66:                 rc(3,2)=5.5d0     ! for type 2  V   -- d-orbital
    67:                 rc(1,3)=5.0d0     ! for type 3  Al  -- s-orbital
    68:                 rc(2,3)=5.5d0     ! for type 3  Al  -- p-orbital
    69:                 rc(1,4)=3.0d0     ! for type 4  O   -- s-orbital
    70:                 rc(2,4)=3.5d0     ! for type 4  O   -- p-orbital
    71:           c ****  We will ignore followings !!
    72:           c
    73:           c   zo : occupation of electrons for atomic orbitals
    74:           c   zo(l,ity)  : l=1,2  for s and P orbotals, ity  atomic type
    75:           c ***  for Si
    76:           c      zo(1,1)=2.d0
    77:           c      zo(2,1)=2.d0
    78:           c ***  for O
    79:           c      zo(1,2)=2.d0
    80:           c      zo(2,2)=4.d0
    81:           c ***  for H
    82:           c      zo(1,3)=1.d0
    83:           c      zo(2,3)=0.d0
    84:           c
    85:           c ***  Instead of above, we do followings:
    86: *------>        do ityp=1,ntypq
    87: |               zo(1,ityp)=2.d0
    88: |               zo(2,ityp)=6.d0
    89: |               zo(3,ityp)=10.d0
    90: |               zo(4,ityp)=14.d0
    91: *------         enddo
    92:           c
    93:           c
    94:           c    ik1 ik2 :  The first and the last k-point
    95:           c                   of your interest
    96:                 ik1=1
    97:                 ik2=4
    98:                 if ( ik.lt.ik1 .or. ik.gt.ik2 ) then
    99:                 return
   100:                 endif
   101:           c
   102:           c   nb1 nb2 : bottom and top bands of your interest
   103:           c *** Ce doped YAG
   104:                 nb1=320
   105:                 nb2=423   ! for a two-layer slab
   106:           c *** Ce atom
   107:           c      nb1=1
   108:           c      nb2=20   ! for a two-layer slab
   109:           c      nb1=128   ! for 64-cell
   110:           c      nb2=160
   111:           c      nb1=106   ! for 54-cell
   112:           c      nb2=120
   113:                 if ( iband.lt.nb1 .or. iband.gt.nb2 ) then
   114:                 return
   115:                 end if
   116:           c
   117:                 if (my_rank.eq.0 ) then
   118:                 write(6,*)
   119:                 write(6,*) '  Orbital analysis for BAND = ',iband
   120:                 write(6,*)
   121:                 endif
   122:           c    re-store coef into rho1 rho2
   123: V------>        do 100 ig=1,ng2
   124: |               rho1(ig)=real(coef(ig))
   125: |               rho2(ig)=imag(coef(ig))
   126: V------     100 continue
   127:           c **** temp check
   128:           c      write(6,*)' check norm of the Bloch wave function '
   129:           c      wnorm=0
   130:           c      do 99 ig=1,ng2
   131:           c   99 wnorm=wnorm+rho1(ig)**2+rho2(ig)**2
   132:           c      wnorm=dsqrt(wnorm)
   133:           c      write(6,*)' norm = ',wnorm
   134:           c **** temp check end
   135:           c
   136:                 itseq=0
   137: +------>        do 1 ity=1,ntype
   138: |               if (my_rank.eq.0 ) then
   139: |               write(6,*)
   140: |               write(6,*)'  --- start type ',ity,' atoms ---'
   141: |               endif
   142: |W----->          do 56 il=1,mxofl(ity)
   143: ||*---->          do 56 ir=1,meshq
   144: ||*----      56   phil(ir,il)=0
   145: |                IF( NUMTY(ITY).LT.0 .OR. MXOFL(ITY).EQ.1 ) THEN
   146: |                if (my_rank.eq.0 ) then
   147: |                write(6,*)'  Up to p-orbitals are considered '
   148: |                endif
   149: |                 CALL PSREAD2(ITY,ISPD,MESHQ,MESH,RAD,PSPOT
   150: |              &            ,PHIL,WORK
   151: |              &            ,NCRQ,ZV,RC0,COR,NUMC)
   152: |                 else
   153: |                 call PSREAD(ITY,ISPD,MESHQ,MESH,RAD,PSPOT,PSPOT2,PHIL,WORK,
   154: |              &  NCRQ,ZV,RC0,COR,NUMC)
   155: |                end if
   156: |         c ***** integrate the norm of the pseudowavefunction up to rad=rc
   157: |         c ****  temp check
   158: |         c      do 18 i=1,mesh
   159: |         c      if ( rad(i).gt.rc(2,ity) ) then
   160: |         c      irmax=i-1
   161: |         c      goto 19
   162: |         c      end if
   163: |         c   18 continue
   164: |         c   19 continue
   165: |         c      write(6,*)' Pseudo wavefunction for type',ity
   166: |         c      write(6,1119)rad(irmax),phil(irmax,1),phil(irmax,2)
   167: |         c 1119 format(' r=',f12.6,' Wf s-orbital =',d14.6,
   168: |         c     &                   ' Wf P-orbital =',d14.6 )
   169: |         c ****  temp check end
   170: |               lmax=MXOFL(ITY)
   171: |+----->        do 13 l=1,lmax
   172: ||V---->        do 2 i=1,mesh
   173: ||V----       2 work(i)=phil(i,l)**2
   174: |+-----      13 call normint(my_rank,rc(l,ity),rad,work,mesh,meshq,pssum(l),l
   175: |              &            ,H,zo(l,ity))
   176: |         c ****** calculate Bloch wavefunction's projection on each atom
   177: |               nnmtyy=abs( numty(ity) )
   178: |         c **** temp check
   179: |         c      write(6,*)'  *****  in sub. psirgen  ****** '
   180: |         c      write(6,*)' check norm of the Bloch wave function '
   181: |               wnorm=0
   182: |V----->        do 99 ig=1,ng2
   183: |V----- F    99 wnorm=wnorm+rho1(ig)**2+rho2(ig)**2
   184: |               wnorm=dsqrt(wnorm)
   185: |               if ( abs(wnorm-1.d0).gt.1.d-08 ) then
   186: |               if (my_rank.eq.0 ) then
   187: |               write(6,*)' WARNING!!! wrong norm of the wavefunction !!! '
   188: |               write(6,*)' norm = ',wnorm
   189: |               endif
   190: |               end if
   191: |         c **** temp check end
   192: |+----->        do 3 it=1,nnmtyy
   193: ||              itseq=itseq+1
   194: ||        c ***  check special atoms only *** PART OF ATOMS !!!!
   195: ||               if ( itseq.eq.1 ) then
   196: ||        cccc
   197: ||              call psirgen(tau(1,itseq),rho1,rho2,cwk
   198: ||             &    ,g2(1,1),ng2q,ng2
   199: ||             &    ,rad,meshq,mesh,psrsum,H,rc(1,ity),tpiba,omega
   200: ||        c ****  added !!
   201: ||             &    ,phil,covl,mxofl(ity) )
   202: ||              if (my_rank.eq.0 ) then
   203: ||              write(6,*)
   204: ||              write(6,*)' atomic site # = ',itseq
   205: ||              write(6,9000)
   206: ||*---->        write(6,1000)(tau(i,itseq),i=1,3)
   207: ||        c      write(6,*)' Orbital charge   in Crystal  Atomic     Ratio'
   208: ||        c      write(6,1010)psrsum(1),pssum(1),psrsum(1)/pssum(1)
   209: ||        c      if ( numty(ity).lt.0 ) then
   210: ||        c       write(6,1020)psrsum(2),pssum(2),psrsum(2)
   211: ||        c       write(6,1030)psrsum(3),pssum(2),psrsum(3)
   212: ||        c       write(6,1040)psrsum(4),pssum(2),psrsum(4)
   213: ||        c      else
   214: ||        c       write(6,1020)psrsum(2),pssum(2),psrsum(2)/(pssum(2)+eps)
   215: ||        c       write(6,1030)psrsum(3),pssum(2),psrsum(3)/(pssum(2)+eps)
   216: ||        c       write(6,1040)psrsum(4),pssum(2),psrsum(4)/(pssum(2)+eps)
   217: ||        c      endif
   218: ||        c      if (lmax.ge.3) then
   219: ||        c      write(6,1050)psrsum(5),pssum(3),psrsum(5)/(pssum(3)+eps)
   220: ||        c      write(6,1060)psrsum(6),pssum(3),psrsum(6)/(pssum(3)+eps)
   221: ||        c      write(6,1070)psrsum(7),pssum(3),psrsum(7)/(pssum(3)+eps)
   222: ||        c      write(6,1080)psrsum(8),pssum(3),psrsum(8)/(pssum(3)+eps)
   223: ||        c      write(6,1090)psrsum(9),pssum(3),psrsum(9)/(pssum(3)+eps)
   224: ||        c      endif
   225: ||        c      if (lmax.eq.4) then
   226: ||        c      write(6,1100)psrsum(10),pssum(4),psrsum(10)/(pssum(4)+eps)
   227: ||        c      write(6,1110)psrsum(11),pssum(4),psrsum(11)/(pssum(4)+eps)
   228: ||        c      write(6,1120)psrsum(12),pssum(4),psrsum(12)/(pssum(4)+eps)
   229: ||        c      write(6,1130)psrsum(13),pssum(4),psrsum(13)/(pssum(4)+eps)
   230: ||        c      write(6,1140)psrsum(14),pssum(4),psrsum(14)/(pssum(4)+eps)
   231: ||        c      write(6,1150)psrsum(15),pssum(4),psrsum(15)/(pssum(4)+eps)
   232: ||        c      write(6,1160)psrsum(16),pssum(4),psrsum(16)/(pssum(4)+eps)
   233: ||        c       if ( mxofl(ity).eq.2 ) then
   234: ||        c        write(6,1050)psrsum(5)
   235: ||        c        write(6,1060)psrsum(6)
   236: ||        c        write(6,1070)psrsum(7)
   237: ||        c        write(6,1080)psrsum(8)
   238: ||        c        write(6,1090)psrsum(9)
   239: ||        c       endif
   240: ||        c      endif
   241: ||              write(6,*)
   242: ||              write(6,*)' overlap with atomic wavefunction  !!'
   243: ||              write(6,2010)covl(1)/pssum(1)
   244: ||              endif
   245: ||              if ( numty(ity).lt.0 ) then
   246: ||              if (my_rank.eq.0) then
   247: ||              write(6,2020)covl(2)
   248: ||              write(6,2030)covl(3)
   249: ||              write(6,2040)covl(4)
   250: ||              endif
   251: ||              else
   252: ||              if (my_rank.eq.0) then
   253: ||              write(6,2020)covl(2)/(pssum(2)+eps)
   254: ||              write(6,2030)covl(3)/(pssum(2)+eps)
   255: ||              write(6,2040)covl(4)/(pssum(2)+eps)
   256: ||              endif
   257: ||              endif
   258: ||              if (lmax.ge.3 ) then
   259: ||              if (my_rank.eq.0) then
   260: ||              write(6,2050)covl(5)/(pssum(3)+eps)
   261: ||              write(6,2060)covl(6)/(pssum(3)+eps)
   262: ||              write(6,2070)covl(7)/(pssum(3)+eps)
   263: ||              write(6,2080)covl(8)/(pssum(3)+eps)
   264: ||              write(6,2090)covl(9)/(pssum(3)+eps)
   265: ||              endif
   266: ||              endif
   267: ||              if (lmax.eq.4 ) then
   268: ||              if (my_rank.eq.0) then
   269: ||              write(6,2100)covl(10)/(pssum(4)+eps)
   270: ||              write(6,2110)covl(11)/(pssum(4)+eps)
   271: ||              write(6,2120)covl(12)/(pssum(4)+eps)
   272: ||              write(6,2130)covl(13)/(pssum(4)+eps)
   273: ||              write(6,2140)covl(14)/(pssum(4)+eps)
   274: ||              write(6,2150)covl(15)/(pssum(4)+eps)
   275: ||              write(6,2160)covl(16)/(pssum(4)+eps)
   276: ||              endif
   277: ||              endif
   278: ||        ccc
   279: ||              endif  ! if itseq branch: end
   280: |+-----       3 continue
   281: +------       1 continue
   282:            9000 format(' Position(Cartesian)'
   283:                &      ,'--- x ---   --- y ---   --- z ---   (a.u.)')
   284:            1000 format(20x,3f12.6)
   285:           c 1010 format(' for  s-orbital ',3f12.6)
   286:           c 1020 format(' for Px-orbital ',3f12.6)
   287:           c 1030 format(' for Py-orbital ',3f12.6)
   288:           c 1040 format(' for Pz-orbital ',3f12.6)
   289:           c 1050 format(' for D3*z^2-1 orbital ',3f12.6)
   290:           c 1060 format(' for Dx^2-y^2 orbital ',3f12.6)
   291:           c 1070 format(' for Dxy    - orbital ',3f12.6)
   292:           c 1080 format(' for Dyz    - orbital ',3f12.6)
   293:           c 1090 format(' for Dzx    - orbital ',3f12.6)
   294:           c 1100 format(' for Fz^3         - orbital ',3f12.6)
   295:           c 1110 format(' for Fx*(x^2-3y^2)- orbital ',3f12.6)
   296:           c 1120 format(' for Fy*(3x^2-y^2)- orbital ',3f12.6)
   297:           c 1130 format(' for Fz*( x^2-y^2)- orbital ',3f12.6)
   298:           c 1140 format(' for Fx*y*z       - orbital ',3f12.6)
   299:           c 1150 format(' for Fx*(5z^2-r^2)- orbital ',3f12.6)
   300:           c 1160 format(' for Fy*(5z^2-r^2)- orbital ',3f12.6)
   301:            2010 format(' for  s-orbital ','Re:',f12.6,'    Im',f12.6)
   302:            2020 format(' for Px-orbital ','Re:',f12.6,'    Im',f12.6)
   303:            2030 format(' for Py-orbital ','Re:',f12.6,'    Im',f12.6)
   304:            2040 format(' for Pz-orbital ','Re:',f12.6,'    Im',f12.6)
   305:            2050 format(' for D3*z^2-1 orbital '
   306:                &  ,'Re:',f12.6,'    Im',f12.6)
   307:            2060 format(' for Dx^2-y^2 orbital '
   308:                &  ,'Re:',f12.6,'    Im',f12.6)
   309:            2070 format(' for Dxy    - orbital '
   310:                &  ,'Re:',f12.6,'    Im',f12.6)
   311:            2080 format(' for Dyz    - orbital '
   312:                &  ,'Re:',f12.6,'    Im',f12.6)
   313:            2090 format(' for Dzx    - orbital '
   314:                &  ,'Re:',f12.6,'    Im',f12.6)
   315:            2100 format(' for Fz^3         - orbital '
   316:                &  ,'Re:',f12.6,'    Im',f12.6)
   317:            2110 format(' for Fx*(x^2-3y^2)- orbital '
   318:                &  ,'Re:',f12.6,'    Im',f12.6)
   319:            2120 format(' for Fy*(3x^2-y^2)- orbital '
   320:                &  ,'Re:',f12.6,'    Im',f12.6)
   321:            2130 format(' for Fz*( x^2-y^2)- orbital '
   322:                &  ,'Re:',f12.6,'    Im',f12.6)
   323:            2140 format(' for Fx*y*z       - orbital '
   324:                &  ,'Re:',f12.6,'    Im',f12.6)
   325:            2150 format(' for Fx*(5z^2-r^2)- orbital '
   326:                &  ,'Re:',f12.6,'    Im',f12.6)
   327:            2160 format(' for Fy*(5z^2-r^2)- orbital '
   328:                &  ,'Re:',f12.6,'    Im',f12.6)
   329:                 return
   330:                 end


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:34 2022
FILE NAME: orbanly_part_f.f

PROCEDURE NAME: PSIRGEN
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   332:                 subroutine psirgen(tau,rho1,rho2,ccc,g2,ng2q,ng2,
   333:                &           rad,meshq,mesh,psrsum,H,rc,tpiba,omega
   334:           c *** added !!
   335:                &          ,phil,covl,mxofl )
   336:                 implicit double precision (a-h,o-z)
   337:           c      dimension tau(3),g2(4,ng2q),rad(meshq),psrsum(9)
   338:                 dimension tau(3),g2(4,ng2q),rad(meshq),psrsum(16)
   339:           c     &         ,rho1(ng2q),rho2(ng2q),rc(2)
   340:                &         ,rho1(ng2q),rho2(ng2q),rc(4)
   341:           c      dimension phil(meshq,2)
   342:                 dimension phil(meshq,4)
   343:                 complex*16 crpsi1,crpsi2,crpsi3,crpsi4,ccc(ng2q)
   344:                 complex*16 crpsi5,crpsi6,crpsi7,crpsi8,crpsi9
   345:                & ,crpsi10,crpsi11,crpsi12,crpsi13,crpsi14,crpsi15,crpsi16
   346:           c      complex*16 covl(4),cone
   347:                 complex*16 covl(16),cone
   348:                 data eps/1.d-08/
   349:                 cone=dcmplx( 0.d0, 1.d0 )
   350:           c **** temp check
   351:           c      write(6,*)'  *****  in sub. psirgen  ****** '
   352:           c      write(6,*)' check norm of the Bloch wave function '
   353:           c      wnorm=0
   354:           c      do 99 ig=1,ng2
   355:           c   99 wnorm=wnorm+rho1(ig)**2+rho2(ig)**2
   356:           c      wnorm=dsqrt(wnorm)
   357:           c      if ( abs(wnorm-1.d0).gt.1.d-08 ) then
   358:           c      write(6,*)' WARNING!!! wrong norm of the wavefunction !!! '
   359:           c      write(6,*)' norm = ',wnorm
   360:           c      end if
   361:           c **** temp check end
   362:           c ***  temp check
   363:           c      write(6,*)' check phil in sub. psirgen '
   364:           c      ssum=0
   365:           c      psum=0
   366:           c      do ir=1,mesh
   367:           c      ssum=ssum+rad(ir)*H*phil(ir,1)*phil(ir,1)
   368:           c      psum=psum+rad(ir)*H*phil(ir,2)*phil(ir,2)
   369:           c      enddo
   370:           c      write(6,*)' Norm of s-orbital ',ssum
   371:           c      write(6,*)' Norm of p-orbital ',psum
   372:           c ***  temp check end
   373:                 fpi=4*dacos(-1.d0)
   374:                 sfac=1.d0/fpi/omega
   375:           c      pfac=3.d0*fpi/omega
   376:                 pfac=3.d0/fpi/omega
   377:                 d5fac=5.d0/(4*fpi)/omega
   378:                 d6fac=15.d0/(4*fpi)/omega
   379:                 d7fac=15.d0/fpi/omega
   380:                 d8fac=15.d0/fpi/omega
   381:                 d9fac=15.d0/fpi/omega
   382:                 f30=7.d0/(4*fpi)/omega
   383:                 f31=21.d0/(16*fpi)/omega
   384:                 f32=105.d0/(8*fpi)/omega
   385:                 f33=35.d0/(16*fpi)/omega
   386:                 f10fac=f30
   387:                 f11fac=f33
   388:                 f12fac=f33
   389:                 f13fac=f32
   390:                 f14fac=f32
   391:                 f15fac=f31
   392:                 f16fac=f31
   393:           c      sfac=1.d0
   394:           c      pfac=3.d0
   395:           c ****  temp check
   396:           c      write(6,*)
   397:           c      write(6,*)' in sub. psirgen  rc = ',rc
   398:           c      write(6,*)'      irmax = ',irmax
   399:           c      write(6,*)' tpiba = ',tpiba
   400:           c ****  temp check end
   401: V------>        do 100 ig=1,ng2
   402: |       F       gt=g2(1,ig)*tau(1)+g2(2,ig)*tau(2)+g2(3,ig)*tau(3)
   403: |               gt=tpiba*gt
   404: |       F       ccc(ig)=dcmplx(dcos(gt),dsin(gt))
   405: |              &       *dcmplx(rho1(ig),rho2(ig))
   406: V------     100 continue
   407:                 if ( g2(4,1).lt.eps ) then
   408:                 ngmin=2
   409:                 else
   410:                 ngmin=1
   411:                 end if
   412:           c      write(6,*)' in sub. psirgen : ngmin = ',ngmin
   413:           c ******  Start the radial integral uo tp r=rc
   414:                 H2=log( rad(mesh)/rad(1) )/dfloat(mesh-1)
   415:                 if ( abs(H2-H).gt.1.d-08 ) then
   416:                 write(6,*)' something wrong in H - Stopping !!'
   417:                 stop
   418:                 end if
   419:                 lmax=mxofl
   420: +------>        do 299 l=1,lmax
   421: |V----->        do 200 ir=1,mesh
   422: ||              if ( rad(ir).gt.rc(l) ) then
   423: ||              irmax=ir-1
   424: ||              goto 220
   425: ||              end if
   426: |V-----     200 continue
   427: |           220 continue
   428: |               if ( l.eq.1 ) irmax1=irmax
   429: |               if ( l.eq.2 ) irmax2=irmax
   430: |               if ( l.eq.3 ) irmax3=irmax
   431: |               if ( l.eq.4 ) irmax4=irmax
   432: |         c *** temp check:
   433: |         c      write(6,*)' in sub. psirgen ','l=',l,'irmax=',irmax
   434: |         c *** temp check: end
   435: +------     299 continue
   436:           c ***** S-component
   437:                 psrsum(1)=0
   438:                 covl(1)=dcmplx(0.d0,0.d0)
   439: +------>        do 1 ir=1,irmax1
   440: |               if ( g2(4,1).lt.eps ) then
   441: |               crpsi1=ccc(1)*rad(ir)
   442: |               else
   443: |               crpsi1=0
   444: |               end if
   445: |               rrr=rad(ir)
   446: |         c *** do 10:  from G-space to r-space
   447: |V----->        do 10 ig=ngmin,ng2
   448: ||              gr=g2(4,ig)*tpiba*rrr
   449: ||      F       crpsi1=crpsi1+ccc(ig)*dsin(gr)/gr*rrr
   450: |V-----      10 continue
   451: |               psrsum(1)=psrsum(1)+H*dconjg(crpsi1)*crpsi1/rrr
   452: |               covl(1)=covl(1)+H*phil(ir,1)*crpsi1
   453: +------       1 continue
   454:                 psrsum(1)=sfac*psrsum(1)
   455:                 covl(1)=dsqrt(sfac)*covl(1)
   456:           c ***** P-components
   457:                 psrsum(2)=0
   458:                 psrsum(3)=0
   459:                 psrsum(4)=0
   460:                 covl(2)=dcmplx(0.d0,0.d0)
   461:                 covl(3)=dcmplx(0.d0,0.d0)
   462:                 covl(4)=dcmplx(0.d0,0.d0)
   463: +------>        do 2 ir=1,irmax2
   464: |               crpsi2=0
   465: |               crpsi3=0
   466: |               crpsi4=0
   467: |               rrr=rad(ir)
   468: |         c *** do 20:  from G-space to r-space
   469: |V----->        do 20 ig=ngmin,ng2
   470: ||              gr=g2(4,ig)*tpiba*rrr
   471: ||      F       rj1=(dsin(gr)-gr*dcos(gr) )/(gr*gr)*rrr
   472: ||      F       crpsi2=crpsi2+ccc(ig)*rj1*g2(1,ig)/g2(4,ig)
   473: ||      F       crpsi3=crpsi3+ccc(ig)*rj1*g2(2,ig)/g2(4,ig)
   474: ||      F       crpsi4=crpsi4+ccc(ig)*rj1*g2(3,ig)/g2(4,ig)
   475: |V-----      20 continue
   476: |               psrsum(2)=psrsum(2)+H*dconjg(crpsi2)*crpsi2/rrr
   477: |               psrsum(3)=psrsum(3)+H*dconjg(crpsi3)*crpsi3/rrr
   478: |               psrsum(4)=psrsum(4)+H*dconjg(crpsi4)*crpsi4/rrr
   479: |               covl(2)=covl(2)+H*phil(ir,2)*crpsi2
   480: |               covl(3)=covl(3)+H*phil(ir,2)*crpsi3
   481: |               covl(4)=covl(4)+H*phil(ir,2)*crpsi4
   482: +------       2 continue
   483:                 psrsum(2)=pfac*psrsum(2)
   484:                 psrsum(3)=pfac*psrsum(3)
   485:                 psrsum(4)=pfac*psrsum(4)
   486:                 covl(2)=dsqrt(pfac)*covl(2)
   487:                 covl(3)=dsqrt(pfac)*covl(3)
   488:                 covl(4)=dsqrt(pfac)*covl(4)
   489:                 if (lmax.ge.3 ) then
   490: +------>        do l=3,lmax
   491: |         c ***** D-components
   492: |               psrsum(5)=0
   493: |               psrsum(6)=0
   494: |               psrsum(7)=0
   495: |               psrsum(8)=0
   496: |               psrsum(9)=0
   497: |               covl(5)=dcmplx(0.d0,0.d0)
   498: |               covl(6)=dcmplx(0.d0,0.d0)
   499: |               covl(7)=dcmplx(0.d0,0.d0)
   500: |               covl(8)=dcmplx(0.d0,0.d0)
   501: |               covl(9)=dcmplx(0.d0,0.d0)
   502: |+----->        do 3 ir=1,irmax3
   503: ||              crpsi5=0
   504: ||              crpsi6=0
   505: ||              crpsi7=0
   506: ||              crpsi8=0
   507: ||              crpsi9=0
   508: ||              rrr=rad(ir)
   509: ||        c *** do 30:  from G-space to r-space
   510: ||V---->        do 30 ig=ngmin,ng2
   511: |||             gr=g2(4,ig)*tpiba*rrr
   512: |||             gg2=g2(4,ig)**2
   513: |||             gx=g2(1,ig)
   514: |||             gy=g2(2,ig)
   515: |||             gz=g2(3,ig)
   516: |||     F       rj1=((3.d0-gr*gr)*dsin(gr)-3*gr*dcos(gr) )/(gr*gr*gr)*rrr
   517: |||     F       crpsi5=crpsi5+ccc(ig)*rj1*( 3*gz**2/gg2-1.d0)
   518: |||     F       crpsi6=crpsi6+ccc(ig)*rj1*( gx**2-gy**2 )/gg2
   519: |||     F       crpsi7=crpsi7+ccc(ig)*rj1*( gx*gy )/gg2
   520: |||     F       crpsi8=crpsi8+ccc(ig)*rj1*( gz*gx )/gg2
   521: |||     F       crpsi9=crpsi9+ccc(ig)*rj1*( gy*gz )/gg2
   522: ||V----      30 continue
   523: ||        c **** temp check
   524: ||        c      if ( ir.eq.irmax ) then
   525: ||        c      write(6,*)' Check  Px-orbital  '
   526: ||        c      write(6,1999)rad(irmax),crpsi
   527: ||        c      end if
   528: ||        c **** temp check end
   529: ||              crpsi5=cone*crpsi5
   530: ||              crpsi6=cone*crpsi6
   531: ||              crpsi7=cone*crpsi7
   532: ||              crpsi8=cone*crpsi8
   533: ||              crpsi9=cone*crpsi9
   534: ||              psrsum(5)=psrsum(5)+H*dconjg(crpsi5)*crpsi5/rrr
   535: ||              psrsum(6)=psrsum(6)+H*dconjg(crpsi6)*crpsi6/rrr
   536: ||              psrsum(7)=psrsum(7)+H*dconjg(crpsi7)*crpsi7/rrr
   537: ||              psrsum(8)=psrsum(8)+H*dconjg(crpsi8)*crpsi8/rrr
   538: ||              psrsum(9)=psrsum(9)+H*dconjg(crpsi9)*crpsi9/rrr
   539: ||              phid=phil(ir,l)
   540: ||              covl(5)=covl(5)+H*phid*crpsi5
   541: ||              covl(6)=covl(6)+H*phid*crpsi6
   542: ||              covl(7)=covl(7)+H*phid*crpsi7
   543: ||              covl(8)=covl(8)+H*phid*crpsi8
   544: ||              covl(9)=covl(9)+H*phid*crpsi9
   545: |+-----       3 continue
   546: |               psrsum(5)=d5fac*psrsum(5)
   547: |               psrsum(6)=d6fac*psrsum(6)
   548: |               psrsum(7)=d7fac*psrsum(7)
   549: |               psrsum(8)=d8fac*psrsum(8)
   550: |               psrsum(9)=d9fac*psrsum(9)
   551: |               covl(5)=dsqrt(d5fac)*covl(5)
   552: |               covl(6)=dsqrt(d6fac)*covl(6)
   553: |               covl(7)=dsqrt(d7fac)*covl(7)
   554: |               covl(8)=dsqrt(d8fac)*covl(8)
   555: |               covl(9)=dsqrt(d9fac)*covl(9)
   556: |         c ***** F-components
   557: |               if (lmax.eq.4) then
   558: |               psrsum(10)=0
   559: |               psrsum(11)=0
   560: |               psrsum(12)=0
   561: |               psrsum(13)=0
   562: |               psrsum(14)=0
   563: |               psrsum(15)=0
   564: |               psrsum(16)=0
   565: |               covl(10)=dcmplx(0.d0,0.d0)
   566: |               covl(11)=dcmplx(0.d0,0.d0)
   567: |               covl(12)=dcmplx(0.d0,0.d0)
   568: |               covl(13)=dcmplx(0.d0,0.d0)
   569: |               covl(14)=dcmplx(0.d0,0.d0)
   570: |               covl(15)=dcmplx(0.d0,0.d0)
   571: |               covl(16)=dcmplx(0.d0,0.d0)
   572: |+----->        do 4 ir=1,irmax4
   573: ||              crpsi10=0
   574: ||              crpsi11=0
   575: ||              crpsi12=0
   576: ||              crpsi13=0
   577: ||              crpsi14=0
   578: ||              crpsi15=0
   579: ||              crpsi16=0
   580: ||              rrr=rad(ir)
   581: ||        c *** do 40:  from G-space to r-space
   582: ||V---->        do 40 ig=ngmin,ng2
   583: |||             gr=g2(4,ig)*tpiba*rrr
   584: |||             gg2=g2(4,ig)**2
   585: |||             gg3=gg2*g2(4,ig)
   586: |||     F       rj1=( (15.d0-6*gr*gr)*dsin(gr)+gr*(gr*gr-15.d0)*dcos(gr) )
   587: |||            &   /(gr*gr*gr*gr)*rrr
   588: |||             gx=g2(1,ig)
   589: |||             gy=g2(2,ig)
   590: |||             gz=g2(3,ig)
   591: |||     F       crpsi10=crpsi10+ccc(ig)*rj1*(5*gz**2/gg2-3.d0)*gz/g2(4,ig)
   592: |||     F       crpsi11=crpsi11+ccc(ig)*rj1*gx*(gx**2-3*gy**2)/gg3
   593: |||     F       crpsi12=crpsi12+ccc(ig)*rj1*gy*(3*gx**2-gy**2)/gg3
   594: |||     F       crpsi13=crpsi13+ccc(ig)*rj1*gz*(  gx**2-gy**2)/gg3
   595: |||     F       crpsi14=crpsi14+ccc(ig)*rj1*gx*gy*gz/gg3
   596: |||     F       crpsi15=crpsi15+ccc(ig)*rj1*gx*(5*gz**2-gg2)/gg3
   597: |||     F       crpsi16=crpsi16+ccc(ig)*rj1*gy*(5*gz**2-gg2)/gg3
   598: ||V----      40 continue
   599: ||        c **** temp check
   600: ||        c      if ( ir.eq.irmax ) then
   601: ||        c      write(6,*)' Check  Px-orbital  '
   602: ||        c      write(6,1999)rad(irmax),crpsi
   603: ||        c      end if
   604: ||        c **** temp check end
   605: ||              crpsi10=cone*crpsi10
   606: ||              crpsi11=cone*crpsi11
   607: ||              crpsi12=cone*crpsi12
   608: ||              crpsi13=cone*crpsi13
   609: ||              crpsi14=cone*crpsi14
   610: ||              crpsi15=cone*crpsi15
   611: ||              crpsi16=cone*crpsi16
   612: ||        c *** temp check
   613: ||        c      if (ir.eq.1 ) then
   614: ||        c       write(6,*)' ngmin = ',ngmin
   615: ||        c       write(6,*)' check crpsi10-16 at ir=',ir
   616: ||        c       write(6,*)' crpsi10 =',crpsi10
   617: ||        c       write(6,*)' crpsi11 =',crpsi11
   618: ||        c       write(6,*)' crpsi12 =',crpsi12
   619: ||        c       write(6,*)' crpsi13 =',crpsi13
   620: ||        c       write(6,*)' crpsi14 =',crpsi14
   621: ||        c       write(6,*)' crpsi15 =',crpsi15
   622: ||        c       write(6,*)' crpsi16 =',crpsi16
   623: ||        c      endif
   624: ||        c *** temp check: end
   625: ||              psrsum(10)=psrsum(10)+H*dconjg(crpsi10)*crpsi10/rrr
   626: ||              psrsum(11)=psrsum(11)+H*dconjg(crpsi11)*crpsi11/rrr
   627: ||              psrsum(12)=psrsum(12)+H*dconjg(crpsi12)*crpsi12/rrr
   628: ||              psrsum(13)=psrsum(13)+H*dconjg(crpsi13)*crpsi13/rrr
   629: ||              psrsum(14)=psrsum(14)+H*dconjg(crpsi14)*crpsi14/rrr
   630: ||              psrsum(15)=psrsum(15)+H*dconjg(crpsi15)*crpsi15/rrr
   631: ||              psrsum(16)=psrsum(16)+H*dconjg(crpsi16)*crpsi16/rrr
   632: ||              phif=phil(ir,l)
   633: ||              covl(10)=covl(10)+H*phif*crpsi10
   634: ||              covl(11)=covl(11)+H*phif*crpsi11
   635: ||              covl(12)=covl(12)+H*phif*crpsi12
   636: ||              covl(13)=covl(13)+H*phif*crpsi13
   637: ||              covl(14)=covl(14)+H*phif*crpsi14
   638: ||              covl(15)=covl(15)+H*phif*crpsi15
   639: ||              covl(16)=covl(16)+H*phif*crpsi16
   640: |+-----       4 continue
   641: |               psrsum(10)=f10fac*psrsum(10)
   642: |               psrsum(11)=f11fac*psrsum(11)
   643: |               psrsum(12)=f12fac*psrsum(12)
   644: |               psrsum(13)=f13fac*psrsum(13)
   645: |               psrsum(14)=f14fac*psrsum(14)
   646: |               psrsum(15)=f15fac*psrsum(15)
   647: |               psrsum(16)=f16fac*psrsum(16)
   648: |               covl(10)=dsqrt(f10fac)*covl(10)
   649: |               covl(11)=dsqrt(f11fac)*covl(11)
   650: |               covl(12)=dsqrt(f12fac)*covl(12)
   651: |               covl(13)=dsqrt(f13fac)*covl(13)
   652: |               covl(14)=dsqrt(f14fac)*covl(14)
   653: |               covl(15)=dsqrt(f15fac)*covl(15)
   654: |               covl(16)=dsqrt(f16fac)*covl(16)
   655: |         c
   656: |               endif  ! if imax.eq.4 branch: end
   657: |         co
   658: +------         enddo  ! l=3,lmax loop: end
   659:           c
   660:                 endif  ! if lmax.ge.3 branch: end
   661:           c
   662:           c 1999 format(' r=',f10.6,' psir= ',2d14.6)
   663:           c ***  temp check
   664:           c      write(6,*)' psrsum   in sub. psirgen '
   665:           c      write(6,1998)(psrsum(il),il=1,4)
   666:           c 1998 format(' s  =',d14.6/'Px =',d14.6
   667:           c     &      /'Py  =',d14.6/'Pz =',d14.6 )
   668:           c ***  temp check end
   669:           c
   670:           c      if ( mxofl.eq.2 ) then
   671:           cc  **  for D-components
   672:           c      psrsum(5)=0
   673:           c      psrsum(6)=0
   674:           c      psrsum(7)=0
   675:           c      psrsum(8)=0
   676:           c      psrsum(9)=0
   677:           c      do 4 ir=1,irmax2
   678:           c      crpsi5=0
   679:           c      crpsi6=0
   680:           c      crpsi7=0
   681:           c      crpsi8=0
   682:           c      crpsi9=0
   683:           c      rrr=rad(ir)
   684:           cc *** do 40:  from G-space to r-space
   685:           c      do 40 ig=ngmin,ng2
   686:           c      gr=g2(4,ig)*tpiba*rrr
   687:           c      rj2=( (3.d0-gr*gr)*dsin(gr)-3*gr*dcos(gr) )
   688:           c     &   /(gr*gr*gr)*rrr
   689:           c      x=g2(1,ig)/g2(4,ig)
   690:           c      y=g2(2,ig)/g2(4,ig)
   691:           c      z=g2(3,ig)/g2(4,ig)
   692:           c      crpsi5=crpsi5+ccc(ig)*rj2*( 3*z*z-1.d0 )
   693:           c      crpsi6=crpsi6+ccc(ig)*rj2*(x*x-y*y)
   694:           c      crpsi7=crpsi7+ccc(ig)*rj2*x*y
   695:           c      crpsi8=crpsi8+ccc(ig)*rj2*y*z
   696:           c      crpsi9=crpsi9+ccc(ig)*rj2*z*x
   697:           c   40 continue
   698:           c      psrsum(5)=psrsum(5)+rrr*H*dconjg(crpsi5)*crpsi5
   699:           c      psrsum(6)=psrsum(6)+rrr*H*dconjg(crpsi6)*crpsi6
   700:           c      psrsum(7)=psrsum(7)+rrr*H*dconjg(crpsi7)*crpsi7
   701:           c      psrsum(8)=psrsum(8)+rrr*H*dconjg(crpsi8)*crpsi8
   702:           c      psrsum(9)=psrsum(9)+rrr*H*dconjg(crpsi9)*crpsi9
   703:           c    4 continue
   704:           c      psrsum(5)=d5fac*psrsum(5)
   705:           c      psrsum(6)=d6fac*psrsum(6)
   706:           c      psrsum(7)=d7fac*psrsum(7)
   707:           c      psrsum(8)=d8fac*psrsum(8)
   708:           c      psrsum(9)=d9fac*psrsum(9)
   709:           c      endif
   710:                 return
   711:                 end


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:34 2022
FILE NAME: orbanly_part_f.f

PROCEDURE NAME: NORMINT
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   713:                 subroutine normint(my_rank,rc,rad,work,mesh,meshq,sum2,l,H,zo)
   714:                 implicit double precision (a-h,o-z)
   715:                 dimension rad(meshq),work(meshq)
   716:                 sum=rint(rad,work,mesh,H)
   717:                 if ( l.eq.1 .and. my_rank.eq.0) write(6,1000)sum
   718:                 if ( l.eq.2 .and. my_rank.eq.0) write(6,2000)sum
   719:                 if ( l.eq.3 .and. my_rank.eq.0) write(6,3000)sum
   720:                 if ( l.eq.4 .and. my_rank.eq.0) write(6,4000)sum
   721:                 sum2=rcint(rc,rad,work,mesh,H)
   722:                 if (l.eq.1 .and. my_rank.eq.0) write(6,1100)sum2,rc
   723:                 if (l.eq.2 .and. my_rank.eq.0) write(6,1200)sum2,rc
   724:                 if (l.eq.3 .and. my_rank.eq.0) write(6,1300)sum2,rc
   725:                 if (l.eq.4 .and. my_rank.eq.0) write(6,1400)sum2,rc
   726:            1000 format(' norm of s-orbital = ',d16.8)
   727:            2000 format(' norm of p-orbital = ',d16.8)
   728:            3000 format(' norm of d-orbital = ',d16.8)
   729:            4000 format(' norm of f-orbital = ',d16.8)
   730:            1100 format(' norm of s-orbital = ',d16.8,' up to r=',d16.8)
   731:            1200 format(' norm of p-orbital = ',d16.8,' up to r=',d16.8)
   732:            1300 format(' norm of d-orbital = ',d16.8,' up to r=',d16.8)
   733:            1400 format(' norm of f-orbital = ',d16.8,' up to r=',d16.8)
   734:           c  ***** normalized by spin
   735:                 if ( l.eq.1 ) then
   736:                 sum2=sum2*zo/2.d0
   737:                 elseif ( l.eq.2 ) then
   738:                 sum2=sum2*zo/2.d0/3.d0
   739:                 end if
   740:                 return
   741:                 end


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:34 2022
FILE NAME: orbanly_part_f.f

PROCEDURE NAME: RINT
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   743:                 function rint(x,y,n,H)
   744:                 implicit double precision (a-h,o-z)
   745:                 dimension x(n),y(n)
   746:                 H=DLOG(X(N)/X(1))/dfloat(N-1)
   747:                 rint=0
   748: V------>        do 1 i=1,n
   749: V------ F     1 rint=rint+x(i)*H*y(i)
   750:                 RETURN
   751:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:34 2022
FILE NAME: orbanly_part_f.f

PROCEDURE NAME: RCINT
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   753:                 FUNCTION RCINT(rc,X,Y,N,H)
   754:                 IMPLICIT REAL*8(A-H,O-Z)
   755:                 DIMENSION  X(N),Y(N)
   756:                 H=DLOG(X(N)/X(1))/dfloat(N-1)
   757: V------>        do 1 i=1,n
   758: |               if ( x(i).gt.rc ) then
   759: |               irmax=i-1
   760: |               goto 2
   761: |               end if
   762: V------       1 continue
   763:               2 continue
   764:                 rcint=0
   765: V------>        do 10 i=1,irmax
   766: V------ F    10 rcint=rcint+x(i)*H*y(i)
   767:                 RETURN
   768:                 END


