NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:23 2022
FILE NAME: cpu_block.f

PROCEDURE NAME: CPU_BLOCK
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     1:           	subroutine cpu_block(nband,ncpu,nbegin,nend,ncpuq)
     2:           	implicit double precision(a-h,o-z)
     3:                   include 'mpif.h'
     4:           	dimension nbegin(0:ncpuq),nend(0:ncpuq)
     5:                   call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
     6:           	nrest=mod(nband,ncpu+1)
     7:           	if ( my_rank.eq.0 ) write(6,*)' nrest = ',nrest
     8:           	if ( nrest.eq.0 ) then
     9:           	 nband_cpu=nband/(ncpu+1)
    10: V------>  	 do icpu=0,ncpu
    11: |         	  nbegin(icpu)=nband_cpu*(icpu) + 1
    12: |         	  nend(icpu)=nbegin(icpu)+nband_cpu-1
    13: V------   	 enddo
    14:           	else
    15:           	 nband_cpu=int( dfloat(nband)/dfloat(ncpu+1) )
    16: V------>  	 do icpu=0,nrest-1
    17: |         	  nbegin(icpu)=(nband_cpu+1)*icpu + 1
    18: |         	  nend(icpu)=nbegin(icpu)+nband_cpu
    19: V------   	 enddo
    20:           	 nblock0=(nband_cpu+1)*nrest+1
    21: V------>  	 do icpu=nrest,ncpu
    22: |         	  nbegin(icpu)=nband_cpu*(icpu-nrest)+nblock0
    23: |         	  nend(icpu)=nbegin(icpu)+nband_cpu-1
    24: V------   	 enddo
    25:           	endif
    26:                   if (my_rank.eq.0 ) then
    27: +------>           do icpu=0,ncpu
    28: |                   write(6,*)' nbegin(',icpu,')=',nbegin(icpu),
    29: |              &    '   nend(',icpu,')=',nend(icpu)
    30: +------            enddo
    31:                   endif
    32:           	return
    33:           	end


