NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:28 2022
FILE NAME: dipole.f

PROCEDURE NAME: DIPOLE
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     2:                 subroutine dipole(rho,nxyz,nrx,nry,nrz,alat,a1,a2,a3,omega,time)
     3:                 implicit double precision (a-h,o-z)
     4:                 dimension rho(nxyz),a1(3),a2(3),a3(3)
     5:                 az=alat*a3(3)
     6:                 dz=az/dfloat(nrz)
     7:                 ay=alat*a2(2)
     8:                 dy=ay/dfloat(nry)
     9:                 ax=alat*a1(1)
    10:                 dx=ax/dfloat(nrx)
    11:                 sumx=0
    12:                 sumy=0
    13:                 sumz=0
    14:                 nzhlf=(nrz+1)/2
    15:                 nyhlf=(nry+1)/2
    16:                 nxhlf=(nrx+1)/2
    17: V------>        do ii=1,nxyz
    18: |                K=1+(II-1)/(NRX*NRY)
    19: |                I=II-(K-1)*NRX*NRY
    20: |                J=1+(I-1)/NRX
    21: |                I=I-(J-1)*NRX
    22: |                LX=I
    23: |                LY=J
    24: |                LZ=K
    25: |                if ( lz.le.nzhlf ) then
    26: |                 z=dz*(lz-1)
    27: |                else
    28: |                 z=-dz*(nrz-lz+1)
    29: |                endif
    30: |                sumz=sumz+z*rho(ii)
    31: |                if ( ly.le.nyhlf ) then
    32: |                 y=dy*(ly-1)
    33: |                else
    34: |                 y=-dy*(nry-ly+1)
    35: |                endif
    36: |                sumy=sumy+y*rho(ii)
    37: |                if ( lx.le.nxhlf ) then
    38: |                 x=dx*(lx-1)
    39: |                else
    40: |                 x=-dx*(nrx-lx+1)
    41: |                endif
    42: |                sumx=sumx+x*rho(ii)
    43: V------         enddo
    44:                 sumx=sumx*omega/dfloat(nxyz)
    45:                 sumy=sumy*omega/dfloat(nxyz)
    46:                 sumz=sumz*omega/dfloat(nxyz)
    47:                 write(91,1000)time,sumx,sumy,sumz
    48:            1000 format(4f22.16)
    49:                 return
    50:                 end


