NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:36 2022
FILE NAME: gga_lib_3_PBE.f

PROCEDURE NAME: G2VXC2
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     3:                  SUBROUTINE G2VXC2(TPIBA,NRX,NRY,NRZ,NXYZ,NG,NGQ,G,
     4:                & VCSR,RHO,RHOG,I2G,
     5:           c ++ for Sugino FFT
     6:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,
     7:           c     & LY1,LY2,LZ1,LZ2,
     8:           c ++ for Kokubo ASL FFT
     9:           c     & WSAVE_XYZ,IFAC_XYZ,
    10:           c ++ for Kokubo FFTW
    11:                & plancfp,plancbp,
    12:                &  DRX,DRY,DRZ,DRXX,DRYY,DRZZ,DRXY,DRYZ,DRZX,VWORK  )
    13:                 IMPLICIT REAL*8(A-H,O-Z)
    14:                 REAL*8 RHO(NXYZ)
    15:                 COMPLEX*16 VCSR(NXYZ),RHOG(NXYZ)
    16:           c *** for Sugino FFT
    17:           c      COMPLEX*16 WSAVEX(NRX),WSAVEY(NRY),WSAVEZ(NRZ)
    18:           c      DIMENSION IFACX(30),IFACY(30),IFACZ(30)
    19:           c      DIMENSION LX1(NXYZ),LX2(NXYZ),LY1(NXYZ),
    20:           c     &          LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
    21:           c *** for Kokubo ASL FFT
    22:           c      COMPLEX*16 WSAVE_XYZ(NRX+NRY+NRZ)
    23:           c      DIMENSION IFAC_XYZ(60)
    24:           c *** for Kokubo FFTW
    25:                 integer*8 plancfp,plancbp
    26:                 DIMENSION I2G(NGQ),G(4,NGQ)
    27:           c      COMMON/GAS/FK,SK,GPOL,ECLOC,ECRS,ECZET
    28:           C ---  for GGA
    29:                 COMPLEX*16 DRX(NXYZ) ,DRY(NXYZ) ,DRZ(NXYZ)
    30:                 COMPLEX*16 DRXX(NXYZ),DRYY(NXYZ),DRZZ(NXYZ)
    31:                 COMPLEX*16 DRXY(NXYZ),DRYZ(NXYZ),DRZX(NXYZ)
    32:                 COMPLEX*16 VWORK(NXYZ)
    33:           C **** for check
    34:           c      call clock(t0)
    35:           c **** check end
    36:           c
    37:                 PI = 4.D0*DATAN(1.D0)
    38:                 THRD2 = 2.0D0/3.0D0
    39:                 TPIBA2 = TPIBA*TPIBA
    40:           c ***  max of RHO
    41:           c      gmax=-1000.d0
    42:           c      do ig=1,nxyz
    43:           c      if ( rho(ig).gt.0 ) then
    44:           c       gmax=max(rho(ig),gmax)
    45:           c      endif
    46:           c      enddo
    47:           c      gdiv=gmax/100.d0
    48:           cc      GMIN=gdiv/256.d0    ! take more than 0.00390625% of max of rho.
    49:           c      GMIN=gdiv/1000.d0    ! take more than 0.00390625% of max of rho.
    50:           c      write(6,*)' GMIN = ',GMIN
    51:           c ***  min of RHO
    52:           c      GMIN=1.d+20
    53:           c      do ig=1,nxyz
    54:           c      if ( rho(ig).gt.0 ) then
    55:           c       GMIN=min(rho(ig),GMIN)
    56:           c      endif
    57:           c      enddo
    58:           c ***
    59:                 GMIN=1.0D-15
    60:           C
    61:           c ++ temp check
    62:           c       sum=0
    63:           c       do ig=1,NXYZ
    64:           c       sum=sum+rho(ig)
    65:           c       enddo
    66:           c       write(6,*)' In sub. G2VXC2: sum = ',sum
    67:           c       miya=13
    68:           c       if (miya.eq.13 ) stop
    69:           c ** check end
    70:           C
    71: V------>         DO JG = 1, NXYZ
    72: |                 DRX(JG)  = (0.0D0,0.0D0)
    73: |                 DRY(JG)  = (0.0D0,0.0D0)
    74: |                 DRZ(JG)  = (0.0D0,0.0D0)
    75: |                 DRXX(JG) = (0.0D0,0.0D0)
    76: |                 DRYY(JG) = (0.0D0,0.0D0)
    77: |                 DRZZ(JG) = (0.0D0,0.0D0)
    78: |                 DRXY(JG) = (0.0D0,0.0D0)
    79: |                 DRYZ(JG) = (0.0D0,0.0D0)
    80: |                 DRZX(JG) = (0.0D0,0.0D0)
    81: V------          END DO
    82:           C
    83: V------>         DO IG = 2, NG
    84: |                 JG = I2G(IG)
    85: |       C         DRX(JG)  = TPIBA*(0,1)*G(1,IG)*RHOG(JG)
    86: |       C         DRY(JG)  = TPIBA*(0,1)*G(2,IG)*RHOG(JG)
    87: |       C         DRZ(JG)  = TPIBA*(0,1)*G(3,IG)*RHOG(JG)
    88: |       C         DRXX(JG) =  - TPIBA2*G(1,IG)*G(1,IG)*RHOG(JG)
    89: |       C         DRYY(JG) =  - TPIBA2*G(2,IG)*G(2,IG)*RHOG(JG)
    90: |       C         DRZZ(JG) =  - TPIBA2*G(3,IG)*G(3,IG)*RHOG(JG)
    91: |       C         DRXY(JG) =  - TPIBA2*G(1,IG)*G(2,IG)*RHOG(JG)
    92: |       C         DRYZ(JG) =  - TPIBA2*G(2,IG)*G(3,IG)*RHOG(JG)
    93: |       C         DRZX(JG) =  - TPIBA2*G(3,IG)*G(1,IG)*RHOG(JG)
    94: V------          END DO
    95:           C
    96:           C --- TRANSFORM TO R-SPACE ----
    97:           c *** for Sugino FFT
    98:           c        CALL FFT3BX( NRX, NRY, NRZ, NXYZ, DRX, VWORK,
    99:           c     &              WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   100:           c     &              LX1, LX2, LY1, LY2, LZ1, LZ2                 )
   101:           c *** for Kokubo ASL FFT
   102:           c        CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, DRX, VWORK,
   103:           c     &              WSAVE_XYZ, IFAC_XYZ                )
   104:           c *** for Kokubo FFTW
   105:           c       call FFT3BX_fftw(NXYZ,DRX,plancfp,plancbp)
   106:           c *** for Kokubo fftw ASL compatible
   107:                   CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, DRX, VWORK,
   108:                &              plancfp,plancbp               )
   109:           C
   110:           c *** for Sugino FFT
   111:           c        CALL FFT3BX( NRX, NRY, NRZ, NXYZ, DRY, VWORK,
   112:           c     &              WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   113:           c     &              LX1, LX2, LY1, LY2, LZ1, LZ2                 )
   114:           c *** for Kokubo ASL FFT
   115:           c        CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, DRY, VWORK,
   116:           c     &              WSAVE_XYZ, IFAC_XYZ                 )
   117:           c *** for Kokubo FFTW
   118:           c       call FFT3BX_fftw(NXYZ,DRY,plancfp,plancbp)
   119:           c *** for Kokubo fftw ASL compatible
   120:                   CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, DRY, VWORK,
   121:                &              plancfp,plancbp           )
   122:           C
   123:           c *** for Sugino FFT
   124:           c        CALL FFT3BX( NRX, NRY, NRZ, NXYZ, DRZ, VWORK,
   125:           c     &              WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   126:           c     &              LX1, LX2, LY1, LY2, LZ1, LZ2                 )
   127:           c *** for Kokubo ASL FFT
   128:           c        CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, DRZ, VWORK,
   129:           c     &              WSAVE_XYZ, IFAC_XYZ                 )
   130:           c *** for Kokubo FFTW
   131:           c       call FFT3BX_fftw(NXYZ,DRZ,plancfp,plancbp)
   132:           c *** for Kokubo fftw ASL compatible
   133:                   CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, DRZ, VWORK,
   134:                &              plancfp,plancbp             )
   135:           C
   136:           c *** for Sugino FFT
   137:           c        CALL FFT3BX( NRX, NRY, NRZ, NXYZ, DRXX, VWORK,
   138:           c     &              WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   139:           c     &              LX1, LX2, LY1, LY2, LZ1, LZ2                 )
   140:           c *** for Kokubo ASL FFT
   141:           c        CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, DRXX, VWORK,
   142:           c     &              WSAVE_XYZ, IFAC_XYZ                 )
   143:           c *** for Kokubo FFTW
   144:           c       call FFT3BX_fftw(NXYZ,DRXX,plancfp,plancbp)
   145:           c *** for Kokubo fftw ASL compatible
   146:                   CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, DRXX, VWORK,
   147:                &              plancfp,plancbp            )
   148:           C
   149:           c *** for Sugino FFT
   150:           c        CALL FFT3BX( NRX, NRY, NRZ, NXYZ, DRYY, VWORK,
   151:           c     &              WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   152:           c     &              LX1, LX2, LY1, LY2, LZ1, LZ2                 )
   153:           c *** for Kokubo ASL FFT
   154:           c        CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, DRYY, VWORK,
   155:           c     &              WSAVE_XYZ, IFAC_XYZ                 )
   156:           c *** for Kokubo FFTW
   157:           c       call FFT3BX_fftw(NXYZ,DRYY,plancfp,plancbp)
   158:           c *** for Kokubo fftw ASL compatible
   159:                   CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, DRYY, VWORK,
   160:                &              plancfp,plancbp           )
   161:           C
   162:           c **** for Sugino FFT
   163:           c        CALL FFT3BX( NRX, NRY, NRZ, NXYZ, DRZZ, VWORK,
   164:           c     &              WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   165:           c     &              LX1, LX2, LY1, LY2, LZ1, LZ2                 )
   166:           c **** for Kokubo ASL FFT
   167:           c        CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, DRZZ, VWORK,
   168:           c     &              WSAVE_XYZ, IFAC_XYZ                )
   169:           c *** for Kokubo FFTW
   170:           c       call FFT3BX_fftw(NXYZ,DRZZ,plancfp,plancbp)
   171:           c **** for Kokubo fftw ASL compatible
   172:                   CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, DRZZ, VWORK,
   173:                &              plancfp,plancbp         )
   174:           C
   175:           c *** for Sugino FFT
   176:           c        CALL FFT3BX( NRX, NRY, NRZ, NXYZ, DRXY, VWORK,
   177:           c     &              WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   178:           c     &              LX1, LX2, LY1, LY2, LZ1, LZ2                 )
   179:           c *** for Kokubo ASL FFT
   180:           c        CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, DRXY, VWORK,
   181:           c     &              WSAVE_XYZ, IFAC_XYZ                 )
   182:           c *** for Kokubo FFTW
   183:           c       call FFT3BX_fftw(NXYZ,DRXY,plancfp,plancbp)
   184:           c *** for Kokubo fftw ASL compatible
   185:                   CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, DRXY, VWORK,
   186:                &              plancfp,plancbp        )
   187:           C
   188:           c **** for Sugino FFT
   189:           c        CALL FFT3BX( NRX, NRY, NRZ, NXYZ, DRYZ, VWORK,
   190:           c     &              WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   191:           c     &              LX1, LX2, LY1, LY2, LZ1, LZ2                 )
   192:           c **** for Kokubo ASL FFT
   193:           c        CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, DRYZ, VWORK,
   194:           c     &              WSAVE_XYZ, IFAC_XYZ                 )
   195:           c *** for Kokubo FFTW
   196:           c       call FFT3BX_fftw(NXYZ,DRYZ,plancfp,plancbp)
   197:           c **** for Kokubo fftw ASL compatible
   198:                   CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, DRYZ, VWORK,
   199:                &              plancfp,plancbp          )
   200:           C
   201:           c **** for Sugino FFT
   202:           c        CALL FFT3BX( NRX, NRY, NRZ, NXYZ, DRZX, VWORK,
   203:           c     &              WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   204:           c     &              LX1, LX2, LY1, LY2, LZ1, LZ2                 )
   205:           c **** for Kokubo ASL FFT
   206:           c        CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, DRZX, VWORK,
   207:           c     &              WSAVE_XYZ, IFAC_XYZ                 )
   208:           c *** for Kokubo FFTW
   209:           c       call FFT3BX_fftw(NXYZ,DRZX,plancfp,plancbp)
   210:           c **** for Kokubo fftw ASL compatible
   211:                   CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, DRZX, VWORK,
   212:                &              plancfp,plancbp            )
   213:           C
   214: V------>        DO 100 IG = 1, NXYZ
   215: |                VX    = 0.0D0
   216: |                VCLOC = 0.0D0
   217: |                VCGGA = 0.0D0
   218: |                VCSR(IG) = (0.0D0,0.0D0)
   219: |                DEN   = RHO(IG)
   220: |               IF(DEN.GT.0) THEN
   221: |                DX    = DBLE(DRX(IG))
   222: |                DY    = DBLE(DRY(IG))
   223: |                DZ    = DBLE(DRZ(IG))
   224: |                ABSD  = SQRT(DX*DX+DY*DY+DZ*DZ)
   225: |               IF(DEN.LT.GMIN.OR.ABSD.LT.GMIN) GO TO 200
   226: |         c      IF(DEN.LT.GMIN) GO TO 200
   227: |                DXX   = DBLE(DRXX(IG))
   228: |                DYY   = DBLE(DRYY(IG))
   229: |                DZZ   = DBLE(DRZZ(IG))
   230: |                DXY   = DBLE(DRXY(IG))
   231: |                DYZ   = DBLE(DRYZ(IG))
   232: |                DZX   = DBLE(DRZX(IG))
   233: |                U0    = ( DX*(DX*DXX+DY*DXY+DZ*DZX)
   234: |              &       +   DY*(DX*DXY+DY*DYY+DZ*DYZ)
   235: |              &       +   DZ*(DX*DZX+DY*DYZ+DZ*DZZ))/ABSD
   236: |                V0    =  DXX + DYY + DZZ
   237: |                DRXX(IG)=DCMPLX(U0,V0)
   238: |         C ---  GGA EXCHANGE ---
   239: |                RS =  (3.0D0/(4.0D0*PI*RHO(IG)))**(1.0D0/3.0D0)
   240: |                FK = 1.91915829D0/RS
   241: |                S  = ABSD / (2.0D0*FK*DEN)
   242: |                U1 = U0 /((2.0D0*FK)**3*DEN**2)
   243: |                V1 = V0 /((2.0D0*FK)**2*DEN)
   244: |                DRYY(IG)=DCMPLX(U1,V1)
   245: |                VWORK(IG)=DCMPLX( ABSD,S)
   246: |          200  CONTINUE
   247: |               END IF
   248: V------    100  CONTINUE
   249:           c
   250:           c       CALL EXCHPBE(DEN,S,U1,V1,1,1,EX,VX)
   251:                  CALL EXCHPBE(RHO,VWORK,DRYY,1,1,DRZZ,NXYZ,GMIN)
   252:           C --- LDA CORRELATION ---
   253:           c       CALL CORLSD(RS,0,ECLOC,VCLOC,VCDN,ECRS,ECZET,ALFC)
   254:           c       zzero=0
   255:           c       CALL CORLSD(RHO,VWORK,zzero,DRXY,DRYZ,DRZX,NXYZ,GMIN)
   256:           C --- GGA CORRELATION ---
   257:                  ZET = 0
   258:                  GPOL = ((1.D0+ZET)**THRD2+(1.D0-ZET)**THRD2)/2.D0
   259: V------>         DO 300 IG=1,NXYZ
   260: |                DEN   = RHO(IG)
   261: |                IF ( DEN.GT. 0 ) THEN
   262: |                ABSD=real( VWORK(IG) )
   263: |                IF ( DEN.LT.GMIN .OR. ABSD.LT.GMIN ) GOTO 400
   264: |         c       IF ( DEN.LT.GMIN  ) GOTO 400
   265: |                RS =  (3.0D0/(4.0D0*PI*RHO(IG)))**(1.0D0/3.0D0)
   266: |                FK = 1.91915829D0/RS
   267: |                SK = DSQRT(4.D0*FK/PI)
   268: |         c       GPOL = ((1.D0+ZET)**THRD2+(1.D0-ZET)**THRD2)/2.D0
   269: |         c       T  =  ABSD/(2.0D0*SK*DEN*GPOL)
   270: |                U0=real( DRXX(IG) )
   271: |                V0=imag( DRXX(IG) )
   272: |                U2 =  U0 /(DEN**2 * (2.0D0*SK*GPOL)**3)
   273: |                V2 =  V0 /(DEN * (2.0D0*SK*GPOL)**2)
   274: |                DRYY(IG)=DCMPLX(U2,V2)
   275: |           400  CONTINUE
   276: |                ENDIF
   277: V------     300  CONTINUE
   278:           c
   279:           c       CALL  CORPBE(RS,0,T,U2,V2,0,1,1,EC,VCUP,VCDN
   280:           c     &     ,H,DVCUP,DVCDN)
   281:                  zzero=0
   282:                  zzero2=0
   283:           c  *** note FK and SH should be rebuild in CORPBE !!!
   284:                  CALL CORPBE(RHO,VWORK,zzero,DRYY,zzero2,1,1,DRX,DRY,DRZ
   285:                &     ,DRXY,DRYZ,DRZX,NXYZ,GMIN)
   286:           c
   287: V------>        DO 500 IG=1,NXYZ
   288: |               DEN= RHO(IG)
   289: |               IF ( DEN.GT.0 ) THEN
   290: |               ABSD=real( VWORK(IG) )
   291: |               IF ( DEN.LT.GMIN .OR. ABSD.LT.GMIN ) GOTO 600
   292: |         c      IF ( DEN.LT.GMIN ) GOTO 600
   293: |         c       VCSR(IG) = VX + VCLOC + VCGGA
   294: |         c                    Vx          +VcLSD          +VcPBEcorrection
   295: |               VCSR(IG)=aimag( DRZZ(IG) )+dreal( DRY(IG) )+dreal( DRYZ(IG) )
   296: |           600 CONTINUE
   297: |               ENDIF
   298: V------     500 CONTINUE
   299:           c *** for check
   300:           c      call clock(t1)
   301:           c      write(6,*)' G2VXC2 took ',t1-t0,'seconds'
   302:           c *** check end
   303:                 RETURN
   304:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:36 2022
FILE NAME: gga_lib_3_PBE.f

PROCEDURE NAME: G2XC2
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   306:                  SUBROUTINE G2XC2(TPIBA, NRX,NRY,NRZ,NXYZ,NG,NGQ,G,
   307:                & RHO,RHOG,I2G,
   308:           c *** for Sugino FFT
   309:           c     & WSAVEX,WSAVEY,WSAVEZ,IFACX,IFACY,IFACZ,LX1,LX2,LY1,LY2,
   310:           c     & LZ1,LZ2,EXC,VCSR,DRX,DRY,DRZ,DRXX,DRYY,DRZZ,
   311:           c *** for Kokubo ASL FFT
   312:           c     & WSAVE_XYZ,IFAC_XYZ,EXC,VCSR,DRX,DRY,DRZ,DRXX,DRYY,DRZZ,
   313:           c *** for Kokubo ASL FFT
   314:                & plancfp,plancbp,EXC,VCSR,DRX,DRY,DRZ,DRXX,DRYY,DRZZ,
   315:                &                              DRXY,DRYZ,DRZX,VWORK)
   316:                 IMPLICIT REAL*8(A-H,O-Z)
   317:                 REAL*8 RHO(NXYZ)
   318:           c       REAL*8 VCSR(NXYZ), RHO(NXYZ)
   319:                 COMPLEX*16 VCSR(NXYZ), RHOG(NXYZ)
   320:           c      COMPLEX*16 RHOG(NXYZ)
   321:           c *** for Sugino FFT
   322:           c      COMPLEX*16 WSAVEX(NRX),WSAVEY(NRY),WSAVEZ(NRZ)
   323:           c      DIMENSION IFACX(30),IFACY(30),IFACZ(30)
   324:           c      DIMENSION LX1(NXYZ),LX2(NXYZ),LY1(NXYZ),
   325:           c     &          LY2(NXYZ),LZ1(NXYZ),LZ2(NXYZ)
   326:           c *** for Kokubo ASK FFT
   327:           c      COMPLEX*16 WSAVE_XYZ(NRX+NRY+NRZ)
   328:           c      DIMENSION IFAC_XYZ(60)
   329:           c *** for Kokubo FFTW
   330:                 integer*8 plancfp,plancbp
   331:                 DIMENSION I2G(NGQ),G(4,NGQ)
   332:           c      COMMON/GAS/FK,SK,GPOL,ECLOC,ECRS,ECZET
   333:           C --- for GGA
   334:                 COMPLEX*16 DRX(NXYZ),DRY(NXYZ),DRZ(NXYZ)
   335:                &         ,DRXX(NXYZ),DRYY(NXYZ),DRZZ(NXYZ)
   336:                &         ,DRXY(NXYZ),DRYZ(NXYZ),DRZX(NXYZ)
   337:                 COMPLEX*16 VWORK(NXYZ)
   338:           C
   339:                 PI = 4.D0*DATAN(1.D0)
   340:                 THRD2 = 2.0D0/3.0D0
   341:           c ***  max of RHO
   342:           c      gmax=-1000.d0
   343:           c      do ig=1,nxyz
   344:           c      if ( rho(ig).gt.0 ) then
   345:           c       gmax=max(rho(ig),gmax)
   346:           c      endif
   347:           c      enddo
   348:           c      gdiv=gmax/100.d0
   349:           cc      GMIN=gdiv/256.d0    ! take more than 0.00390625% of max of rho.
   350:           c      GMIN=gdiv/1000.d0    ! take more than 0.00390625% of max of rho.
   351:           c ***  min of RHO
   352:           c      GMIN=1.d+20
   353:           c      do ig=1,nxyz
   354:           c      if ( rho(ig).gt.0 ) then
   355:           c       GMIN=min(rho(ig),GMIN)
   356:           c      endif
   357:           c      enddo
   358:           c ***
   359:           c ***
   360:                 GMIN=1.0D-15
   361:           C
   362:           C
   363: V------>         DO JG = 1, NXYZ
   364: |                 DRX(JG)  = (0.0D0,0.0D0)
   365: |                 DRY(JG)  = (0.0D0,0.0D0)
   366: |                 DRZ(JG)  = (0.0D0,0.0D0)
   367: V------          END DO
   368:           C
   369: V------>         DO IG = 2, NG
   370: |                 JG = I2G(IG)
   371: |       C         DRX(JG)  = TPIBA*(0,1)*G(1,IG)*RHOG(JG)
   372: |       C         DRY(JG)  = TPIBA*(0,1)*G(2,IG)*RHOG(JG)
   373: |       C         DRZ(JG)  = TPIBA*(0,1)*G(3,IG)*RHOG(JG)
   374: V------          END DO
   375:           C
   376:           C --- TRANSFORM TO R-SPACE ----
   377:           c *** for Sugino FFT
   378:           c        CALL FFT3BX( NRX, NRY, NRZ, NXYZ, DRX, VWORK,
   379:           c     &              WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   380:           c     &              LX1, LX2, LY1, LY2, LZ1, LZ2                 )
   381:           c *** for Kokubo ASL FFT
   382:           c        CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, DRX, VWORK,
   383:           c     &              WSAVE_XYZ, IFAC_XYZ                 )
   384:           c *** for Kokubo FFTW
   385:           c        call FFT3BX_fftw(NXYZ,DRX,plancfp,plancbp)
   386:           c *** for Kokubo fftw ASL compatible
   387:                   CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, DRX, VWORK,
   388:                &              plancfp,plancbp           )
   389:           C
   390:           c *** for Sugino FFT
   391:           c        CALL FFT3BX( NRX, NRY, NRZ, NXYZ, DRY, VWORK,
   392:           c     &              WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   393:           c     &              LX1, LX2, LY1, LY2, LZ1, LZ2                 )
   394:           c *** for Kokubo ASL FFT
   395:           c        CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, DRY, VWORK,
   396:           c     &              WSAVE_XYZ, IFAC_XYZ                 )
   397:           c *** for Kokubo FFTW
   398:           c        call FFT3BX_fftw(NXYZ,DRY,plancfp,plancbp)
   399:           c *** for Kokubo fftw ASL compatible
   400:                   CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, DRY, VWORK,
   401:                &              plancfp,plancbp             )
   402:           c *** for Sugino FFT
   403:           c        CALL FFT3BX( NRX, NRY, NRZ, NXYZ, DRZ, VWORK,
   404:           c     &              WSAVEX, WSAVEY, WSAVEZ, IFACX, IFACY, IFACZ,
   405:           c     &              LX1, LX2, LY1, LY2, LZ1, LZ2                 )
   406:           c *** for Kokubo ASL FFT
   407:           c        CALL FFT3BX_ASL( NRX, NRY, NRZ, NXYZ, DRZ, VWORK,
   408:           c     &              WSAVE_XYZ, IFAC_XYZ                 )
   409:           c *** for Kokubo FFTW
   410:           c        call FFT3BX_fftw(NXYZ,DRZ,plancfp,plancbp)
   411:           c *** for Kokubo fftw ASL compatible
   412:                   CALL FFT3BX_fftwASL( NRX, NRY, NRZ, NXYZ, DRZ, VWORK,
   413:                &              plancfp,plancbp         )
   414:           c
   415: V------>        DO 100 IG = 1, NXYZ
   416: |                EX    = 0.0D0
   417: |                ECLOC = 0.0D0
   418: |                H     = 0.0D0
   419: |                VCSR(IG) = 0.0D0
   420: |                DEN   = RHO(IG)
   421: |               IF(DEN.GT.0.0D0) THEN
   422: |                DX    = DBLE(DRX(IG))
   423: |                DY    = DBLE(DRY(IG))
   424: |                DZ    = DBLE(DRZ(IG))
   425: |                ABSD  = SQRT(DX*DX+DY*DY+DZ*DZ)
   426: |               IF(DEN.LT.GMIN.OR.ABSD.LT.GMIN) GO TO 200
   427: |         c      IF(DEN.LT.GMIN) GO TO 200
   428: |         C ---  GGA EXCHANGE ---
   429: |                RS =  (3.0D0/(4.0D0*PI*RHO(IG)))**(1.0D0/3.0D0)
   430: |                FK = 1.91915829D0/RS
   431: |                S  = ABSD / (2.0D0*FK*DEN)
   432: |                U1 = 0.0D0
   433: |                V1 = 0.0D0
   434: |               DRYY(IG)=DCMPLX(U1,V1)
   435: |               VWORK(IG)=DCMPLX(ABSD,S)
   436: |          200  CONTINUE
   437: |               END IF
   438: V------    100  CONTINUE
   439:           C
   440:           c       CALL  EXCHPBE(DEN,S,U1,V1,EX,VX)
   441:                  CALL  EXCHPBE(RHO,VWORK,DRYY,1,0,DRZZ,NXYZ,GMIN)
   442:           C --- LDA CORRELATION ---
   443:           c       CALL CORLSD(RS,0,ECLOC,VCLOC,VCDN,ECRS,ECZET,ALFC)
   444:           c       zzero=0
   445:           c       CALL CORLSD(RHO,VWORK,zzero,DRXY,DRYZ,DRZX,NXYZ,GMIN)
   446:           c
   447:           C --- GGA CORRELATION ---
   448:                  ZET = 0
   449:                  GPOL = ((1.D0+ZET)**THRD2+(1.D0-ZET)**THRD2)/2.D0
   450: V------>         DO 300 IG=1,NXYZ
   451: |                DRYY(IG)=dcmplx(0.d0,0.d0)
   452: V------     300  CONTINUE
   453:           c
   454:           c       CALL  CORPBE(RS,0,T,U2,V2,0,1,1,EC,VCUP,VCDN
   455:           c     &     ,H,DVCUP,DVCDN)
   456:                  zzero=0
   457:                  zzero2=0
   458:           c  *** note FK and SH should be rebuild in CORPBE !!!
   459:                  CALL CORPBE(RHO,VWORK,zzero,DRYY,zzero2,1,0,DRX,DRY,DRZ
   460:                &     ,DRXY,DRYZ,DRZX,NXYZ,GMIN)
   461:           c
   462: V------>        DO IG=1,NXYZ
   463: |         c *****            Ex      +  EcLSD   +  H (EcPBEcorrection)
   464: |                VCSR(IG)=( dreal(DRZZ(IG) )+dreal(DRX(IG) )
   465: |              &           +dreal(DRXY(IG) ) )*RHO(IG)
   466: |               ENDDO
   467: |         c
   468: |                 EXC = 0.0D0
   469: |               DO IG = 1, NXYZ
   470: |                 EXC = EXC + DBLE(VCSR(IG))
   471: V------         END DO
   472:                 RETURN
   473:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:36 2022
FILE NAME: gga_lib_3_PBE.f

PROCEDURE NAME: EXCHPBE
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   478:                 SUBROUTINE EXCHPBE(rho,VWORK,DRYY,lgga,lpot,DRZZ,NXYZ,GMIN)
   479:           c----------------------------------------------------------------------
   480:           C  PBE EXCHANGE FOR A SPIN-UNPOLARIZED ELECTRONIC SYSTEM
   481:           c  K Burke's modification of PW91 codes, May 14, 1996
   482:           c  Modified again by K. Burke, June 29, 1996, with simpler Fx(s)
   483:           c----------------------------------------------------------------------
   484:           c----------------------------------------------------------------------
   485:           C  INPUT rho : DENSITY
   486:           C  INPUT S:  ABS(GRAD rho)/(2*KF*rho), where kf=(3 pi^2 rho)^(1/3)
   487:           C  INPUT U:  (GRAD rho)*GRAD(ABS(GRAD rho))/(rho**2 * (2*KF)**3)
   488:           C  INPUT V: (LAPLACIAN rho)/(rho*(2*KF)**2)
   489:           c   (for U,V, see PW86(24))
   490:           c  input lgga:  (=0=>don't put in gradient corrections, just LDA)
   491:           c  input lpot:  (=0=>don't get potential and don't need U and V)
   492:           C  OUTPUT:  EXCHANGE ENERGY PER ELECTRON (EX) AND POTENTIAL (VX)
   493:           c----------------------------------------------------------------------
   494:           c----------------------------------------------------------------------
   495:           c References:
   496:           c [a]J.P.~Perdew, K.~Burke, and M.~Ernzerhof, submiited to PRL, May96
   497:           c [b]J.P. Perdew and Y. Wang, Phys. Rev.  B {\bf 33},  8800  (1986);
   498:           c     {\bf 40},  3399  (1989) (E).
   499:           c----------------------------------------------------------------------
   500:           c----------------------------------------------------------------------
   501:           c Formulas:
   502:           c   	e_x[unif]=ax*rho^(4/3)  [LDA]
   503:           c ax = -0.75*(3/pi)^(1/3)
   504:           c	e_x[PBE]=e_x[unif]*FxPBE(s)
   505:           c	FxPBE(s)=1+uk-uk/(1+ul*s*s)                 [a](13)
   506:           c uk, ul defined after [a](13)
   507:           c----------------------------------------------------------------------
   508:           c----------------------------------------------------------------------
   509:                 IMPLICIT REAL*8 (A-H,O-Z)
   510:                 DIMENSION RHO(NXYZ)
   511:                 COMPLEX*16 VWORK(NXYZ),DRYY(NXYZ),DRZZ(NXYZ)
   512:                 parameter(thrd=1.d0/3.d0,thrd4=4.d0/3.d0)
   513:                 parameter(pi=3.14159265358979323846264338327950d0)
   514:                 parameter(ax=-0.738558766382022405884230032680836d0)
   515:                 parameter(um=0.2195149727645171d0,uk=0.8040d0,ul=um/uk)
   516:           c----------------------------------------------------------------------
   517:           c----------------------------------------------------------------------
   518:           c construct LDA exchange energy density
   519:           ccc      exunif = AX*rho**THRD
   520:                 if(lgga.eq.0)then
   521: V------>        do ig=1,nxyz
   522: |               exunif = AX*rho(ig)**THRD
   523: |         	ex=exunif
   524: |                 vx=ex*thrd4
   525: |               DRZZ(IG)=DCMPLX(EX,VX)
   526: V------         enddo
   527:           	return
   528:                 endif
   529:           c----------------------------------------------------------------------
   530:           c----------------------------------------------------------------------
   531:           c construct PBE enhancement factor
   532:           c
   533:                 if(lpot.eq.0) then
   534: V------>        do ig=1,NXYZ
   535: |               exunif = AX*rho(ig)**THRD
   536: |               S=aimag(VWORK(IG))
   537: |               U=dreal(DRYY(IG) )
   538: |               V=aimag(DRYY(IG) )
   539: |               S2 = S*S
   540: |               P0=1.d0+ul*S2
   541: |               FxPBE = 1d0+uk-uk/P0
   542: |               EX = exunif*FxPBE
   543: |               DRZZ(IG)=DCMPLX(EX,0.d0)
   544: V------         enddo
   545:                 endif
   546:                 if(lpot.eq.0)return
   547:           c----------------------------------------------------------------------
   548:           c----------------------------------------------------------------------
   549:           C  ENERGY DONE. NOW THE POTENTIAL:
   550:           c  find first and second derivatives of Fx w.r.t s.
   551:           c  Fs=(1/s)*d FxPBE/ ds
   552:           c  Fss=d Fs/ds
   553:           c      Fs=2.d0*uk*ul/(P0*P0)   ! moved into do loop (P0 depends on S)
   554:           c      Fss=-4.d0*ul*S*Fs/P0    ! moved into do loop
   555:           c----------------------------------------------------------------------
   556:           c----------------------------------------------------------------------
   557:           c calculate potential from [b](24)
   558: V------>        do ig=1,NXYZ
   559: |               exunif = AX*rho(ig)**THRD
   560: |               S=aimag(VWORK(IG))
   561: |               U=dreal(DRYY(IG) )
   562: |               V=aimag(DRYY(IG) )
   563: |               S2 = S*S
   564: |               P0=1.d0+ul*S2
   565: |               FxPBE = 1d0+uk-uk/P0
   566: |               EX = exunif*FxPBE
   567: |               Fs=2.d0*uk*ul/(P0*P0)
   568: |               Fss=-4.d0*ul*S*Fs/P0
   569: |               VX = exunif*(THRD4*FxPBE-(U-THRD4*S2*s)*FSS-V*FS)
   570: |               DRZZ(IG)=DCMPLX(EX,VX)
   571: V------         enddo
   572:                 RETURN
   573:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:36 2022
FILE NAME: gga_lib_3_PBE.f

PROCEDURE NAME: CORPBE
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   579:                 SUBROUTINE CORPBE(RHO,VWORK,ZET,DRYY,WW,lgga,lpot,DRX,DRY,DRZ,
   580:                1                  DRXY,DRYZ,DRZX,NXYZ,GMIN)
   581:           c----------------------------------------------------------------------
   582:           c  Official PBE correlation code. K. Burke, May 14, 1996.
   583:           C  INPUT: RS=SEITZ RADIUS=(3/4pi rho)^(1/3)
   584:           C       : ZET=RELATIVE SPIN POLARIZATION = (rhoup-rhodn)/rho
   585:           C       : t=ABS(GRAD rho)/(rho*2.*KS*G)  -- only needed for PBE and made
   586:           C       :                                   from RS
   587:           C       : UU=(GRAD rho)*GRAD(ABS(GRAD rho))/(rho**2 * (2*KS*G)**3)
   588:           C       : VV=(LAPLACIAN rho)/(rho * (2*KS*G)**2)
   589:           C       : WW=(GRAD rho)*(GRAD ZET)/(rho * (2*KS*G)**2
   590:           c       :  UU,VV,WW, only needed for PBE potential
   591:           c       : lgga=flag to do gga (0=>LSD only)
   592:           c       : lpot=flag to do potential (0=>energy only)
   593:           c  output: ec=lsd correlation energy from [a]
   594:           c        : vcup=lsd up correlation potential
   595:           c        : vcdn=lsd dn correlation potential
   596:           c        : h=NONLOCAL PART OF CORRELATION ENERGY PER ELECTRON
   597:           c        : dvcup=nonlocal correction to vcup
   598:           c        : dvcdn=nonlocal correction to vcdn
   599:           c----------------------------------------------------------------------
   600:           c----------------------------------------------------------------------
   601:           c References:
   602:           c [a] J.P.~Perdew, K.~Burke, and M.~Ernzerhof,
   603:           c     {\sl Generalized gradient approximation made simple}, sub.
   604:           c     to Phys. Rev.Lett. May 1996.
   605:           c [b] J. P. Perdew, K. Burke, and Y. Wang, {\sl Real-space cutoff
   606:           c     construction of a generalized gradient approximation:  The PW91
   607:           c     density functional}, submitted to Phys. Rev. B, Feb. 1996.
   608:           c [c] J. P. Perdew and Y. Wang, Phys. Rev. B {\bf 45}, 13244 (1992).
   609:           c----------------------------------------------------------------------
   610:           c----------------------------------------------------------------------
   611:                 IMPLICIT REAL*8 (A-H,O-Z)
   612:           c thrd*=various multiples of 1/3
   613:           c numbers for use in LSD energy spin-interpolation formula, [c](9).
   614:           c      GAM= 2^(4/3)-2
   615:           c      FZZ=f''(0)= 8/(9*GAM)
   616:           c numbers for construction of PBE
   617:           c      gamma=(1-log(2))/pi^2
   618:           c      bet=coefficient in gradient expansion for correlation, [a](4).
   619:           c      eta=small number to stop d phi/ dzeta from blowing up at
   620:           c          |zeta|=1.
   621:                 parameter(thrd=1.d0/3.d0,thrdm=-thrd,thrd2=2.d0*thrd)
   622:                 parameter(sixthm=thrdm/2.d0)
   623:                 parameter(thrd4=4.d0*thrd)
   624:                 parameter(GAM=0.5198420997897463295344212145565d0)
   625:                 parameter(fzz=8.d0/(9.d0*GAM))
   626:                 parameter(gamma=0.03109069086965489503494086371273d0)
   627:                 parameter(bet=0.06672455060314922d0,delt=bet/gamma)
   628:                 parameter(eta=1.d-12)
   629:           c----------------------------------------------------------------------
   630:           c----------------------------------------------------------------------
   631:           c find LSD energy contributions, using [c](10) and Table I[c].
   632:           c EU=unpolarized LSD correlation energy
   633:           c EURS=dEU/drs
   634:           c EP=fully polarized LSD correlation energy
   635:           c EPRS=dEP/drs
   636:           c ALFM=-spin stiffness, [c](3).
   637:           c ALFRSM=-dalpha/drs
   638:           c F=spin-scaling factor from [c](9).
   639:           c construct ec, using [c](8)
   640:                 DIMENSION RHO(NXYZ)
   641:                 COMPLEX*16 VWORK(NXYZ)
   642:                 COMPLEX*16 DRX(NXYZ),DRY(NXYZ),DRZ(NXYZ),DRYY(NXYZ)
   643:                 COMPLEX*16 DRXY(NXYZ),DRYZ(NXYZ),DRZX(NXYZ)
   644:                 pi=dacos(-1.d0)
   645: V------>        DO IG=1,NXYZ
   646: |               DEN   = RHO(IG)
   647: |         ccc      IF ( DEN.LE. 0 ) GOTO 400
   648: |               ABSD=real( VWORK(IG) )
   649: |               IF ( DEN.LT.GMIN .OR. ABSD.LT.GMIN ) GOTO 400
   650: |         c      IF ( DEN.LT.GMIN  ) GOTO 400
   651: |               RS =  (3.0D0/(4.0D0*PI*RHO(IG)))**(1.0D0/3.0D0)
   652: |               FK = 1.91915829D0/RS
   653: |               SK = DSQRT(4.D0*FK/PI)
   654: |               GPOL = ((1.D0+ZET)**THRD2+(1.D0-ZET)**THRD2)/2.D0
   655: |               T  =  ABSD/(2.0D0*SK*DEN*GPOL)
   656: |               rtrs=dsqrt(rs)
   657: |               UU=dreal(DRYY(IG))
   658: |               VV=aimag(DRYY(IG))
   659: |         c *****  SUBROUTINE GCOR2(A,A1,B1,B2,B3,B4,rtrs,GG,GGRS)
   660: |         c      CALL gcor2(0.0310907D0,0.21370D0,7.5957D0,3.5876D0,1.6382D0,
   661: |         c     1    0.49294D0,rtrs,EU,EURS)
   662: |               A= 0.0310907D0
   663: |               A1=0.21370D0
   664: |               B1=7.5957D0
   665: |               B2=3.5876D0
   666: |               B3=1.6382D0
   667: |               B4=0.49294D0
   668: |               Q0 = -2.D0*A*(1.D0+A1*rtrs*rtrs)
   669: |               Q1 = 2.D0*A*rtrs*(B1+rtrs*(B2+rtrs*(B3+B4*rtrs)))
   670: |               Q2 = DLOG(1.D0+1.D0/Q1)
   671: |               EU = Q0*Q2
   672: |               Q3 = A*(B1/rtrs+2.D0*B2+rtrs*(3.D0*B3+4.D0*B4*rtrs))
   673: |               EURS = -2.D0*A*A1*Q2-Q0*Q3/(Q1*(1.d0+Q1))
   674: |         c      CALL gcor2(0.01554535D0,0.20548D0,14.1189D0,6.1977D0,3.3662D0,
   675: |         c     1    0.62517D0,rtRS,EP,EPRS)
   676: |               A= 0.01554535D0
   677: |               A1=0.20548D0
   678: |               B1=14.1189D0
   679: |               B2=6.1977D0
   680: |               B3=3.3662D0
   681: |               B4=0.62517D0
   682: |               Q0 = -2.D0*A*(1.D0+A1*rtrs*rtrs)
   683: |               Q1 = 2.D0*A*rtrs*(B1+rtrs*(B2+rtrs*(B3+B4*rtrs)))
   684: |               Q2 = DLOG(1.D0+1.D0/Q1)
   685: |               EP = Q0*Q2
   686: |               Q3 = A*(B1/rtrs+2.D0*B2+rtrs*(3.D0*B3+4.D0*B4*rtrs))
   687: |               EPRS = -2.D0*A*A1*Q2-Q0*Q3/(Q1*(1.d0+Q1))
   688: |         c      CALL gcor2(0.0168869D0,0.11125D0,10.357D0,3.6231D0,0.88026D0,
   689: |         c     1    0.49671D0,rtRS,ALFM,ALFRSM)
   690: |               A= 0.0168869D0
   691: |               A1=0.11125D0
   692: |               B1=10.357D0
   693: |               B2=3.6231D0
   694: |               B3=0.88026D0
   695: |               B4=0.49671D0
   696: |               Q0 = -2.D0*A*(1.D0+A1*rtrs*rtrs)
   697: |               Q1 = 2.D0*A*rtrs*(B1+rtrs*(B2+rtrs*(B3+B4*rtrs)))
   698: |               Q2 = DLOG(1.D0+1.D0/Q1)
   699: |               ALFM = Q0*Q2
   700: |               Q3 = A*(B1/rtrs+2.D0*B2+rtrs*(3.D0*B3+4.D0*B4*rtrs))
   701: |               ALFRSM = -2.D0*A*A1*Q2-Q0*Q3/(Q1*(1.d0+Q1))
   702: |               ALFC = -ALFM
   703: |               Z4 = ZET**4
   704: |               F=((1.D0+ZET)**THRD4+(1.D0-ZET)**THRD4-2.D0)/GAM
   705: |               EC = EU*(1.D0-F*Z4)+EP*F*Z4-ALFM*F*(1.D0-Z4)/FZZ
   706: |               DRX(IG)=DCMPLX(EC,0)   ! correlation by LSD part
   707: |         c----------------------------------------------------------------------
   708: |         c----------------------------------------------------------------------
   709: |         c LSD potential from [c](A1)
   710: |         c ECRS = dEc/drs [c](A2)
   711: |         c ECZET=dEc/dzeta [c](A3)
   712: |         c FZ = dF/dzeta [c](A4)
   713: |               ECRS = EURS*(1.D0-F*Z4)+EPRS*F*Z4-ALFRSM*F*(1.D0-Z4)/FZZ
   714: |               FZ = THRD4*((1.D0+ZET)**THRD-(1.D0-ZET)**THRD)/GAM
   715: |               ECZET = 4.D0*(ZET**3)*F*(EP-EU+ALFM/FZZ)+FZ*(Z4*EP-Z4*EU
   716: |              1        -(1.D0-Z4)*ALFM/FZZ)
   717: |               COMM = EC -RS*ECRS/3.D0-ZET*ECZET
   718: |               VCUP = COMM + ECZET
   719: |               VCDN = COMM - ECZET
   720: |               DRY(IG)=DCMPLX(VCUP,0)
   721: |               DRZ(IG)=DCMPLX(VCDN,0)
   722: |         ccc      if(lgga.eq.0)return
   723: |               if(lgga.eq.0) GOTO 400
   724: |         c----------------------------------------------------------------------
   725: |         c----------------------------------------------------------------------
   726: |         c PBE correlation energy
   727: |         c G=phi(zeta), given after [a](3)
   728: |         c DELT=bet/gamma
   729: |         c B=A of [a](8)
   730: |               G=((1.d0+ZET)**thrd2+(1.d0-ZET)**thrd2)/2.d0
   731: |               G3 = G**3
   732: |               PON=-EC/(G3*gamma)
   733: |               B = DELT/(DEXP(PON)-1.D0)
   734: |               B2 = B*B
   735: |               T2 = T*T
   736: |               T4 = T2*T2
   737: |               RS2 = RS*RS
   738: |               RS3 = RS2*RS
   739: |               Q4 = 1.D0+B*T2
   740: |               Q5 = 1.D0+B*T2+B2*T4
   741: |               H = G3*(BET/DELT)*DLOG(1.D0+DELT*Q4*T2/Q5)
   742: |               DRXY(IG)=DCMPLX(H,0)
   743: |         c      if(lpot.eq.0)return
   744: |               if(lpot.eq.0) GOTO 400
   745: |         c----------------------------------------------------------------------
   746: |         c----------------------------------------------------------------------
   747: |         C ENERGY DONE. NOW THE POTENTIAL, using appendix E of [b].
   748: |               G4 = G3*G
   749: |               T6 = T4*T2
   750: |               RSTHRD = RS/3.D0
   751: |               GZ=(((1.d0+zet)**2+eta)**sixthm-
   752: |              1((1.d0-zet)**2+eta)**sixthm)/3.d0
   753: |               FAC = DELT/B+1.D0
   754: |               BG = -3.D0*B2*EC*FAC/(BET*G4)
   755: |               BEC = B2*FAC/(BET*G3)
   756: |               Q8 = Q5*Q5+DELT*Q4*Q5*T2
   757: |               Q9 = 1.D0+2.D0*B*T2
   758: |               hB = -BET*G3*B*T6*(2.D0+B*T2)/Q8
   759: |               hRS = -RSTHRD*hB*BEC*ECRS
   760: |               FACT0 = 2.D0*DELT-6.D0*B
   761: |               FACT1 = Q5*Q9+Q4*Q9*Q9
   762: |               hBT = 2.D0*BET*G3*T4*((Q4*Q5*FACT0-DELT*FACT1)/Q8)/Q8
   763: |               hRST = RSTHRD*T2*hBT*BEC*ECRS
   764: |               hZ = 3.D0*GZ*h/G + hB*(BG*GZ+BEC*ECZET)
   765: |               hT = 2.d0*BET*G3*Q9/Q8
   766: |               hZT = 3.D0*GZ*hT/G+hBT*(BG*GZ+BEC*ECZET)
   767: |               FACT2 = Q4*Q5+B*T2*(Q4*Q9+Q5)
   768: |               FACT3 = 2.D0*B*Q5*Q9+DELT*FACT2
   769: |               hTT = 4.D0*BET*G3*T*(2.D0*B/Q8-(Q9*FACT3/Q8)/Q8)
   770: |               COMM = H+HRS+HRST+T2*HT/6.D0+7.D0*T2*T*HTT/6.D0
   771: |               PREF = HZ-GZ*T2*HT/G
   772: |               FACT5 = GZ*(2.D0*HT+T*HTT)/G
   773: |               COMM = COMM-PREF*ZET-UU*HTT-VV*HT-WW*(HZT-FACT5)
   774: |               DVCUP = COMM + PREF
   775: |               DVCDN = COMM - PREF
   776: |         c      DRYZ(IG)=DCMPLX(DCUP,0)
   777: |         c      DRZX(IG)=DCMPLX(DCDN,0)
   778: |               DRYZ(IG)=DCMPLX(DVCUP,0)
   779: |               DRZX(IG)=DCMPLX(DVCDN,0)
   780: |           400 CONTINUE
   781: V------         ENDDO
   782:                 RETURN
   783:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:36 2022
FILE NAME: gga_lib_3_PBE.f

PROCEDURE NAME: GCOR2
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   787:                 SUBROUTINE GCOR2(A,A1,B1,B2,B3,B4,rtrs,GG,GGRS)
   788:           c slimmed down version of GCOR used in PW91 routines, to interpolate
   789:           c LSD correlation energy, as given by (10) of
   790:           c J. P. Perdew and Y. Wang, Phys. Rev. B {\bf 45}, 13244 (1992).
   791:           c K. Burke, May 11, 1996.
   792:                 IMPLICIT REAL*8 (A-H,O-Z)
   793:                 Q0 = -2.D0*A*(1.D0+A1*rtrs*rtrs)
   794:                 Q1 = 2.D0*A*rtrs*(B1+rtrs*(B2+rtrs*(B3+B4*rtrs)))
   795:                 Q2 = DLOG(1.D0+1.D0/Q1)
   796:                 GG = Q0*Q2
   797:                 Q3 = A*(B1/rtrs+2.D0*B2+rtrs*(3.D0*B3+4.D0*B4*rtrs))
   798:                 GGRS = -2.D0*A*A1*Q2-Q0*Q3/(Q1*(1.d0+Q1))
   799:                 RETURN
   800:                 END


