NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:25 2022
FILE NAME: rarr3.f

PROCEDURE NAME: RARR3
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     5:                 SUBROUTINE RARR3(SP,RG,NG,INV,QF,EPS,IPRINT,AKK,KG,KZ,NNK,NKG)
     6:                 IMPLICIT REAL*8(A-H,O-Z)
     7:                 include 'mpif.h'
     8:                 PARAMETER(LATQ=120)
     9:                 DIMENSION KG(3,LATQ),AKK(LATQ),SP(3,3),NN(3)
    10:                &         ,KZ(3,LATQ,48),NNK(LATQ)
    11:                 dimension kz0(3,latq,48),nnk0(latq),akk0(latq)
    12:                 INTEGER*4 RG(3,3,48)
    13:                 REAL*8  AKK,SP
    14:                 EQUIVALENCE (N1,NN(1)),(N2,NN(2)),(N3,NN(3))
    15:           c
    16:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
    17:           c
    18:           c **** for 2D cell where A3 is normal to the cell
    19:           c      do i=1,2
    20:           c      sp(i,3)=sp(i,3)*100
    21:           c      sp(3,i)=sp(3,i)*100
    22:           c      enddo
    23:           c      sp(3,3)=sp(3,3)*10000
    24:           c **** temp check
    25:           c      if ( my_rank.ne.0 ) then
    26:           c      write(6,*)' in sub RARR3 my_rank=',my_rank,':  QF = ',qf
    27:           cc      write(6,1020)((sp(i,j),j=1,3),i=1,3)
    28:           c 1020 format(3d20.12)
    29:           cc      write(6,*)'  check KZ '
    30:           cc      do 401 kk=1,latq
    31:           cc      write(6,*)' kk = ',kk
    32:           cc      do 401 ks=1,48
    33:           cc  401 write(6,*)(kz(i,kk,ks),i=1,3)
    34:           c      endif
    35:           c      call MPI_Barrier(MPI_COMM_WORLD,ierr)
    36:           c      miya=13
    37:           c      if ( miya.eq.13 ) stop
    38:           c **** check end
    39:                 IND=0
    40:                 QFF=QF*QF
    41:                 A=SP(3,3)
    42:                 B0=SP(2,2)*SP(3,3)-SP(2,3)**2
    43:                 B=B0/A
    44:                 C=(SP(1,1)*SP(2,2)*SP(3,3)+2.0*SP(2,3)*SP(3,1)*SP(1,2)
    45:                &  -(SP(1,1)*SP(2,3)**2+SP(2,2)*SP(3,1)**2+SP(3,3)*SP(1,2)**2))/B0
    46:                 N=0
    47:                 QN1=-QF/SQRT(C)
    48:                 N1=QN1
    49:              20 GK1=N1
    50:                 SB=-(SP(1,2)*SP(3,3)-SP(1,3)*SP(2,3))*GK1/B0
    51:                 S=C*GK1*GK1
    52:                 RS=QFF-S
    53:                 IF(RS) 65,21,21
    54:              21 QN2=SB-SQRT(RS/B)
    55:                 N2=QN2
    56:                 IF(QN2.GT.0.0) N2=N2+1
    57:              22 GK2=N2
    58:                 SA=-(SP(1,3)*GK1+SP(2,3)*GK2)/A
    59:                 SS=S+B*(GK2-SB)**2
    60:                 RS=QFF-SS
    61:                 IF(RS) 64,23,23
    62:              23 QN3=SA-SQRT(RS/A)
    63:                 N3=QN3
    64:                 IF(QN3.GT.0.0) N3=N3+1
    65:              24 GK3=N3
    66:                 SSS=SS+A*(GK3-SA)**2
    67:                 IF(QFF-SSS) 62,25,25
    68:              25 IF(N) 46,46,26
    69: V------>     26 DO 28 K=1,NKG
    70: |               IF(AKK(K)-(SSS-EPS)) 28,32,32
    71: V------      28 CONTINUE
    72:                 IF(N-LATQ) 30,50,50
    73:              30 K=N+1
    74:                 GO TO 48
    75:              32 IF(AKK(K)-(SSS+EPS)) 52,52,34
    76:              34 IF(N-LATQ) 38,36,36
    77:              36 IF(NKG-K) 48,48,40
    78:              40 KM=K+1
    79:                 GO TO 42
    80:              38 KM=K
    81: V------>     42 DO 44 KK=KM,NKG
    82: |               KS=NKG-KK+K
    83: |               AKK(KS+1)=AKK(KS)
    84: |*----->        DO 41 J=1,3
    85: |*-----      41 KG(J,KS+1)=KG(J,KS)
    86: V------      44 CONTINUE
    87:                 GO TO 48
    88:              46 K=1
    89:              48 AKK(K)=SSS
    90: *------>        DO 49 I=1,3
    91: *------      49 KG(I,K)=NN(I)
    92:              50 N=N+1
    93:                 NKG=MIN0(N,LATQ)
    94:                 GO TO 60
    95: +------>     52 DO 54 IV=1,INV+1
    96: |+----->        DO 54 IG=1,NG
    97: ||*---->        DO 55 I=1,3
    98: |||             IS=0
    99: |||*--->        DO 56 M=1,3
   100: |||*---      56 IS=IS+RG(M,I,IG)*KG(M,K)
   101: |||             IF( IV.EQ.2) IS=-IS
   102: |||             IF(IS-NN(I)) 54,55,54
   103: ||*----      55 CONTINUE
   104: ||              GO TO 60
   105: |+-----      54 CONTINUE
   106:                 IF(K.GE.LATQ) GO TO 50
   107:                 K=K+1
   108:                 IF(K.GT.NKG) GO TO 48
   109:                 IF(AKK(K)-(SSS+EPS)) 52,52,34
   110:              60 N3=N3+1
   111:                 GO TO 24
   112:              62 N2=N2+1
   113:                 GO TO 22
   114:              64 N1=N1+1
   115:                 GO TO 20
   116:              65 CONTINUE
   117:                 IF(N.GT.NKG) IND=-1
   118:           C
   119:                 if ( my_rank.eq.0 ) WRITE(6,6000) NKG, IND
   120:            6000 FORMAT(/8X,
   121:                &'  **** RARR3: NEXPND = ',I4,' IND = ',I2,' SHOULD BE 0')
   122:           C
   123:           c      IF(IPRINT.NE.0) WRITE(6,100) N
   124:           c  100 FORMAT(8X
   125:           c     &'              N = ',I3,'   NO  KR1 KR2 KR3    ADR ')
   126:           c      IF(IPRINT) 90,88,90
   127:           c   90 write(6,*)' Reducible R-vectors '
   128:           c      DO 92 KK=1,NKG
   129:           c      WRITE(6,2000) KK,(KG(I,KK),I=1,3),AKK(KK)
   130:           c 2000 FORMAT(31X,I3,2X,3I3,2X,D13.5)
   131:           c   92 CONTINUE
   132:           CC
   133: +------>     88 DO 71 KK=1,NKG
   134: |               KS=1
   135: |               KZ(1,KK,1)=KG(1,KK)
   136: |               KZ(2,KK,1)=KG(2,KK)
   137: |               KZ(3,KK,1)=KG(3,KK)
   138: |+----->        DO 72 IG=1,NG
   139: ||*---->        DO 72 IW=1,-1,-2
   140: |||             KK1=RG(1,1,IG)*KG(1,KK)+RG(2,1,IG)*KG(2,KK)+RG(3,1,IG)*KG(3,KK)
   141: |||             KK2=RG(1,2,IG)*KG(1,KK)+RG(2,2,IG)*KG(2,KK)+RG(3,2,IG)*KG(3,KK)
   142: |||             KK3=RG(1,3,IG)*KG(1,KK)+RG(2,3,IG)*KG(2,KK)+RG(3,3,IG)*KG(3,KK)
   143: |||             KK1=KK1*IW
   144: |||             KK2=KK2*IW
   145: |||             KK3=KK3*IW
   146: |||V--->        DO 73 KX=1,KS
   147: ||||            IF((KK1.EQ.KZ(1,KK,KX)).AND.(KK2.EQ.KZ(2,KK,KX)).AND.
   148: ||||           &   (KK3.EQ.KZ(3,KK,KX))) GO TO 72
   149: |||V---      73 CONTINUE
   150: |||             KS=KS+1
   151: |||             KZ(1,KK,KS)=KK1
   152: |||             KZ(2,KK,KS)=KK2
   153: |||             KZ(3,KK,KS)=KK3
   154: ||*----      72 CONTINUE
   155: |               NNK(KK)=KS
   156: +------      71 CONTINUE
   157:           c **** now generate irreducible R-vectors ***
   158:           c
   159:           c **** temp check
   160:           c      write(6,*)' Before taking copies '
   161:           c      write(6,*) '  nnk '
   162:           c      write(6,*)(nnk(kk),kk=1,nkg)
   163:           c      write(6,*)
   164:           c      write(6,*)' kz '
   165:           c      do 302 kk=1,nkg
   166:           c      write(6,*) '  kk = ',kk
   167:           c      do 302 ks=1,nnk(kk)
   168:           c  302 write(6,*)(kz(i,kk,ks),i=1,3),akk(kk)
   169:           c **** temp check end
   170:           c  ******  first, take backup copies ***
   171: +------>        do 101 kk=1,nkg
   172: |               nnk0(kk)=nnk(kk)
   173: |               akk0(kk)=akk(kk)
   174: |V----->        do 101 ks=1,nnk(kk)
   175: ||              kz0(1,kk,ks)=kz(1,kk,ks)
   176: ||              kz0(2,kk,ks)=kz(2,kk,ks)
   177: ||              kz0(3,kk,ks)=kz(3,kk,ks)
   178: |V-----     101 continue
   179:           c **** temp check
   180:           c      write(6,*)' Check after taking copies '
   181:           c      write(6,*) '  nnk0 '
   182:           c      write(6,*)(nnk0(kk),kk=1,nkg)
   183:           c      write(6,*)
   184:           c      write(6,*)' kz0 '
   185:           c      do 301 kk=1,nkg
   186:           c      write(6,*) '  kk = ',kk
   187:           c      do 301 ks=1,nnk(kk)
   188:           c  301 write(6,*)(kz0(i,kk,ks),i=1,3),akk0(kk)
   189:           c **** temp check end
   190:           c
   191:           c  ******  second, look for equivalent R-vectors ***
   192:                 kseq=1
   193: +------>        do 102 kk=2,nkg
   194: |               kzx=kz0(1,kk,1)
   195: |               kzy=kz0(2,kk,1)
   196: |               kzz=kz0(3,kk,1)
   197: |               ieq=0
   198: |+----->        do 103 kk0=1,kk-1
   199: ||V---->        do 103 ks0=1,nnk0(kk0)
   200: |||             if (kzx.eq.kz0(1,kk0,ks0) .and.
   201: |||            &    kzy.eq.kz0(2,kk0,ks0) .and.
   202: |||            &    kzz.eq.kz0(3,kk0,ks0) ) then
   203: |||             ieq=1
   204: |||             goto 104
   205: |||             end if
   206: ||V----     103 continue
   207: |         c**
   208: |           104 continue
   209: |         c******   Finally, renumber the R-vectors
   210: |               if ( ieq.eq.0 ) then
   211: |               kseq=kseq+1
   212: |               if ( kseq.gt.latq ) then
   213: |                kseq=kseq-1
   214: |                goto 112
   215: |               endif
   216: |               nnk(kseq)=nnk0(kk)
   217: |               akk(kseq)=akk0(kk)
   218: |               kg(1,kseq)=kz0(1,kk,1)
   219: |               kg(2,kseq)=kz0(2,kk,1)
   220: |               kg(3,kseq)=kz0(3,kk,1)
   221: |V----->        do 201 ks=1,nnk(kseq)
   222: ||              kz(1,kseq,ks)=kz0(1,kk,ks)
   223: ||              kz(2,kseq,ks)=kz0(2,kk,ks)
   224: ||              kz(3,kseq,ks)=kz0(3,kk,ks)
   225: |V-----     201 continue
   226: |               end if
   227: +------     102 continue
   228:             112 continue
   229:                 nkg=kseq
   230:           C
   231:                 IF(IPRINT.NE.0 .and. my_rank.eq.0 ) WRITE(6,100) N
   232:             100 FORMAT(8X
   233:                &'              N = ',I3,'   NO  KR1 KR2 KR3    ADR ')
   234:                 IF(IPRINT) 80,88,80
   235:              80 if (my_rank.eq.0 ) write(6,*)' R-vectors'
   236:                 if ( my_rank.eq.0 ) then
   237: +------>        DO 83 KK=1,NKG
   238: |               write(6,*)' seq. #   # of stars     length'
   239: |               WRITE(6,2000) KK,nnk(kk),AKK(KK)
   240: |+----->        do 82 ks=1,nnk(kk)
   241: ||*---->        WRITE(6,2010)(Kz(I,KK,ks),I=1,3)
   242: |+-----      82 CONTINUE
   243: +------      83 CONTINUE
   244:                 endif
   245:            2000 FORMAT(3X,I3,9x,i3,7x,D13.5)
   246:            2010 FORMAT(2X,3x,2X,3I3,'       R-vector')
   247:           CC
   248:                 RETURN
   249:                 END


