NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:28 2022
FILE NAME: smatchk2.f

PROCEDURE NAME: SMATCHK2
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     5:                 SUBROUTINE SMATCHK2( S, TAU, CTAU, B1, B2, B3, ALAT,
     6:                &                    NTOT, NTAUQ )
     7:                 IMPLICIT REAL*8 (A-H, O-Z)
     8:                 include 'mpif.h'
     9:                 INTEGER  S(3,3,48), IS(3,3)
    10:                 DIMENSION TAU(3,NTAUQ), CTAU(3,NTAUQ), B1(3), B2(3), B3(3)
    11:                 DATA  ONE/1.0D+00/, ZERO/0.0D+00/
    12:           C
    13:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
    14:           C
    15:                 if ( my_rank.eq.0 ) then
    16:                 WRITE(6,1000)
    17:                 endif
    18:            1000 FORMAT(/
    19:                &'   **** SMATCHK: THIS VERSION DOES NOT RECOGNIZE ATOM TYPE.')
    20:           C
    21: +------>        DO 1 I = 1, NTOT
    22: |+----->        DO 2 J = 1, NTOT
    23: ||*---->            DO 3 K1 = 1, 3
    24: |||*--->            DO 3 K2 = 1, 3
    25: |||*---       3     IS(K1,K2) = 0
    26: ||*---->            DO 4 K1 = 1, 3
    27: |||*--->            DO 4 K2 = 1, 3
    28: |||*---       4     IS(K1,K2) = IS(K1,K2) + S(K1,1,I) * S(1,K2,J)
    29: ||             &                          + S(K1,2,I) * S(2,K2,J)
    30: ||             &                          + S(K1,3,I) * S(3,K2,J)
    31: ||              NUM = 0
    32: ||V---->            DO 5 JP = 1, NTOT
    33: |||*--->               DO 6 K1 = 1, 3
    34: ||||*-->               DO 6 K2 = 1, 3
    35: |||||                  IF( IS(K1,K2) .NE. S(K1,K2,JP) ) GO TO 5
    36: ||||*--       6        CONTINUE
    37: |||                 NUM = NUM + 1
    38: ||V----       5     CONTINUE
    39: ||        C
    40: ||              IF( NUM .NE. 1 ) THEN
    41: ||                 if ( my_rank.eq.0 ) then
    42: ||*---->           WRITE(6,1010) NUM, I, J,
    43: ||             &    ( (S(K1,K2,I), K2=1,3), (S(K1,K2,J), K2=1,3),
    44: ||             &      (IS(K1,K2), K2=1,3),  K1 = 1, 3             )
    45: ||                 endif
    46: ||         1010    FORMAT(10X,'  SOMETHING WRONG FOR S MATRIX: ',
    47: ||             &              '  NUM I J = ',3I3/
    48: ||             &   (15X,3I3,3X,3I3,3X,3I3) )
    49: ||                 STOP
    50: ||              END IF
    51: ||        C
    52: |+-----       2 CONTINUE
    53: +------       1 CONTINUE
    54:           C ***
    55:           C    CHECK OF CLOSED ALGEBRA FOR  MATRICES IS COMPLETED
    56:           C ***
    57: +------>        DO 10 IAT = 1, NTAUQ
    58: |               C1 = (  TAU(1,IAT)*B1(1) + TAU(2,IAT)*B1(2)
    59: |              &                         + TAU(3,IAT)*B1(3) ) / ALAT
    60: |               C2 = (  TAU(1,IAT)*B2(1) + TAU(2,IAT)*B2(2)
    61: |              &                         + TAU(3,IAT)*B2(3) ) / ALAT
    62: |               C3 = (  TAU(1,IAT)*B3(1) + TAU(2,IAT)*B3(2)
    63: |              &                         + TAU(3,IAT)*B3(3) ) / ALAT
    64: |         c                                  CTAU(1,IAT) = MOD(C1,ONE)
    65: |         c      IF( CTAU(1,IAT) .LT. ZERO ) CTAU(1,IAT) = CTAU(1,IAT) + ONE
    66: |         c                                  CTAU(2,IAT) = MOD(C2,ONE)
    67: |         c      IF( CTAU(2,IAT) .LT. ZERO ) CTAU(2,IAT) = CTAU(2,IAT) + ONE
    68: |         c                                  CTAU(3,IAT) = MOD(C3,ONE)
    69: |         c      IF( CTAU(3,IAT) .LT. ZERO ) CTAU(3,IAT) = CTAU(3,IAT) + ONE
    70: |         c *** Modified rescaling
    71: |*----->        do i=1,3
    72: ||              call rescale( ctau(i,IAT ) )
    73: |*-----         enddo
    74: +------      10 CONTINUE
    75:           C
    76: +------>        DO 12 IAT = 1, NTAUQ
    77: |+----->        DO 14 IOP = 1, NTOT
    78: ||              CP1 =  CTAU(1,IAT) * DBLE( S(1,1,IOP) )
    79: ||             &     + CTAU(2,IAT) * DBLE( S(2,1,IOP) )
    80: ||             &     + CTAU(3,IAT) * DBLE( S(3,1,IOP) )
    81: ||              CP2 =  CTAU(1,IAT) * DBLE( S(1,2,IOP) )
    82: ||             &     + CTAU(2,IAT) * DBLE( S(2,2,IOP) )
    83: ||             &     + CTAU(3,IAT) * DBLE( S(3,2,IOP) )
    84: ||              CP3 =  CTAU(1,IAT) * DBLE( S(1,3,IOP) )
    85: ||             &     + CTAU(2,IAT) * DBLE( S(2,3,IOP) )
    86: ||             &     + CTAU(3,IAT) * DBLE( S(3,3,IOP) )
    87: ||        c                          C1 = MOD(CP1,ONE)
    88: ||        c      IF( C1 .LT. ZERO )  C1 = C1 + ONE
    89: ||        c                          C2 = MOD(CP2,ONE)
    90: ||        c      IF( C2 .LT. ZERO )  C2 = C2 + ONE
    91: ||        c                          C3 = MOD(CP3,ONE)
    92: ||        c      IF( C3 .LT. ZERO )  C3 = C3 + ONE
    93: ||        c **** Modified rescaling
    94: ||               c1=cp1
    95: ||               c2=cp2
    96: ||               c3=cp3
    97: ||               call rescale(c1)
    98: ||               call rescale(c2)
    99: ||               call rescale(c3)
   100: ||        C
   101: ||                   NUM = 0
   102: ||V---->          DO 16 JAT = 1, NTAUQ
   103: |||               IF( ABS(C1-CTAU(1,JAT)) .GT. 0.1D-04 ) GO TO 16
   104: |||               IF( ABS(C2-CTAU(2,JAT)) .GT. 0.1D-04 ) GO TO 16
   105: |||               IF( ABS(C3-CTAU(3,JAT)) .GT. 0.1D-04 ) GO TO 16
   106: |||                  NUM = NUM + 1
   107: |||       C          WRITE(6,1020) IAT, JAT, IOP
   108: |||       C1020      FORMAT(10X,3X,I4,'-TH ATOM IS MAPPED ON ',I4,'-TH ATOM ',
   109: |||       C    &                      ' BY ',I2,'-TH OPERATION.')
   110: ||V----      16   CONTINUE
   111: ||        C
   112: ||              IF(NUM.EQ.0) THEN
   113: ||              if ( my_rank.eq.0 ) then
   114: ||              WRITE(6,1040) IOP, IAT, C1, C2, C3
   115: ||         1040 FORMAT(10X,'   SYMMETRY OPERATION ',I3,' ON ',I4,'TH ATOM NOT',
   116: ||             &           ' TRANSFORM ANOTHER ATOM.'/
   117: ||             &       10X,'     C1 C2 C3 = ',3D18.10)
   118: ||              endif
   119: ||              STOP
   120: ||              END IF
   121: ||        C
   122: |+-----      14 CONTINUE
   123: +------      12 CONTINUE
   124:           C
   125:                 if ( my_rank.eq.0 ) WRITE(6,1100)
   126:            1100 FORMAT(
   127:                &'                 NORMAL END')
   128:           C
   129:                 RETURN
   130:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:28 2022
FILE NAME: smatchk2.f

PROCEDURE NAME: RESCALE
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   132:                 subroutine rescale(a1)
   133:                 implicit double precision (a-h,o-z)
   134:             998 continue
   135:                 mcyc=0
   136:                 if ( a1.ge. 0.5d0 ) then
   137:                   a1=a1-1.d0
   138:                   mcyc=mcyc+1
   139:                 elseif ( a1.lt. -0.5d0 ) then
   140:                   a1=a1+1.d0
   141:                   mcyc=mcyc+1
   142:                 endif
   143:                 if ( mcyc.eq.0 ) then
   144:                  return
   145:                 else
   146:                 goto 998
   147:                 endif
   148:                 end


