NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:28 2022
FILE NAME: tm_inputs.f

PROCEDURE NAME: AINPUT
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     6:                 SUBROUTINE AINPUT(IOPT,CELLDM,MAXFN,OKSTEP,ZVAL,NBND,
     7:                &                  NFL, NPFL, RCUT,
     8:                &                  GCUT2,GRAT, KCONT,MXBND,dt,ntstep)
     9:                 IMPLICIT REAL*8(A-H,O-Z)
    10:                 include 'mpif.h'
    11:                 DIMENSION IOPT(10,5),CELLDM(6)
    12:                 COMMON/COMFRP/RMIX,TR2,ITCMAX,ITMAX,ITC1,ITC7
    13:                 COMMON/COMINI/MAXG2
    14:                 COMMON/COMFIX/FATM(3,101),NFIX,IFATM(101)
    15:                 COMMON/TMOD/ITMOD
    16:                 COMMON/SUZUKI/IOPTION
    17:                 CHARACTER ATEMP(80)*72,NUL*72,ASAVE(80)*12,
    18:                &          BSAVE(80)*20,A1(72)*1,NAIBU*80
    19:           C
    20:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
    21:           c **** temp check
    22:           c      write(6,*)' my_rank=',my_rank,' sub. AINPUT is working'
    23:           c **** temp check ; end
    24:                 NFIX = 0
    25: +======>        NUL=' '
    26: +------>        DO 2100 I=1,80
    27: |+=====>        ASAVE(I)=' '
    28: |+=====>        BSAVE(I)=' '
    29: |+=====>   2100 ATEMP(I)=' '
    30:                 MAXG2=0
    31:           C****************************************************
    32:           C****************************************************
    33:                 if ( my_rank.eq.0 ) then
    34: +======>        READ(5,1) A1
    35:                 endif
    36:                 call MPI_Bcast(A1,72,MPI_CHARACTER,0,MPI_COMM_WORLD,ierr)
    37:                 if ( my_rank.eq.0 ) then
    38: +======>        WRITE(6,1) A1
    39:                 endif
    40:                 I=0
    41: +======>   9000 if ( my_rank.eq.0 ) READ(5,1) A1
    42:                 call MPI_Bcast(A1,72,MPI_CHARACTER,0,MPI_COMM_WORLD,ierr)
    43:               1 FORMAT(72A1)
    44:                 N=1
    45:            9100 IF(A1(N).EQ.'/') GO TO 9200
    46:                 IF(A1(N).EQ.' ') GO TO 9101
    47:           C
    48:           C
    49:                 J=1
    50:                 I=I+1
    51: +======>        ATEMP(I)=A1(N)
    52:            9110 N=N+1
    53:                 IF(A1(N).EQ.'/') GO TO 9200
    54:                 IF(A1(N).EQ.' ') GO TO 9101
    55: +======>        ATEMP(I)=ATEMP(I)(1:J)//A1(N)
    56:                 J=J+1
    57:                 IF(   N .LT. 72) GO TO 9110
    58:            9101 N=N+1
    59:                 IF(   N .LE. 72) GO TO 9100
    60:                                  GO TO 9000
    61:           C***************************************************
    62:           C     MAIN ROUTINE
    63:           C***************************************************
    64:            9200 L=0
    65: +------>        DO 1000 I=1,80
    66: |               IF(ATEMP(I).EQ.NUL) GO TO 201
    67: |               L=L+1
    68: |         C
    69: |         C
    70: |+----->        DO 140 J=72,1,-1
    71: |+-----     140 IF(ATEMP(I)(J:J).NE.' ') GO TO 141
    72: |         C
    73: |         C
    74: |           141 CONTINUE
    75: |               IEQ=INDEX(ATEMP(I),'=')
    76: |               IF(IEQ.EQ.0) THEN
    77: |+=====>           ASAVE(L)=ATEMP(I)(1:J)
    78: |+=====>           BSAVE(L)=ATEMP(I)(13:32)
    79: |               ELSE
    80: |+=====>           ASAVE(L)=ATEMP(I)(1:IEQ-1)
    81: |+=====>           BSAVE(L)=ATEMP(I)(IEQ+1:J)
    82: |               ENDIF
    83: +------    1000 CONTINUE
    84:             201 JSAVE=L
    85:           C
    86:                 if ( my_rank.eq.0 ) WRITE(6,*) ' # OF COMMANDS = ',JSAVE
    87: +------>        DO 220 I=1,JSAVE
    88: |               if (my_rank.eq.0 ) WRITE(6,221) I,ASAVE(I),BSAVE(I)
    89: +------     220 continue
    90:             221 FORMAT(' NO. ',I2,'  COMMAND = ',A12,' OPERATION = ',A20)
    91:           C
    92: +------>        DO 3000 L=1,JSAVE
    93: |               IF(ASAVE(L)(1:2).EQ.'PP') THEN
    94: |                  IF(INDEX(BSAVE(L),'KB').NE.0) THEN
    95: |                     IOPT(1,1)=0
    96: |                     if ( my_rank.eq.0 ) then
    97: |                     WRITE(6,*) ' KLEINMAN BYLANDER PSEUDOPOTENTIAL IS USED '
    98: |                     endif
    99: |                  ENDIF
   100: |                  IF(INDEX(BSAVE(L),'BHS').NE.0) THEN
   101: |                     IOPT(1,1)=1
   102: |                     if ( my_rank.eq.0 ) then
   103: |                     WRITE(6,*) ' BHS TYPE  PSEUDOPOTENTIAL IS USED '
   104: |                     endif
   105: |                  ENDIF
   106: |                  IF(INDEX(BSAVE(L),'DEBUG').NE.0) THEN
   107: |                     IOPT(1,1)=2
   108: |                     if ( my_rank.eq.0 ) then
   109: |                     WRITE(6,*) ' DEBUG KB PSEUDOPOTENTIAL '
   110: |                     endif
   111: |                  ENDIF
   112: |                  IF(INDEX(BSAVE(L),'SOFT').NE.0) THEN
   113: |                     IOPT(5,1)=0
   114: |                     if ( my_rank.eq.0 ) then
   115: |                     WRITE(6,*) ' SOFT PSEUDOPOTENTIAL IS USED '
   116: |                     endif
   117: |                  ENDIF
   118: |                  IF(INDEX(BSAVE(L),'HARD').NE.0) THEN
   119: |                     IOPT(5,1)=1
   120: |                     if ( my_rank.eq.0 ) then
   121: |                     WRITE(6,*) ' HARD PSEUDOPOTENTIAL IS USED '
   122: |                     endif
   123: |                  ENDIF
   124: |                  IF(INDEX(BSAVE(L),'NOND').NE.0) THEN
   125: |                     IOPT(6,1)=1
   126: |                     if ( my_rank.eq.0 ) then
   127: |                     WRITE(6,*) ' D-COMPONENT IS SET ZERO '
   128: |                     endif
   129: |                  ENDIF
   130: |               ELSEIF(ASAVE(L)(1:4).EQ.'DISP') THEN
   131: |                  IOPT(2,1)=1
   132: |                  if ( my_rank.eq.0 ) then
   133: |                  WRITE(6,*) ' BAND DISPERION IS CALCULATED '
   134: |                  endif
   135: |               ELSEIF(ASAVE(L)(1:4).EQ.'FCHK') THEN
   136: |                  IOPT(2,1)=2
   137: |                  if ( my_rank.eq.0 ) then
   138: |                  WRITE(6,*) ' FORCE IS CHECKED '
   139: |                  endif
   140: |               ELSEIF(ASAVE(L)(1:5).EQ.'STEEP') THEN
   141: |                  IOPT(2,1)=3
   142: |                  if ( my_rank.eq.0 ) then
   143: |                  WRITE(6,*) ' STEEPEST DESCENT '
   144: |                  endif
   145: |               ELSEIF(ASAVE(L)(1:5).EQ.'PROJE') THEN
   146: |                  IOPT(2,1)=4
   147: |                  if ( my_rank.eq.0 ) then
   148: |                  WRITE(6,*) ' ORBITAL PROJECTION ON ATOMS'
   149: |                  endif
   150: |               ELSEIF(ASAVE(L)(1:3).EQ.'GGA') THEN
   151: |                  IOPT(8,2)=1
   152: |                  if ( my_rank.eq.0 ) then
   153: |                  WRITE(6,*) ' GGA is adopted'
   154: |                  endif
   155: |               ELSEIF(ASAVE(L)(1:5).EQ.'FFTWF') THEN
   156: |                  IOPT(2,1)=5
   157: |                  if ( my_rank.eq.0 ) then
   158: |                  WRITE(6,*) ' STORE THE NORM OF WFs'
   159: |                  endif
   160: |               ELSEIF(ASAVE(L)(1:4).EQ.'LDOS') THEN
   161: |                  IF(BSAVE(L)(1:3).EQ.'SMK') THEN
   162: |                     IOPT(10,1)=1
   163: |                     if ( my_rank.eq.0 ) then
   164: |                     WRITE(6,*) ' LDOS: K SAMPLING AS IN SCF'
   165: |                     endif
   166: |                  ELSEIF(BSAVE(L)(1:3).EQ.'NWK') THEN
   167: |                     IOPT(10,1)=2
   168: |                     if ( my_rank.eq.0 ) then
   169: |                     WRITE(6,*) ' LDOS: NEW K SAMPLING '
   170: |                     endif
   171: |                  ENDIF
   172: |               ELSEIF(ASAVE(L)(1:2).EQ.'CD') THEN
   173: |                  IF(BSAVE(L)(1:1).EQ.'I') THEN
   174: |                     IOPT(3,1)=0
   175: |                     if ( my_rank.eq.0 ) then
   176: |                     WRITE(6,*) ' CHARGE DENSITY IS CREADTED INTERNALLY '
   177: |                     endif
   178: |                  ELSEIF(BSAVE(L)(1:1).EQ.'R') THEN
   179: |                     IOPT(3,1)=2
   180: |                     if ( my_rank.eq.0 ) then
   181: |                     WRITE(6,*) ' READ PREVIOUS CHARGE DENSITY FROM FILE20 '
   182: |                     endif
   183: |                  ELSEIF(BSAVE(L)(1:1).EQ.'A') THEN
   184: |                     IOPT(3,1)=4
   185: |                     if ( my_rank.eq.0 ) then
   186: |                     WRITE(6,*) ' MAKE CHARGE FROM OVERLAP OF ATOM CHARGE '
   187: |                     endif
   188: |                  ELSEIF(BSAVE(L)(1:1).EQ.'F') THEN
   189: |                     IOPT(3,1)=1
   190: |                     if ( my_rank.eq.0 ) then
   191: |                     WRITE(6,*) ' READ CHARGE DENSITY FROM FILE20 (REAL SPACE)'
   192: |                     endif
   193: |                  ELSE
   194: |                     IOPT(3,1)=3
   195: |                     if ( my_rank.eq.0 ) then
   196: |                     WRITE(6,*) ' CREATE CHARGE DENSITY FROM READ WAVEFUNCTION'
   197: |                     endif
   198: |                  ENDIF
   199: |               ELSEIF(ASAVE(L)(1:2).EQ.'WF') THEN
   200: |                  IF(BSAVE(L)(1:1).EQ.'I') THEN
   201: |                     IOPT(4,1)=0
   202: |                     if ( my_rank.eq.0 ) then
   203: |                     WRITE(6,*) ' WAVEFUNCTION IS CREADTED INTERNALLY '
   204: |                     endif
   205: |                  ELSE
   206: |                     IOPT(4,1)=1
   207: |                   if ( my_rank.eq.0 ) then
   208: |                    WRITE(NAIBU,'(A20)') BSAVE(L)
   209: |                    READ(NAIBU,'(BN,I20)') MXBND
   210: |                   endif
   211: |                   call MPI_Bcast(MXBND,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   212: |                   if ( my_rank.eq.0 ) then
   213: |                    WRITE(6,*) ' MAX # OF BAND ',MXBND
   214: |                      WRITE(6,*) ' READ PREVIOUS WAVEFUNCTION FROM FILE22 '
   215: |                   endif
   216: |                  ENDIF
   217: |               ELSEIF(ASAVE(L)(1:2).EQ.'CG') THEN
   218: |                     I0 = INDEX(BSAVE(L),'(') + 1
   219: |                     I9 = INDEX(BSAVE(L),')') - 1
   220: |                     I1 = INDEX(BSAVE(L),',')
   221: |                     I2 = INDEX(BSAVE(L)(I1+1:I9),',') + I1
   222: |                     if (my_rank.eq.0 ) then
   223: |                     WRITE(NAIBU,'(A20)') BSAVE(L)(I0:I1-1)
   224: |                     READ(NAIBU,'(BN,I20)') ITC7
   225: |                     endif
   226: |                     call MPI_Bcast(ITC7  ,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   227: |                     if (my_rank.eq.0 ) then
   228: |                     WRITE(NAIBU,'(A20)') BSAVE(L)(I1+1:I2-1)
   229: |                     READ(NAIBU,'(BN,I20)') ITC1
   230: |                     endif
   231: |                     call MPI_Bcast(ITC1  ,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   232: |                     if (my_rank.eq.0 ) then
   233: |                     WRITE(NAIBU,'(A20)') BSAVE(L)(I2+1:I9)
   234: |                     READ(NAIBU,'(BN,I20)') ITCMAX
   235: |                     endif
   236: |                     call MPI_Bcast(ITCMAX,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   237: |                     if (my_rank.eq.0 ) then
   238: |                     WRITE(6,*) ' #CG  STEP IS ',ITC7,ITC1,ITCMAX
   239: |                     endif
   240: |               ELSEIF(ASAVE(L)(1:3).EQ.'SCF') THEN
   241: |                  if (my_rank.eq.0 ) then
   242: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   243: |                  READ(NAIBU,'(BN,I20)') ITMAX
   244: |                  endif
   245: |                  call MPI_Bcast(ITMAX,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   246: |                  if (my_rank.eq.0 ) then
   247: |                  WRITE(6,*) ' #SCF STEP IS ',ITMAX
   248: |                  endif
   249: |               ELSEIF(ASAVE(L)(1:6).EQ.'SUZUKI') THEN
   250: |                  if ( my_rank.eq.0 ) then
   251: |                   WRITE(NAIBU,'(A20)') BSAVE(L)
   252: |                   READ(NAIBU,'(BN,I20)') ioption
   253: |                  endif
   254: |                  call MPI_Bcast(ioption,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   255: |                  if ( ioption.eq.2 ) then
   256: |                    if ( my_rank.eq.0 ) then
   257: |                    write(6,*)' Second order Suzuki-Trotter decomposition!! '
   258: |                    endif
   259: |                  elseif ( ioption.eq.3 ) then
   260: |                    if ( my_rank.eq.0 ) then
   261: |                    write(6,*)' Fourth order Suzuki-Trotter decomposition
   262: |              &  (Ver.1)!! '
   263: |                    endif
   264: |                  elseif ( ioption.eq.4 ) then
   265: |                    if ( my_rank.eq.0 ) then
   266: |                    write(6,*)' Fourth order Suzuki-Trotter decomposition
   267: |              &  (Ver.2)!! '
   268: |                    endif
   269: |                  else
   270: |                    if ( my_rank.eq.0 ) then
   271: |                    write(6,*)' WRONG option for Suzuki-Trotter decompostion'
   272: |                    write(6,*)'    has been assigned !!!  STOPPING '
   273: |                    endif
   274: |                    stop
   275: |                  endif
   276: |               ELSEIF(ASAVE(L)(1:3).EQ.'EXT') THEN
   277: |                  IF(BSAVE(L)(1:3).EQ.'PAN') THEN
   278: |                     IOPT(7,1)=0
   279: |                     if ( my_rank.eq.0 ) then
   280: |                     WRITE(6,*) ' PANDEY EXTRAPOLATION SCHEME (R) IS USED '
   281: |                     endif
   282: |                  ELSEIF(BSAVE(L)(1:3).EQ.'PAG') THEN
   283: |                     IOPT(7,1)=2
   284: |                     if ( my_rank.eq.0 ) then
   285: |                     WRITE(6,*) ' PANDEY EXTRAPOLATION SCHEME (G) IS USED '
   286: |                     endif
   287: |                  ELSEIF(BSAVE(L)(1:3).EQ.'PKB') THEN
   288: |                     IOPT(7,1)=3
   289: |                     if ( my_rank.eq.0 ) then
   290: |                     WRITE(6,*) ' PANDEY-KB EXTRAPOLATION SCHEME IS USED '
   291: |                     endif
   292: |                  ELSEIF(BSAVE(L)(1:3).EQ.'NEX') THEN
   293: |                     IOPT(7,1)=4
   294: |                     if ( my_rank.eq.0 ) then
   295: |                     WRITE(6,*) ' NO EXTRAPOLATION SCHEMES IS USED '
   296: |                     endif
   297: |                  ELSE
   298: |                     IOPT(7,1)=1
   299: |                     if ( my_rank.eq.0 ) then
   300: |                     WRITE(6,*) ' KB EXTRAPOLATION SCHEME IS USED '
   301: |                     endif
   302: |                  ENDIF
   303: |               ELSEIF(ASAVE(L)(1:4).EQ.'TMOD') THEN
   304: |                  if ( my_rank.eq.0 ) then
   305: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   306: |                  READ(NAIBU,'(BN,I10)') ITMOD
   307: |                  endif
   308: |                  call MPI_Bcast(ITMOD,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   309: |                  if ( my_rank.eq.0 ) then
   310: |                  WRITE(6,*) ' FREQUENCY OF MONITOR ',ITMOD
   311: |                  endif
   312: |               ELSEIF(ASAVE(L)(1:4).EQ.'RMIX') THEN
   313: |                  if ( my_rank.eq.0 ) then
   314: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   315: |                  READ(NAIBU,'(BN,E20.0)') RMIX
   316: |                  endif
   317: |                  call MPI_Bcast(RMIX ,1,MPI_DOUBLE_PRECISION
   318: |              &     ,0,MPI_COMM_WORLD,ierr)
   319: |                  if ( my_rank.eq.0 ) then
   320: |                  WRITE(6,*) ' MIXING RATIO IS ',RMIX
   321: |                  endif
   322: |               ELSEIF(ASAVE(L)(1:4).EQ.'CONV') THEN
   323: |                  if ( my_rank.eq.0 ) then
   324: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   325: |                  READ(NAIBU,'(BN,E20.0)') TR2
   326: |                  endif
   327: |                  call MPI_Bcast(TR2,1,MPI_DOUBLE_PRECISION
   328: |              &    ,0,MPI_COMM_WORLD,ierr)
   329: |                  if ( my_rank.eq.0 ) then
   330: |                  WRITE(6,*) ' SCF CONVERGENCE CRITERION IS ',TR2
   331: |                  endif
   332: |               ELSEIF(ASAVE(L)(1:4).EQ.'MAXF') THEN
   333: |                  if ( my_rank.eq.0 ) then
   334: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   335: |                  READ(NAIBU,'(BN,I20)') MAXFN
   336: |                  endif
   337: |                  call MPI_Bcast(MAXFN,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   338: |                  if ( my_rank.eq.0 ) then
   339: |                  WRITE(6,*) ' #G-OPT LOOP IS ',MAXFN
   340: |                  endif
   341: |               ELSEIF(ASAVE(L)(1:4).EQ.'KCON') THEN
   342: |                  if ( my_rank.eq.0 ) then
   343: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   344: |                  READ(NAIBU,'(BN,I20)') KCONT
   345: |                  endif
   346: |                  call MPI_Bcast(KCONT,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   347: |                  if ( my_rank.eq.0 ) then
   348: |                  WRITE(6,*) ' CONTINUATION? KCONT =  ', KCONT
   349: |                  endif
   350: |               ELSEIF(ASAVE(L)(1:4).EQ.'OKST') THEN
   351: |                  if ( my_rank.eq.0 ) then
   352: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   353: |                  READ(NAIBU,'(BN,E20.0)') OKSTEP
   354: |                  endif
   355: |                  call MPI_Bcast(OKSTEP,1,MPI_DOUBLE_PRECISION
   356: |              &                ,0,MPI_COMM_WORLD,ierr)
   357: |                  if ( my_rank.eq.0 ) then
   358: |                  WRITE(6,*) ' AT G-OPT INITIAL DISPLACEMENT IS ',OKSTEP
   359: |                  endif
   360: |               ELSEIF(ASAVE(L)(1:4).EQ.'ALAT') THEN
   361: |                  if ( my_rank.eq.0 ) then
   362: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   363: |                  READ(NAIBU,'(BN,E20.0)') CELLDM(1)
   364: |                  endif
   365: |                  call MPI_Bcast(CELLDM(1),1,MPI_DOUBLE_PRECISION
   366: |              &     ,0,MPI_COMM_WORLD,ierr)
   367: |                  if ( my_rank.eq.0 ) then
   368: |                  WRITE(6,*) ' LATTICE CONSTANT ',CELLDM(1)
   369: |                  endif
   370: |               ELSEIF(ASAVE(L)(1:4).EQ.'ZVAL') THEN
   371: |                  if ( my_rank.eq.0 ) then
   372: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   373: |                  READ(NAIBU,'(BN,E20.0)') ZVAL
   374: |                  endif
   375: |                  call MPI_Bcast(ZVAL,1,MPI_DOUBLE_PRECISION
   376: |              &    ,0,MPI_COMM_WORLD,ierr)
   377: |                  if ( my_rank.eq.0 ) then
   378: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   379: |                  WRITE(6,*) ' #CHARGE IS ',ZVAL
   380: |                  endif
   381: |               ELSEIF(ASAVE(L)(1:4).EQ.'DUAL') THEN
   382: |                  IOPT(5,2)=1
   383: |                  if ( my_rank.eq.0 ) then
   384: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   385: |                  READ(NAIBU,'(BN,E20.0)') GRAT
   386: |                  endif
   387: |                  call MPI_Bcast(GRAT,1,MPI_DOUBLE_PRECISION
   388: |              &    ,0,MPI_COMM_WORLD,ierr)
   389: |                  if ( my_rank.eq.0 ) then
   390: |                  WRITE(6,*) ' DUAL SPACE FORMALISM RATIO = ',GRAT
   391: |                  endif
   392: |                  IF(GRAT.EQ.0.D0) GRAT=1.D0
   393: |               ELSEIF(ASAVE(L)(1:4).EQ.'NBND') THEN
   394: |                  if ( my_rank.eq.0 ) then
   395: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   396: |                  READ(NAIBU,'(BN,I20)') NBND
   397: |                  endif
   398: |                  call MPI_Bcast(NBND,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   399: |                  if ( my_rank.eq.0 ) then
   400: |                  WRITE(6,*) ' #OCCUPIED BAND IS ',NBND
   401: |                  endif
   402: |               ELSEIF(ASAVE(L)(1:4).EQ.'RCUT') THEN
   403: |                  if ( my_rank.eq.0 ) then
   404: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   405: |                  READ(NAIBU,'(BN,E20.0)') RCUT
   406: |                  endif
   407: |                  call MPI_Bcast(RCUT,1,MPI_DOUBLE_PRECISION
   408: |              &    ,0,MPI_COMM_WORLD,ierr)
   409: |                  if ( my_rank.eq.0 ) then
   410: |                  WRITE(6,*) ' RCUT**2 IS (AU) ',RCUT
   411: |                  endif
   412: |               ELSEIF(ASAVE(L)(1:4).EQ.'GCUT') THEN
   413: |                  if ( my_rank.eq.0 ) then
   414: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   415: |                  READ(NAIBU,'(BN,E20.0)') GCUT2
   416: |                  endif
   417: |                  call MPI_Bcast(GCUT2,1,MPI_DOUBLE_PRECISION
   418: |              &    ,0,MPI_COMM_WORLD,ierr)
   419: |                  if ( my_rank.eq.0 ) then
   420: |                  WRITE(6,*) ' GCUT2 IS ',GCUT2
   421: |                  endif
   422: |         c **** Miyamoto
   423: |               elseif(asave(l)(1:2).eq.'ST') then
   424: |                  if(asave(l)(3:4).eq.'ND') then
   425: |                   iopt(1,2)=99
   426: |                   if ( my_rank.eq.0 ) then
   427: |                   write(6,*) ' ****  Standard inputs !!!! *****'
   428: |                   endif
   429: |                  end if
   430: |               elseif(asave(l)(1:2).eq.'dt') then
   431: |                if ( my_rank.eq.0 ) then
   432: |                write(naibu,'(A20)') bsave(l)
   433: |                read( naibu,'(BN,E20.12)') dt
   434: |                endif
   435: |                call MPI_Bcast(dt,1,MPI_DOUBLE_PRECISION
   436: |              &   ,0,MPI_COMM_WORLD,ierr)
   437: |                if ( my_rank.eq.0 ) then
   438: |                write(6,*)' Delta t = ',dt,' a.u.'
   439: |                endif
   440: |               elseif(asave(l)(1:5).eq.'tstep') then
   441: |                if ( my_rank.eq.0 ) then
   442: |                write(naibu,'(A20)') bsave(l)
   443: |                read( naibu,'(BN,I20)')ntstep
   444: |                endif
   445: |                call MPI_Bcast(ntstep,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   446: |         c
   447: |               ELSEIF(ASAVE(L)(1:2).EQ.'AL') THEN
   448: |                     IOPT(1,2)=11
   449: |                     if ( my_rank.eq.0 ) then
   450: |                     WRITE(6,*) ' AL FCC LATTICE'
   451: |                     endif
   452: |               ELSEIF(ASAVE(L)(1:2).EQ.'CB') THEN
   453: |                     IOPT(1,2)=30
   454: |                     if ( my_rank.eq.0 ) then
   455: |                     WRITE(6,*) ' CRISTOBALITE'
   456: |                     endif
   457: |               ELSEIF(ASAVE(L)(1:2).EQ.'SI') THEN
   458: |                  IF(ASAVE(L)(3:4).EQ.'TE') THEN
   459: |                     IOPT(1,2)=1
   460: |                     if ( my_rank.eq.0 ) then
   461: |                     WRITE(6,*) ' SITEST CALCULATION'
   462: |                     endif
   463: |                  ELSEIF(ASAVE(L)(3:4).EQ.'O2') THEN
   464: |                     IOPT(1,2)=2
   465: |                     if ( my_rank.eq.0 ) then
   466: |                     WRITE(6,*) ' SIO2 '
   467: |                     endif
   468: |                  ELSEIF(ASAVE(L)(3:4).EQ.'EP') THEN
   469: |                     IOPT(1,2)=13
   470: |                     if ( my_rank.eq.0 ) then
   471: |                     WRITE(6,*) ' SUPER CELL CALCULATION FOR A-QUARTZ'
   472: |                     endif
   473: |                  ELSEIF(ASAVE(L)(3:5).EQ.'GEH') THEN
   474: |                     IOPT(1,2)=21
   475: |                     if ( my_rank.eq.0 ) then
   476: |                     WRITE(6,*) ' SI/GE + H '
   477: |                     endif
   478: |                  ELSEIF(ASAVE(L)(3:3).EQ.'8') THEN
   479: |                     IOPT(1,2)=5
   480: |                     if ( my_rank.eq.0 ) then
   481: |                     WRITE(6,*) ' SI8 CUBIC LATTICE'
   482: |                     endif
   483: |                  ELSEIF(ASAVE(L)(3:3).EQ.'2') THEN
   484: |                     IOPT(1,2)=0
   485: |                     if ( my_rank.eq.0 ) then
   486: |                     WRITE(6,*) ' SI2 LATTICE'
   487: |                     endif
   488: |                  ELSEIF(ASAVE(L)(3:5).EQ.'SL5') THEN
   489: |                     IOPT(1,2)=6
   490: |                     if ( my_rank.eq.0 ) then
   491: |                     WRITE(6,*) ' 5-LAYER SLAB CALCULATIONS'
   492: |                     endif
   493: |                  ELSEIF(ASAVE(L)(3:6).EQ.'SLH1') THEN
   494: |                     IOPT(1,2)=8
   495: |                     if ( my_rank.eq.0 ) then
   496: |                     WRITE(6,*) ' H-TERMINATED SLAB CALCULATIONS: 1'
   497: |                     endif
   498: |                  ELSEIF(ASAVE(L)(3:6).EQ.'SLH2') THEN
   499: |                     IOPT(1,2)=3
   500: |                     if ( my_rank.eq.0 ) then
   501: |                     WRITE(6,*) ' H-TERMINATED SLAB CALCULATIONS: 2'
   502: |                     endif
   503: |                  ELSEIF(ASAVE(L)(3:6).EQ.'SLH3') THEN
   504: |                     IOPT(1,2)=4
   505: |                     if ( my_rank.eq.0 ) then
   506: |                     WRITE(6,*) ' H-TERMINATED SLAB CALCULATIONS: 3'
   507: |                     endif
   508: |                  ELSEIF(ASAVE(L)(3:6).EQ.'SLH4') THEN
   509: |                     IOPT(1,2)=10
   510: |                     if ( my_rank.eq.0 ) then
   511: |                     WRITE(6,*) ' H-TERMINATED VICINAL SURFACE CALCULATIONS'
   512: |                     endif
   513: |                  ELSEIF(ASAVE(L)(3:6).EQ.'SLH5') THEN
   514: |                     IOPT(1,2)=12
   515: |                     if ( my_rank.eq.0 ) then
   516: |                     WRITE(6,*) ' H-TERMINATED (1,1,10) VICINAL SURFACE '
   517: |                     endif
   518: |                  ELSEIF(ASAVE(L)(3:4).EQ.'H4') THEN
   519: |                     IOPT(1,2)=9
   520: |                     if ( my_rank.eq.0 ) then
   521: |                     WRITE(6,*) ' SIH4(CUBIC CELL) CALCULATIONS'
   522: |                     endif
   523: |                  ELSE
   524: |                     if ( my_rank.eq.0 ) then
   525: |                     WRITE(6,*) ' SUCH A LATTICE IS NOT SUPPORTED HERE '
   526: |                     endif
   527: |                     STOP
   528: |                  ENDIF
   529: |               ELSEIF(ASAVE(L)(1:2).EQ.'KP') THEN
   530: |                  IF(BSAVE(L)(1:1).EQ.'0') THEN
   531: |                     IOPT(2,2)=0
   532: |                     if ( my_rank.eq.0 ) then
   533: |                     WRITE(6,*) ' INTERNAL SAMPLING FOR K-VECTORS'
   534: |                     endif
   535: |                  ELSEIF(BSAVE(L)(1:1).EQ.'1') THEN
   536: |                     IOPT(2,2)=1
   537: |                     if ( my_rank.eq.0 ) then
   538: |                     WRITE(6,*) ' GAMMA SAMPLING '
   539: |                     endif
   540: |                  ELSEIF(BSAVE(L)(1:1).EQ.'2') THEN
   541: |                     IOPT(2,2)=2
   542: |                     if ( my_rank.eq.0 ) then
   543: |                     WRITE(6,*) ' # OF K-POINT = 2 '
   544: |                     endif
   545: |                  ELSEIF(BSAVE(L)(1:1).EQ.'4') THEN
   546: |                     IOPT(2,2)=4
   547: |                     if ( my_rank.eq.0 ) then
   548: |                     WRITE(6,*) ' # OF K-POINT = 4 '
   549: |                     endif
   550: |                  ELSEIF(BSAVE(L)(1:1).EQ.'M') THEN
   551: |                     IOPT(2,2)=100
   552: |                     if ( my_rank.eq.0 ) then
   553: |                     WRITE(6,*) ' MESH SAMPLING FOR K-VECTROS'
   554: |                     endif
   555: |                  ELSE
   556: |                     if ( my_rank.eq.0 ) then
   557: |                     WRITE(6,*) ' SUCH A KPOINT SAMPLING IS NOT SUPPORTED HERE'
   558: |                     endif
   559: |                     STOP
   560: |                  ENDIF
   561: |         C
   562: |               ELSEIF(ASAVE(L)(1:5).EQ.'METAL') THEN
   563: |                  IF(INDEX(BSAVE(L),',').NE.0) THEN
   564: |                     I1=INDEX(BSAVE(L),'(')+1
   565: |                     I2=INDEX(BSAVE(L),',')-1
   566: |                     if ( my_rank.eq.0 ) then
   567: |                     WRITE(NAIBU,'(A20)') BSAVE(L)(I1:I2)
   568: |                     READ(NAIBU,'(BN,I20)') NFL
   569: |                     endif
   570: |                     call MPI_Bcast(NFL,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   571: |                     I1=INDEX(BSAVE(L),',')+1
   572: |                     I2=INDEX(BSAVE(L),')')-1
   573: |                     if ( my_rank.eq.0 ) then
   574: |                     WRITE(NAIBU,'(A20)') BSAVE(L)(I1:I2)
   575: |                     READ(NAIBU,'(BN,I20)') NPFL
   576: |                     endif
   577: |                     call MPI_Bcast(NPFL,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   578: |                  ELSE
   579: |                     if ( my_rank.eq.0 ) then
   580: |                     WRITE(6,*) ' ******  CHECK YOUR INPUT... METAL = ?'
   581: |                     endif
   582: |                     STOP
   583: |                  ENDIF
   584: |                     if ( my_rank.eq.0 ) then
   585: |                     WRITE(6,*) ' METAL CASE: NFL NPFL = ', NFL, NPFL
   586: |                     endif
   587: |         C
   588: |               ELSEIF(ASAVE(L)(1:5).EQ.'FORCE') THEN
   589: |                  I0=INDEX(BSAVE(L),'(')+1
   590: |                  I9=INDEX(BSAVE(L),')')-1
   591: |                  I1=INDEX(BSAVE(L),',')
   592: |                  I2=INDEX(BSAVE(L)(I1+1:I9),',')+I1
   593: |                  I3=INDEX(BSAVE(L)(I2+1:I9),',')+I2
   594: |                  NFIX=NFIX+1
   595: |                  if ( my_rank.eq.0 ) then
   596: |                  WRITE(NAIBU,'(A20)') BSAVE(L)(I0:I1-1)
   597: |                  READ(NAIBU,'(BN,I20)') IFATM(NFIX)
   598: |                  endif
   599: |                  call MPI_Bcast(IFATM(NFIX),1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   600: |                  if ( my_rank.eq.0 ) then
   601: |                  WRITE(NAIBU,'(A20)') BSAVE(L)(I1+1:I2-1)
   602: |                  READ(NAIBU,'(BN,F20.0)') XX
   603: |                  endif
   604: |                  call MPI_Bcast(XX,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
   605: |                  if ( my_rank.eq.0 ) then
   606: |                  WRITE(NAIBU,'(A20)') BSAVE(L)(I2+1:I3-1)
   607: |                  READ(NAIBU,'(BN,F20.0)') YY
   608: |                  endif
   609: |                  call MPI_Bcast(YY,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
   610: |                  if ( my_rank.eq.0 ) then
   611: |                  WRITE(NAIBU,'(A20)') BSAVE(L)(I3+1:I9)
   612: |                  READ(NAIBU,'(BN,F20.0)') ZZ
   613: |                  endif
   614: |                  call MPI_Bcast(ZZ,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
   615: |                  RR=SQRT(XX**2+YY**2+ZZ**2)
   616: |                  IF(RR.LT.1.D-5) THEN
   617: |                     RR=0.D0
   618: |                     IFATM(NFIX)=-IFATM(NFIX)
   619: |                  ELSE
   620: |                     RR=1.D0/RR
   621: |                  ENDIF
   622: |                  FATM(1,NFIX)=XX*RR
   623: |                  FATM(2,NFIX)=YY*RR
   624: |                  FATM(3,NFIX)=ZZ*RR
   625: |                  if ( my_rank.eq.0 ) then
   626: |                  WRITE(6,'('' FIXED ATOM '',2I5,3F15.7)')
   627: |              &               NFIX,IFATM(NFIX),XX,YY,ZZ
   628: |                  endif
   629: |               ELSEIF(ASAVE(L)(1:5).EQ.'MAXG2') THEN
   630: |                  if ( my_rank.eq.0 ) then
   631: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   632: |                  READ(NAIBU,'(BN,I20)') MAXG2
   633: |                  endif
   634: |                  call MPI_Bcast(MAXG2,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   635: |                  if ( my_rank.eq.0 ) then
   636: |                  WRITE(6,*) ' #MAXG2 IS ',MAXG2
   637: |                  endif
   638: |               ELSEIF(ASAVE(L)(1:5).EQ.'OUTWF') THEN
   639: |                  if ( my_rank.eq.0 ) then
   640: |                  WRITE(NAIBU,'(A20)') BSAVE(L)
   641: |                  READ(NAIBU,'(BN,I20)') ITEMP
   642: |                  endif
   643: |                  call MPI_Bcast(ITEMP,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   644: |                  if ( my_rank.eq.0 ) then
   645: |                  WRITE(6,*) ' WRITE WF TO FILE ',ITEMP
   646: |                  endif
   647: |                  IOPT(4,2)=ITEMP
   648: |               ELSE
   649: |                  if ( my_rank.eq.0 ) then
   650: |                  WRITE(6,*) ' OPTION ',ASAVE(L),' IS NOT SUPPORTED'
   651: |                  endif
   652: |               ENDIF
   653: +------    3000 CONTINUE
   654:                 if (my_rank.eq.0 ) then
   655:                 WRITE(6,3002)
   656:            3002 FORMAT(' ------------',
   657:                &'------------------------------------------------------------'//)
   658:                 endif
   659:                 RETURN
   660:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:28 2022
FILE NAME: tm_inputs.f

PROCEDURE NAME: CRYST
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   662:                 SUBROUTINE CRYST(NRX,NRY,NRZ,NXYZ,NG,NGQ,
   663:                & NBNDQ,NBND,ZVAL,NFL, NPFL, NUMK,
   664:                & NUMKQ,CELLDM,NTOT,S,VECK,WGT,G,I2G,OMEGA,GCUT,
   665:                & GCUT2,GRAT,GG,I2GG,INDX,OCC,
   666:                & LATQ,RVEC,RCUT,NLV,RR,NWK,
   667:                & NTAUQ,NTYQ,NTYPE,TAU, CTAU, NUMTY,NIDN,
   668:                & RKK,KG,KZ,NSY,NEXPND,
   669:                & RCOSIN,CCO,NKMESH,SK,WK,JDR,MM,NJD, NDX, NDY, NDZ, MXOFL,
   670:                & atmss )
   671:                 IMPLICIT REAL*8 (A-H,O-Z)
   672:                 include 'mpif.h'
   673:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ)
   674:                &        , CTAU(3,NTAUQ), MXOFL(NTYQ)
   675:                 COMMON/AVEC/A1(3),A2(3),A3(3),B1(3),B2(3),B3(3),COVA,ALAT
   676:                 DIMENSION G(4,NGQ),CELLDM(6)
   677:                 DIMENSION GG(4,NGQ),I2GG(NGQ),INDX(NGQ)
   678:                 DIMENSION VECK(3,NUMKQ),WGT(NUMKQ),I2G(NGQ)
   679:                 DIMENSION RR(LATQ),NWK(LATQ),RVEC(4,LATQ),OCC(NBNDQ,NUMKQ)
   680:                 dimension atmss(ntauq)
   681:                 INTEGER*4 S(3,3,48)
   682:                 INTEGER PGIND, RIND(32)
   683:                 COMMON/COMOPT/IOPT(10,5)
   684:                 PARAMETER (IRLATQ=144,NARF=IRLATQ)
   685:                 PARAMETER (NAS=72,NAD=72)
   686:                 DIMENSION RKK(IRLATQ),KG(3,IRLATQ),KZ(3,IRLATQ,48),NSY(IRLATQ)
   687:                 DIMENSION RCOSIN(NAS,IRLATQ),CCO(-NAD:NAD),SK(3,NAS),WK(NAS),
   688:                &          JDR(48,NAS),MM(3,10000),NJD(NAS)
   689:                 DATA RIND/5*1,2*3,6*2,4*1,3*2,7*1,2*2,3*1/
   690:           C
   691:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
   692:           C**********************************************************
   693:           C     SETS UP THE BASIS VECTORS AND INITIAL GEOMETRY.
   694:                 CALL STRUC(CELLDM,IBRAV,PGIND,NK,NBNDQ,NBND,ZVAL,GCUT,
   695:                &  GCUT2,GRAT,A1,A2,A3,OMEGA,OCC,NUMKQ,
   696:                &  NTAUQ,NTYQ,TAU,NTYPE,NUMTY,NIDN, MXOFL, COVA, ALAT,atmss )
   697:           C
   698:                 if ( my_rank.eq.0 ) then
   699:                 WRITE(6,3001) IBRAV,PGIND,NFL,NBND,NPFL,NK,RCUT,GCUT,GCUT2
   700:            3001 FORMAT(/' IBRAV = ',I3,' PGIND = ',I3,' NFL = ',I3,
   701:                &       ' NBND = ',I3,' NPFL = ',I3,' NK = ',I3/
   702:                &       ' RCUT = ',F15.7,' GCUT = ',F15.7,' GCUT2 = ',F15.7)
   703: *------>        WRITE(6,3002) (A1(I),A2(I),A3(I),I=1,3),OMEGA
   704:            3002 FORMAT(' A-VECTORS'/,3(' ',3F15.7/),' OMEGA=',F15.7)
   705:                 endif
   706:           C**************ROTATION MATRIX S**********************
   707:           C     OBTAIN THE ROTATION MATRIX(IN REAL SPACE)
   708:           C
   709:                 IF( IOPT(1,2) .EQ. 0 ) THEN
   710:                    CALL SMAT(PGIND,S,NTOT,IBRAV)
   711:           C
   712:           C    **     NO SYMMETRY IS ASSUMED
   713:           CARE  ELSEIF( IOPT(1,2).EQ.5 .OR. IOPT(1,2).EQ.11 .OR.
   714:           C    &        IOPT(1,2).EQ.8 .OR. IOPT(1,2).EQ.9  ) THEN
   715:                 ELSEIF( IOPT(1,2).EQ.5 .OR. IOPT(1,2).EQ.11 .OR.
   716:                &        IOPT(1,2).EQ.8 .OR. IOPT(1,2).EQ.3  .OR.
   717:                &        IOPT(1,2).EQ.4 .OR. IOPT(1,2).EQ.10 .OR.
   718:                &        IOPT(1,2).EQ.12 .OR. IOPT(1,2).EQ.1 .OR.
   719:                &        IOPT(1,2).EQ.2  .OR. IOPT(1,2).EQ.21 .OR.
   720:                &        IOPT(1,2).EQ.13 .OR. IOPT(1,2).EQ.30     ) THEN
   721:                   NTOT=1
   722: +------>          DO 53 I3=1,NTOT
   723: |*----->          DO 53 I2=1,3
   724: ||*---->          DO 53 I1=1,3
   725: |||                 S(I1,I2,I3)=0
   726: ||*----      53   CONTINUE
   727: *------>          DO 54 I1=1,3
   728: |                   S(I1,I1,1)=1
   729: *------      54   CONTINUE
   730:           C
   731:                 ELSE IF(IOPT(1,2).EQ.6) THEN
   732:           C ******   D2D SYMMETRY FOR A1=(0.5,0.5,0), A2=(-0.5,0.5,0)
   733:           C                           A3=(0,0,1)
   734:                   NTOT=8
   735: V------>            DO 60 IOP = 1, NTOT
   736: |*----->            DO 60 K1 = 1, 3
   737: ||*---->            DO 60 K2 = 1, 3
   738: ||*----      60     S(K1,K2,IOP) = 0
   739: *------>          DO 62 K1 = 1, 3
   740: *------      62   S(K1,K1,1) = 1
   741:           C ***      3C(2)
   742:                   S(1,2,2) = -1
   743:                   S(2,1,2) = -1
   744:                   S(3,3,2) = -1
   745:           C
   746:                   S(1,2,3) =  1
   747:                   S(2,1,3) =  1
   748:                   S(3,3,3) = -1
   749:           C
   750:                   S(1,1,4) = -1
   751:                   S(2,2,4) = -1
   752:                   S(3,3,4) =  1
   753:           C ***     2 MIRRORS
   754:                   S(1,1,5) =  1
   755:                   S(2,2,5) = -1
   756:                   S(3,3,5) =  1
   757:           C
   758:                   S(1,1,6) = -1
   759:                   S(2,2,6) =  1
   760:                   S(3,3,6) =  1
   761:           C ***     2 ADDITIONAL S(4)
   762:                   S(1,2,7) = -1
   763:                   S(2,1,7) =  1
   764:                   S(3,3,7) = -1
   765:           C
   766:                   S(1,2,8) =  1
   767:                   S(2,1,8) = -1
   768:                   S(3,3,8) = -1
   769:                 ELSE IF(IOPT(1,2).EQ.9) THEN
   770:           C ******   D2D SYMMETRY FOR A1=(1,0,0), A2=(0,1,0)
   771:           C                           A3=(0,0,1)
   772:                   NTOT=8
   773: V------>            DO 360 IOP = 1, NTOT
   774: |*----->            DO 360 K1 = 1, 3
   775: ||*---->            DO 360 K2 = 1, 3
   776: ||*----     360     S(K1,K2,IOP) = 0
   777: *------>          DO 362 K1 = 1, 3
   778: *------     362   S(K1,K1,1) = 1
   779:           C ***      3C(2)
   780:                   S(1,1,2) =  1
   781:                   S(2,2,2) = -1
   782:                   S(3,3,2) = -1
   783:           C
   784:                   S(1,1,3) = -1
   785:                   S(2,2,3) =  1
   786:                   S(3,3,3) = -1
   787:           C
   788:                   S(1,1,4) = -1
   789:                   S(2,2,4) = -1
   790:                   S(3,3,4) =  1
   791:           C ***     2 MIRRORS
   792:                   S(1,2,5) =  1
   793:                   S(2,1,5) =  1
   794:                   S(3,3,5) =  1
   795:           C
   796:                   S(1,2,6) = -1
   797:                   S(2,1,6) = -1
   798:                   S(3,3,6) =  1
   799:           C ***     2 ADDITIONAL S(4)
   800:                   S(1,2,7) =  1
   801:                   S(2,1,7) = -1
   802:                   S(3,3,7) = -1
   803:           C
   804:                   S(1,2,8) = -1
   805:                   S(2,1,8) =  1
   806:                   S(3,3,8) = -1
   807:           c ***  Miyamoto
   808:                 elseif ( iopt(1,2).eq.99 ) then
   809:                  if ( my_rank.eq.0 ) then
   810:                  write(6,*)' Read S-matrices fron file !!'
   811:                  read(55,*)ntot
   812:                  endif
   813:                  call MPI_Bcast(ntot,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   814:                  if ( my_rank.eq.0 ) then
   815: +------>         do 199 ir=1,ntot
   816: |*----->          read(55,*)irot,((s(i,j,ir),j=1,3),i=1,3)
   817: +------     199  continue
   818:                  endif
   819:                  nsize=3*3*48
   820:                  call MPI_Bcast(S,nsize,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
   821:                 ELSE
   822:                   if ( my_rank.eq.0 ) then
   823:                   WRITE(6,*) '  ***  IOPT(1,2) = ', IOPT(1,2), ' NOT PROGRAMED'
   824:                   endif
   825:                   STOP
   826:                 ENDIF
   827:           C
   828:                 if ( my_rank.eq.0 ) then
   829:                 WRITE(6,*) ' # OF SYMMETRY OPERATIONS: NTOT = ',NTOT
   830:                 WRITE(6,*) ' S MATRICES: OP  1ST RAW   2ND RAW   3RD RAW'
   831: +------>        DO 6662 I3 = 1, NTOT
   832: |*----->   6662 WRITE(6,6660) I3, (  (S(I1,I2,I3),I2=1,3), I1=1,3)
   833:            6660 FORMAT( 7X,I3,3X,3(2X,3I3) )
   834:                 WRITE(6,*) ' '
   835:                 endif
   836:           C******************************************************
   837:           C     GENERATE ALL LATTICE VECTORS INSIDE A RADIUS RCUT
   838:                 CALL LVGEN(A1,A2,A3,LATQ,NLV,RCUT,RVEC,RR,NWK)
   839:                 if ( my_rank.eq.0 ) then
   840:                 WRITE(6,*) '   # OF LATTICE VECTORS: NLV = ',NLV
   841:                 endif
   842:           C***********************************************************
   843:           C     GENERATE ALL RECIPROCAL LATTICE VECTORS INSIDE GCUT
   844:                 CALL GGEN(CELLDM(1),A1,A2,A3,B1,B2,B3,NRX,NRY,NRZ,NXYZ,
   845:                &          NG,NGQ,G,I2G,GCUT,GG,I2GG,INDX)
   846:           C**************SYMMETRY BUSINESS***********************
   847:           C
   848:                 IF(NTOT.NE.1) CALL SMATCHK2( S, TAU, CTAU, B1, B2, B3, CELLDM(1),
   849:                &                            NTOT, NTAUQ )
   850:           C
   851:                 if ( my_rank.eq.0 ) write(6,*) ' SMATCHK2 finished ! '
   852:           C     GENERATE VECK'S AND WEIGHTS WITHIN IRREDUCIBLE BZ
   853:                 IF( IOPT(2,2).EQ.0 ) THEN
   854:                   CALL KWGT( NUMKQ, VECK, WGT, NK, IBRAV, CELLDM, OMEGA,
   855:                &             RIND(PGIND), NUMK )
   856:                 if ( my_rank.eq.0 ) write(6,*) ' KWGT finished ! '
   857:           C *******   SUM OF WGT OVER NUMK SHOULD BE THE INVERSE OF OMEGA
   858: V------>               DO 7002 IK = 1, NUMK
   859: |          7002        WGT(IK) = DBLE(NTOT) * WGT(IK)
   860: |         C               ALSO NKMESH WHICH IS NOT ESSENTIALLY USED SHOULD NOT
   861: |         C               BE ZERO IN NONLOCF
   862: |                      NKMESH = 1
   863: |         C *******
   864: |                 DO 7000 IK = 1, NUMK
   865: V------    7000   WK(IK) = OMEGA * WGT(IK)
   866:                 ELSE IF( IOPT(2,2) .EQ. 100 ) THEN
   867:                 if ( my_rank.eq.0 ) write(6,*) ' begin LVGENX! '
   868:                   CALL LVGENX(A1,A2,A3,S,NTOT,RKK,KG,KZ,NSY,NEXPND)
   869:           c      if ( my_rank.eq.0 ) write(6,*) ' LVGENX finished ! '
   870:           c      write(6,*)' my_rank=',my_rank,' LVGENX finished ! '
   871:                   CALL MESHK(S,NTOT,NUMK,NKMESH,KG,NEXPND,MM,RCOSIN,JDR,SK,
   872:                &           WK,NJD,CCO, NDX, NDY, NDZ )
   873:                 if ( my_rank.eq.0 ) write(6,*) ' MESHK finished ! '
   874:           C
   875:           CARE ****
   876:           c **** Miyamoto 9/6/95
   877:           c        read(5,*)nexpnd
   878:                       IF( NUMK.LT.NEXPND ) THEN
   879:                          NEXPND = MIN( NUMK, NEXPND )
   880:                          if ( my_rank.eq.0 ) then
   881:                          WRITE(6,6600) NEXPND
   882:                          endif
   883:            6600          FORMAT(/20X,'  ****  CRYST: NEXPND CHANGED TO BE ',I3)
   884:                        ELSE
   885:                        END IF
   886:           CARE         NEXPND = 10
   887:           CARE END *****
   888:           C
   889: V------>          DO 55 IK=1,NUMKQ
   890: |                   VECK(1,IK)=0.D0
   891: |                   VECK(2,IK)=0.D0
   892: |                   VECK(3,IK)=0.D0
   893: |                   WGT(IK)=0.D0
   894: V------    55     CONTINUE
   895: V------>          DO 56 IK=1,NUMK
   896: |                   VECK(1,IK)=SK(1,IK)*B1(1)+SK(2,IK)*B2(1)+SK(3,IK)*B3(1)
   897: |                   VECK(2,IK)=SK(1,IK)*B1(2)+SK(2,IK)*B2(2)+SK(3,IK)*B3(2)
   898: |                   VECK(3,IK)=SK(1,IK)*B1(3)+SK(2,IK)*B2(3)+SK(3,IK)*B3(3)
   899: |                   WGT(IK)=WK(IK)/OMEGA
   900: V------    56     CONTINUE
   901:                 ELSEIF(IOPT(2,2).EQ.1) THEN
   902:                    NUMK=1
   903:                    NKMESH = 1
   904:           CARE
   905:                      IF( IOPT(1,2) .EQ. 2 ) THEN
   906:           C ** HEXAGONAL ONE SPECIAL POINT
   907:                        OTH = 0.333333333333333D+00
   908:                        VECK(1,1) = OTH
   909:                        VECK(2,1) = OTH / SQRT(3.0D+00)
   910:                        VECK(3,1) = 0.25D+00 / COVA
   911:                      ELSE IF(IOPT(1,2) .EQ. 30 ) THEN
   912:           C ** TETRAGONAL ONE SPECIAL POINT
   913:                        VECK(1,1) =  0.25d+00
   914:                        VECK(2,1) =  0.25d+00
   915:                        VECK(3,1) =  0.25D+00 / COVA
   916:                      ELSE IF(IOPT(1,2) .EQ. 13 ) THEN
   917:           C ** TRICLINIC SUPERCELL
   918:                        OTH = 1.0D+00 / 9.0D+00
   919:                        VECK(1,1) = - OTH
   920:                        VECK(2,1) =   OTH * SQRT(3.0D+00)
   921:                        VECK(3,1) =   2.0D+00 * OTH / COVA
   922:                      ELSE
   923:           C **  GAMMA POINT
   924:                        VECK(1, 1)=0.000D0
   925:                        VECK(2, 1)=0.000D0
   926:                        VECK(3, 1)=0.000D0
   927:                      END IF
   928:           C **
   929:                    WGT( 1)=1.D0/(OMEGA)
   930:                    WK( 1)=1.D0
   931:                 ELSEIF(IOPT(2,2).EQ.2) THEN
   932:                    if ( my_rank.eq.0 ) then
   933:                     write(6,*)' NUMK=2 IS NOT SUPPORTED'
   934:                    endif
   935:                    STOP
   936:                 ELSEIF(IOPT(2,2).EQ.3) THEN
   937:                    NUMK=3
   938:                    VECK(1, 1)=0.125D0
   939:                    VECK(2, 1)=0.000D0
   940:                    VECK(3, 1)=0.000D0
   941:                    WGT( 1)=1.D0/(3.D0*OMEGA)
   942:                    WK( 1)=1.D0/3.D0
   943:                    VECK(1, 2)=0.000D0
   944:                    VECK(2, 2)=0.125D0
   945:                    VECK(3, 2)=0.000D0
   946:                    WGT( 2)=1.D0/(3.D0*OMEGA)
   947:                    WK( 2)=1.D0/3.D0
   948:                    VECK(1, 3)=0.000D0
   949:                    VECK(2, 3)=0.000D0
   950:                    VECK(3, 3)=0.125D0
   951:                    WGT( 3)=1.D0/(3.D0*OMEGA)
   952:                    WK( 3)=1.D0/3.D0
   953:                 ELSEIF(IOPT(2,2).EQ.4) THEN
   954:                    NUMK=4
   955:                    VECK(1, 1)= 0.25D0
   956:                    VECK(2, 1)= 0.25D0
   957:                    VECK(3, 1)= 0.25D0
   958:                    WGT( 1)=1.D0/(4.D0*OMEGA)
   959:                    WK( 1)=1.D0/4.D0
   960:                    VECK(1, 2)=-0.25D0
   961:                    VECK(2, 2)= 0.25D0
   962:                    VECK(3, 2)= 0.25D0
   963:                    WGT( 2)=1.D0/(4.D0*OMEGA)
   964:                    WK( 2)=1.D0/4.D0
   965:                    VECK(1, 3)= 0.25D0
   966:                    VECK(2, 3)=-0.25D0
   967:                    VECK(3, 3)= 0.25D0
   968:                    WGT( 3)=1.D0/(4.D0*OMEGA)
   969:                    WK( 3)=1.D0/4.D0
   970:                    VECK(1, 4)= 0.25D0
   971:                    VECK(2, 4)= 0.25D0
   972:                    VECK(3, 4)=-0.25D0
   973:                    WGT( 4)=1.D0/(4.D0*OMEGA)
   974:                    WK( 4)=1.D0/4.D0
   975:                 ELSEIF(IOPT(2,2).EQ.6) THEN
   976:                    NUMK=4
   977:                    VECK(1, 1)= 0.25D0
   978:                    VECK(2, 1)= 0.25D0
   979:                    VECK(3, 1)= 0.25D0
   980:                    WGT( 1)=1.D0/(4.D0*OMEGA)
   981:                    WK( 1)=1.D0/4.D0
   982:                    VECK(1, 2)=-0.25D0
   983:                    VECK(2, 2)= 0.25D0
   984:                    VECK(3, 2)= 0.25D0
   985:                    WGT( 2)=1.D0/(4.D0*OMEGA)
   986:                    WK( 2)=1.D0/4.D0
   987:                    VECK(1, 3)= 0.25D0
   988:                    VECK(2, 3)=-0.25D0
   989:                    VECK(3, 3)= 0.25D0
   990:                    WGT( 3)=1.D0/(4.D0*OMEGA)
   991:                    WK( 3)=1.D0/4.D0
   992:                    VECK(1, 4)= 0.25D0
   993:                    VECK(2, 4)= 0.25D0
   994:                    VECK(3, 4)=-0.25D0
   995:                    WGT( 4)=1.D0/(4.D0*OMEGA)
   996:                    WK( 4)=1.D0/4.D0
   997:                 ELSEIF(IOPT(2,2).EQ.5) THEN
   998:                    NUMK=4
   999:                    VECK(1, 1)= 1.D0/SQRT(32.D0)
  1000:                    VECK(2, 1)= 1.D0/SQRT(32.D0)
  1001:                    VECK(3, 1)= 1.D0/8.D0
  1002:                    WGT( 1)=1.D0/(4.D0*OMEGA)
  1003:                    WK( 1)=1.D0/4.D0
  1004:                    VECK(1, 2)=-1.D0/SQRT(32.D0)
  1005:                    VECK(2, 2)= 1.D0/SQRT(32.D0)
  1006:                    VECK(3, 2)= 1.D0/8.D0
  1007:                    WGT( 2)=1.D0/(4.D0*OMEGA)
  1008:                    WK( 2)=1.D0/4.D0
  1009:                    VECK(1, 3)= 1.D0/SQRT(32.D0)
  1010:                    VECK(2, 3)=-1.D0/SQRT(32.D0)
  1011:                    VECK(3, 3)= 1.D0/8.D0
  1012:                    WGT( 3)=1.D0/(4.D0*OMEGA)
  1013:                    WK( 3)=1.D0/4.D0
  1014:                    VECK(1, 4)=-1.D0/SQRT(32.D0)
  1015:                    VECK(2, 4)=-1.D0/SQRT(32.D0)
  1016:                    VECK(3, 4)= 1.D0/8.D0
  1017:                    WGT( 4)=1.D0/(4.D0*OMEGA)
  1018:                    WK( 4)=1.D0/4.D0
  1019:                 ENDIF
  1020:                    IF(NUMK.LE.0.OR.NUMK.GT.NUMKQ) then
  1021:                     if ( my_rank.eq.0 ) write(6,*)' NUMK'
  1022:                     STOP
  1023:                    ENDIF
  1024:           C
  1025:                 if ( my_rank.eq.0 ) then
  1026: +------>        DO 811 IK=1,NUMK
  1027: |*----->    811 WRITE(6,812) IK,(VECK(KK,IK),KK=1,3)
  1028:             812 FORMAT(' ***   CRYST: VECK(',I2,') =',3(F10.5,3X))
  1029: +------>        DO 3004 K2 = 1, NUMK
  1030: |+----->   3004 WRITE(6,3003) K2, ( OCC(K1,K2), K1 = 1, NFL + NPFL )
  1031:            3003 FORMAT(' OCC: K2 = ',I3/(7X,5F12.4))
  1032:                 endif
  1033:           C
  1034:                 RETURN
  1035:                 END


NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:28 2022
FILE NAME: tm_inputs.f

PROCEDURE NAME: STRUC
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1037:                 SUBROUTINE STRUC(CELLDM,IBRAV,PGIND,NK,NBNDQ,NBND,ZVAL,
  1038:                &  GCUT,GCUT2,GRAT,A1,A2,A3,OMEGA,OCC,NUMKQ,
  1039:                &  NTAUQ,NTYQ,
  1040:                &  TAU,NTYPE,NUMTY,NIDN, MXOFL, COVA, ALAT,atmss )
  1041:                 IMPLICIT REAL*8 (A-H,O-Z)
  1042:                 include 'mpif.h'
  1043:           C
  1044:                 PARAMETER (ZERO=0.D0, UM=1.D0, TRES=3.D0)
  1045:           C
  1046:                 CHARACTER*1 IOP(3,3),JOP(3),IP
  1047:                 DIMENSION AVEC(3,3),RAT(3),DRAT(3)
  1048:                 REAL*8 CELLDM(6)
  1049:                 INTEGER PGIND
  1050:                 DIMENSION TAU(3,NTAUQ),NUMTY(NTYQ),NIDN(NTAUQ,NTYQ)
  1051:                &         ,OCC(NBNDQ,NUMKQ), MXOFL(NTYQ)
  1052:                 DIMENSION A1(3),A2(3),A3(3)
  1053:                 dimension atmss(ntauq)
  1054:                 COMMON/COMOPT/IOPT(10,5)
  1055:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1056:                 PI=4.D0*ATAN(1.D0)
  1057:           C   FOLLOWING PARAMETER (IBRAV,PGIND,NK) IS VALID IN SI2 CALCULATION
  1058:           C     IBRAV=FCC TYPE BRAVAIS LATTICE
  1059:                 IBRAV=0
  1060:                 NK = 0
  1061:           C     PGIND IS THE POINT-GROUP INDEX, WHICH DETERMINES THE IRREDUCIBLE
  1062:           C     WEDGE FOR THE GIVEN STRUCTURE.
  1063:           C
  1064:           C     POINT GROUP CHARACTERISTIC IS OF TD.
  1065:                 PGIND=0
  1066:           C
  1067:           C     CELLDM(1) IS THE LATTICE CONSTANT (THE STANDARD CRYSTALLOGRAPHIC
  1068:           C     BASAL-PLANE DIMENSION A) IN ATOMIC UNITS.
  1069:           C     REQUIRED VALUES OF CELLDM(I),I>1 ARE GIVEN IN THE TABLE BELOW FOR
  1070:           C     EACH POINT GROUP AND BRAVAIS LATTICE.
  1071:           C
  1072:           C
  1073:           C     SI-SI DISTANCE
  1074:           C     RSI=4.44D0
  1075:           C     SIMPLE CUBIC LATTICE,  EIGHT ATOMS IN A UNIT CELL
  1076:           CELLDM(1)=ALAT
  1077:           CELLDM(2)=B/A
  1078:           CELLDM(3)=C/A
  1079:           CELLDM(4)=COS(BC)
  1080:           CELLDM(5)=COS(AC)
  1081:           CELLDM(6)=COS(AB)
  1082:           C     Alat=RSI/(SQRT(3.D0)*0.25D0)
  1083:           C                      /VACANCY/ LATTICE CONSTANT
  1084:                 ALAT=CELLDM(1)
  1085:           C
  1086:           C
  1087:                 IF(IOPT(5,2).EQ.0) THEN
  1088:                    GCUT=(GCUT2*4.D0)/((PI*2.D0/CELLDM(1))**2 )
  1089:                 ELSE
  1090:                    if (my_rank.eq.0 ) then
  1091:                    WRITE(6,*) ' !!! DUAL SPACE FORMALISM MAY NOT WORK WELL !!!'
  1092:                    endif
  1093:                    GCUT=(GCUT2*GRAT)/((PI*2.D0/CELLDM(1))**2 )
  1094:                 ENDIF
  1095:           C
  1096:                     IF( ZVAL.LT.0.1D00 ) then
  1097:                      if ( my_rank.eq.0 ) write(6,*)' **  STRUC:  ZVAL = 0 ???'
  1098:                      STOP
  1099:                     ENDIF
  1100:                     NBND =  ZVAL + 0.1D-04
  1101:                     IF( MOD(NBND,2) .EQ. 0 ) THEN
  1102:                          IFLAG = 0
  1103:                          NBND = NBND / 2
  1104:                     ELSE
  1105:                          IFLAG = 1
  1106:                          NBND = NBND / 2 + 1
  1107:                     END IF
  1108: W------>                      DO 120 K=1,NUMKQ
  1109: |*----->                      DO 120 I=1,NBNDQ
  1110: |*-----     120               OCC(I,K)=0.D0
  1111: +------>            DO 121 K=1,NUMKQ
  1112: |V----->            DO 122 I=1,NBND
  1113: |V-----     122     OCC(I,K)=1.D0
  1114: |                   IF( IFLAG .EQ. 1) OCC(NBND,K) = 0.5D+00
  1115: +------     121     CONTINUE
  1116:           C
  1117:           C
  1118:           C     THERE ARE ONE TYPE OF ATOMS.
  1119:           C
  1120:                 IF(IOPT(1,2).EQ.0) THEN
  1121:           C   SI 2
  1122:                   IBRAV = 2
  1123:                   PGIND = 31
  1124:                   NK = 3
  1125:                   NTYPE=1
  1126:                   NUMTY(1)=NTAUQ
  1127: V------>          DO 711 I=1,NTAUQ
  1128: V------     711   NIDN(I,1)=I
  1129:                   MXOFL(1) = 2
  1130: *------>          DO 712 IR=1,3
  1131: |                 A1(IR)=0.D0
  1132: |                 A2(IR)=0.D0
  1133: *------     712   A3(IR)=0.D0
  1134:           C     IBRAV=2:FCC
  1135:           C     A1=(-A/2,  0,A/2)
  1136:           C     A2=(   0,A/2,A/2)
  1137:           C     A3=(-A/2,A/2,  0)
  1138:                   TERM=CELLDM(1)/2.D0
  1139:                   A1(1)=-TERM
  1140:                   A1(3)=TERM
  1141:                   A2(2)=TERM
  1142:                   A2(3)=TERM
  1143:                   A3(1)=-TERM
  1144:                   A3(2)=TERM
  1145:                   TAU(1,1)=0.D0
  1146:                   TAU(2,1)=0.D0
  1147:                   TAU(3,1)=0.D0
  1148:                   TAU(1,2)=ALAT/4.D0
  1149:                   TAU(2,2)=ALAT/4.D0
  1150:                   TAU(3,2)=ALAT/4.D0
  1151:                 ELSEIF(IOPT(1,2).EQ.1) THEN
  1152:           C   ***   SITEST:   SI2 CASE
  1153:                   NTYPE=1
  1154:                   NUMTY(1)=NTAUQ
  1155: V------>          DO 731 I=1,NTAUQ
  1156: V------     731   NIDN(I,1)=I
  1157:                   MXOFL(1) = 2
  1158: *------>          DO 732 IR=1,3
  1159: |                 A1(IR)=0.D0
  1160: |                 A2(IR)=0.D0
  1161: *------     732   A3(IR)=0.D0
  1162:           C     A1=( A/2,   0, A/2)
  1163:           C     A2=( A/2, A/2,   0)
  1164:           C     A3=(   0, A/2, A/2)
  1165:                   TERM=CELLDM(1)/2.D0
  1166:                   A1(1) =  TERM
  1167:                   A1(3) =  TERM
  1168:                   A2(1) =  TERM
  1169:                   A2(2) =  TERM
  1170:                   A3(2) =  TERM
  1171:                   A3(3) =  TERM
  1172:                   TAU(1,1)=0.D0
  1173:                   TAU(2,1)=0.D0
  1174:                   TAU(3,1)=0.D0
  1175:                   TAU(1,2)=ALAT/4.D0
  1176:                   TAU(2,2)=ALAT/4.D0
  1177:                   TAU(3,2)=ALAT/4.D0
  1178:                 ELSEIF(IOPT(1,2).EQ.2 .OR. IOPT(1,2).EQ.30 ) THEN
  1179:           C  **           O2 OR SIO2
  1180:           C         O2
  1181:           CARE    NTYPE = 1
  1182:           C       NUMTY(1) = NTAUQ
  1183:           C       MXOFL(1) = 1
  1184:           C       DO 800 IR=1,3
  1185:           C       A1(IR)=0.D0
  1186:           C       A2(IR)=0.D0
  1187:           C 800   A3(IR)=0.D0
  1188:           C       DO 810 I = 1, NUMTY(1)
  1189:           C 810   NIDN(I,1) = I
  1190:           C       A1(1) =  ALAT
  1191:           C       A2(2) =  ALAT
  1192:           C       A3(3) =  ALAT
  1193:           C       READ(5,*) DIST
  1194:           C
  1195:           C       DO 820 K = 1, 3
  1196:           C       DO 820 ITAU = 1, NUMTY(1)
  1197:           C 820   TAU(K,ITAU) = 0.0D+00
  1198:           C       TAU(3,1) =   0.5D+00 * DIST
  1199:           C       TAU(3,2) = - 0.5D+00 * DIST
  1200:           CARE  **  ALPHA QUARTZ or CRISTOBALITE
  1201:                   NTYPE = 2
  1202:                   NUMTY(1) = NTAUQ / 3
  1203:                   NUMTY(2) = 2 * NUMTY(1)
  1204:                     NUMCHK = NUMTY(1) + NUMTY(2)
  1205:                     IF( NUMCHK .NE. NTAUQ ) THEN
  1206:                        if ( my_rank.eq.0 ) WRITE(6,801) NUMTY(1), NUMTY(2), NTAUQ
  1207:             801        FORMAT(' ** STRUC  SIO2:  NUMTY(1) NUMTY(2) NTAUQ = ',3I5)
  1208:                        STOP
  1209:                     END IF
  1210:                   MXOFL(1) = 2
  1211:                   MXOFL(2) = 1
  1212: *------>          DO 800 IR=1,3
  1213: |                 A1(IR)=0.D0
  1214: |                 A2(IR)=0.D0
  1215: *------     800   A3(IR)=0.D0
  1216: V------>          DO 810 I = 1, NUMTY(1)
  1217: V------     810   NIDN(I,1) = I
  1218: V------>          DO 812 I = 1, NUMTY(2)
  1219: V------     812   NIDN(I,2) = I + NUMTY(1)
  1220:                   if ( my_rank.eq.0 ) then
  1221:                   READ(5,*) COVA, U, X, Y, Z
  1222:                   endif
  1223:                   call MPI_Bcast(COVA,1,MPI_DOUBLE_PRECISION
  1224:                &   ,0,MPI_COMM_WORLD,ierr)
  1225:                   call MPI_Bcast(U   ,1,MPI_DOUBLE_PRECISION
  1226:                &   ,0,MPI_COMM_WORLD,ierr)
  1227:                   call MPI_Bcast(X   ,1,MPI_DOUBLE_PRECISION
  1228:                &   ,0,MPI_COMM_WORLD,ierr)
  1229:                   call MPI_Bcast(Y   ,1,MPI_DOUBLE_PRECISION
  1230:                &   ,0,MPI_COMM_WORLD,ierr)
  1231:                   call MPI_Bcast(Z   ,1,MPI_DOUBLE_PRECISION
  1232:                &   ,0,MPI_COMM_WORLD,ierr)
  1233:                     if( iopt(1,2) .eq. 2 ) then
  1234:                   A1(1) =                    0.5D+00 * ALAT
  1235:                   A1(2) = - 0.5D+00 * SQRT(3.0D+00 ) * ALAT
  1236:                   A2(1) =                    0.5D+00 * ALAT
  1237:                   A2(2) =   0.5D+00 * SQRT(3.0D+00 ) * ALAT
  1238:                   A3(3) =                       COVA * ALAT
  1239:           C
  1240:                   OTH = 0.3333333333333333D+00
  1241: *------>          DO 820 K = 1, 3
  1242: |                 TAU(K,1) = - U * ( A1(K) + A2(K) ) + OTH * A3(K)
  1243: |                 TAU(K,2) =   U * A1(K)
  1244: |                 TAU(K,3) =   U * A2(K) - OTH * A3(K)
  1245: |                 TAU(K,4) =   X * A1(K) + Y * A2(K) + Z * A3(K)
  1246: |                 TAU(K,5) =   (Y-X) * A1(K) - X * A2(K) + (Z+OTH) * A3(K)
  1247: |                 TAU(K,6) = - Y * A1(K) + (X-Y) * A2(K) + (Z-OTH) * A3(K)
  1248: |                 TAU(K,7) =   (X-Y) * A1(K) - Y * A2(K) - Z * A3(K)
  1249: |                 TAU(K,8) =   Y * A1(K) + X * A2(K) - (Z+OTH) * A3(K)
  1250: *------     820   TAU(K,9) = - X * A1(K) + (Y-X) * A2(K) - (Z-OTH) * A3(K)
  1251:           
  1252:           Care *** Tau for Cristobalite  by A.Yokozawa *****
  1253:           
  1254:                       else if( iopt(1,2) .eq. 30 ) then
  1255:                   A1(1) =    ALAT
  1256:                   A2(2) =    ALAT
  1257:                   A3(3) =    COVA * ALAT
  1258: *------>          DO 823 K = 1, 3
  1259: |                 TAU(K, 1) =   U * ( A1(K) + A2(K) )
  1260: |                 TAU(K, 2) =  -U * ( A1(K) + A2(K) ) + 0.5 * A3(K)
  1261: |                 TAU(K, 3) =  (0.5-U) * A1(K) + (0.5+U) * A2(K) - 0.25 * A3(K)
  1262: |                 TAU(K, 4) =  (0.5+U) * A1(K) + (0.5-U) * A2(K) + 0.75 * A3(K)
  1263: |                 TAU(K, 5) =   X * A1(K) + Y * A2(K) + Z * A3(K)
  1264: |                 TAU(K, 6) =  -X * A1(K) - Y * A2(K) + (0.5+Z) * A3(K)
  1265: |                 TAU(K, 7) =  (0.5-Y) * A1(K) + (0.5+X) * A2(K)+(Z+0.25) * A3(K)
  1266: |                 TAU(K, 8) =  (0.5+Y) * A1(K) + (0.5-X) * A2(K)+(Z+0.75) * A3(K)
  1267: |                 TAU(K, 9) =   Y * A1(K) + X * A2(K) - Z * A3(K)
  1268: |                 TAU(K,10) =  -Y * A1(K) - X * A2(K) + (0.5-Z) * A3(K)
  1269: |                 TAU(K,11) =  (0.5-X) * A1(K) + (0.5+Y) * A2(K)+(0.25-Z) * A3(K)
  1270: *------     823   TAU(K,12) =  (0.5+X) * A1(K) + (0.5-Y) * A2(K)+(0.75-Z) * A3(K)
  1271:                       end if
  1272:           C
  1273:                   if ( my_rank.eq.0 ) then
  1274:                   READ(5,*) IREAD
  1275:                   endif
  1276:                   call MPI_Bcast(IREAD,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1277:                   IF(IREAD.EQ.1) THEN
  1278:                     if ( my_rank.eq.0 ) then
  1279: +------>            DO 821 I = 1, NTAUQ
  1280: |*----->    821     READ(76,*) ( TAU(K,I), K = 1, 3 )
  1281:                     endif
  1282:                     call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1283:                &     ,0,MPI_COMM_WORLD,ierr)
  1284:                   END IF
  1285:           CARE END
  1286:                 ELSEIF(IOPT(1,2).EQ.13) THEN
  1287:           CARE  **  ALPHA QUARTZ:  TRICLINIC SUPER CELL
  1288:           C        NTYPE = 2
  1289:           C        NUMTY(1) = NTAUQ / 3
  1290:           C        NUMTY(2) = 2 * NUMTY(1)
  1291:           C          NUMCHK = NUMTY(1) + NUMTY(2)
  1292:           C          IF( NUMCHK .NE. NTAUQ ) THEN
  1293:           C             WRITE(6,801) NUMTY(1), NUMTY(2), NTAUQ
  1294:           C             STOP
  1295:           C          END IF
  1296:           C        MXOFL(1) = 2
  1297:           C        MXOFL(2) = 1
  1298:           C        DO 880 IR=1,3
  1299:           C        A1(IR)=0.D0
  1300:           C        A2(IR)=0.D0
  1301:           C  880   A3(IR)=0.D0
  1302:           C        DO 882 I = 1, NUMTY(1)
  1303:           C  882   NIDN(I,1) = I
  1304:           C        DO 884 I = 1, NUMTY(2)
  1305:           C  884   NIDN(I,2) = I + NUMTY(1)
  1306:           C        READ(5,*) COVA
  1307:           C        A1(1) =                    1.5D+00 * ALAT
  1308:           C        A1(2) =   0.5D+00 * SQRT(3.0D+00 ) * ALAT
  1309:           C        A2(2) =             SQRT(3.0D+00 ) * ALAT
  1310:           C        A3(1) =                    0.5D+00 * ALAT
  1311:           C        A3(2) =   0.5D+00 * SQRT(3.0D+00 ) * ALAT
  1312:           C        A3(3) =                       COVA * ALAT
  1313:           C
  1314:           C          DO 888 I = 1, NTAUQ
  1315:           C  888     READ(76,*) ( TAU(K,I), K = 1, 3 )
  1316:           CARE END
  1317:           CARE  **  OXYGEN VACANCY IN ALPHA QUARTZ:  TRICLINIC SUPER CELL
  1318:                   NTYPE = 2
  1319:                   NUMTY(1) = 9
  1320:                   NUMTY(2) = 17
  1321:                   MXOFL(1) = 2
  1322:                   MXOFL(2) = 1
  1323: *------>          DO 880 IR=1,3
  1324: |                 A1(IR)=0.D0
  1325: |                 A2(IR)=0.D0
  1326: *------     880   A3(IR)=0.D0
  1327: V------>          DO 882 I = 1, NUMTY(1)
  1328: V------     882   NIDN(I,1) = I
  1329: V------>          DO 884 I = 1, NUMTY(2)
  1330: V------     884   NIDN(I,2) = I + NUMTY(1)
  1331:                   if ( my_rank.eq.0 ) then
  1332:                   READ(5,*) COVA
  1333:                   endif
  1334:                   call MPI_Bcast(COVA,1,MPI_DOUBLE_PRECISION
  1335:                &    ,0,MPI_COMM_WORLD,ierr)
  1336:                   A1(1) =                    1.5D+00 * ALAT
  1337:                   A1(2) =   0.5D+00 * SQRT(3.0D+00 ) * ALAT
  1338:                   A2(2) =             SQRT(3.0D+00 ) * ALAT
  1339:                   A3(1) =                    0.5D+00 * ALAT
  1340:                   A3(2) =   0.5D+00 * SQRT(3.0D+00 ) * ALAT
  1341:                   A3(3) =                       COVA * ALAT
  1342:           C
  1343:                     if ( my_rank.eq.0 ) then
  1344: +------>            DO 888 I = 1, NTAUQ
  1345: |         CC888     READ(76,*) IDUMM, ( TAU(K,I), K = 1, 3 )
  1346: |*----->    888     READ(76,*) ( TAU(K,I), K = 1, 3 )
  1347:                     endif
  1348:                     call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1349:                &     ,0,MPI_COMM_WORLD,ierr)
  1350:           CARE END
  1351:           c ***** Miyamoto
  1352:           c      for standard inputs
  1353:           c
  1354:                 elseif(iopt(1,2).eq.99) then
  1355:           cccc        read(5,*) alat   ! read in AINPUT
  1356:                   if ( my_rank.eq.0 ) then
  1357: *------>          read(5,*)(avec(i,1),i=1,3)
  1358: *------>          read(5,*)(avec(i,2),i=1,3)
  1359: *------>          read(5,*)(avec(i,3),i=1,3)
  1360:                   endif
  1361:                   call MPI_Bcast(avec,3*3,MPI_DOUBLE_PRECISION
  1362:                &    ,0,MPI_COMM_WORLD,ierr)
  1363: *------>          do 991 i=1,3
  1364: |                  a1(i)=alat*avec(i,1)
  1365: |                  a2(i)=alat*avec(i,2)
  1366: |                  a3(i)=alat*avec(i,3)
  1367: *------     991   continue
  1368:                   if ( my_rank.eq.0 ) read(5,*)ntype
  1369:                   call MPI_Bcast(ntype,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1370:                   ntseq=0
  1371: +------>          do 992 ity=1,ntype
  1372: |                  if ( my_rank.eq.0 ) then
  1373: |                  read(5,*)numty(ity),mxofl(ity),amass
  1374: |                  endif
  1375: |                  call MPI_Bcast(numty(ity),1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1376: |                  call MPI_Bcast(mxofl(ity),1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1377: |                  call MPI_Bcast(amass     ,1,MPI_DOUBLE_PRECISION
  1378: |              &    ,0,MPI_COMM_WORLD,ierr)
  1379: |+----->            do 993 it=1,abs(numty(ity))
  1380: ||                   ntseq=ntseq+1
  1381: ||                   if (ntseq.gt.ntauq ) then
  1382: ||                    if ( my_rank.eq.0 ) then
  1383: ||                    write(6,*) ' NTAUQ should be grater than ',ntseq
  1384: ||                    endif
  1385: ||                    stop
  1386: ||                   endif
  1387: ||                   atmss(ntseq)=amass
  1388: ||                   nidn(it,ity)=ntseq
  1389: ||                   if ( my_rank.eq.0 ) then
  1390: ||+---->             read(5,*)(rat(i),i=1,3)
  1391: ||                   endif
  1392: ||                   call MPI_Bcast(rat,3,MPI_DOUBLE_PRECISION
  1393: ||             &      ,0,MPI_COMM_WORLD,ierr)
  1394: ||                   tau(1,ntseq)=a1(1)*rat(1)+a2(1)*rat(2)+a3(1)*rat(3)
  1395: ||                   tau(2,ntseq)=a1(2)*rat(1)+a2(2)*rat(2)+a3(2)*rat(3)
  1396: ||                   tau(3,ntseq)=a1(3)*rat(1)+a2(3)*rat(2)+a3(3)*rat(3)
  1397: |+-----     993     continue
  1398: +------     992   continue
  1399:           cc
  1400:                 ELSEIF(IOPT(1,2).EQ.11) THEN
  1401:           C   AL
  1402:                   NTYPE=1
  1403:                   MXOFL(1) = 2
  1404:                   NUMTY(1)=NTAUQ
  1405: V------>          DO 721 I=1,NTAUQ
  1406: V------     721   NIDN(I,1)=I
  1407:                   if ( my_rank.eq.0 ) then
  1408:                   READ(5,100) ALAT
  1409:                   endif
  1410:                   call MPI_Bcast(ALAT,1,MPI_DOUBLE_PRECISION
  1411:                &     ,0,MPI_COMM_WORLD,ierr)
  1412:                   if ( my_rank.eq.0 ) then
  1413:                   WRITE(6,200) ALAT
  1414:                   endif
  1415:                   CELLDM(1)=ALAT
  1416:           C
  1417:           C     READ THE BASIS VECTORS FOR THE LATTICE (CARTESIAN COORDINATES
  1418:           C     AND ATOMIC UNITS DIVIDED BY ASCALE). MODIFY ACCORDING TO IOP..
  1419:           C     MULTIPLY BY ALAT.
  1420:           C
  1421:                   if ( my_rank.eq.0 ) then
  1422: *------>          READ(5,101) (IOP(I,1),AVEC(I,1),I=1,3)
  1423: *------>          READ(5,101) (IOP(I,2),AVEC(I,2),I=1,3)
  1424: *------>          READ(5,101) (IOP(I,3),AVEC(I,3),I=1,3)
  1425:                   endif
  1426:                   call MPI_Bcast(IOP, 3*3,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1427:                   call MPI_Bcast(AVEC,3*3,MPI_DOUBLE_PRECISION
  1428:                &   ,0,MPI_COMM_WORLD,ierr)
  1429: +------>          DO 10 J=1,3
  1430: |*----->          DO 10 I=1,3
  1431: ||                  SGN=UM
  1432: ||                  IF(AVEC(I,J).LT.ZERO) SGN=-UM
  1433: ||                  AVEC(I,J)=ABS(AVEC(I,J))
  1434: ||                  IF(IOP(I,J).EQ.'S') AVEC(I,J)=SQRT(AVEC(I,J))
  1435: ||                  IF(IOP(I,J).EQ.'C') AVEC(I,J)=AVEC(I,J)**(UM/TRES)
  1436: ||                  IF(IOP(I,J).EQ.'T') AVEC(I,J)=AVEC(I,J)/TRES
  1437: ||                  IF(IOP(I,J).EQ.'H') AVEC(I,J)=AVEC(I,J)/SQRT(TRES)
  1438: ||                  AVEC(I,J)=SGN*ALAT*AVEC(I,J)
  1439: |*-----      10   CONTINUE
  1440: *------>          DO 11 I=1,3
  1441: |                   A1(I)=AVEC(I,1)
  1442: |                   A2(I)=AVEC(I,2)
  1443: |                   A3(I)=AVEC(I,3)
  1444: *------      11   CONTINUE
  1445:                   if ( my_rank.eq.0 ) READ(5,*) NUMAT
  1446:                   call MPI_Bcast(NUMAT,1,MPI_INTETGER,0,MPI_COMM_WORLD,ierr)
  1447:                   IF(NUMAT.NE.NTAUQ) THEN
  1448:                     WRITE(6,*) ' ERROR IN NUMBER OF ATOMS '
  1449:                   ENDIF
  1450: +------>          DO 12 JA=1,NTAUQ
  1451: |                   if ( my_rank.eq.0 ) then
  1452: |*----->            READ(5,101) (JOP(I),RAT(I),I=1,3),IP
  1453: |                   endif
  1454: |                   call MPI_Bcast(JOP,3,MPI_INTEGER  ,0,MPI_COMM_WORLD,ierr)
  1455: |                   call MPI_Bcast(RAT,3,MPI_DOUBLE_PRECISION
  1456: |              &        ,0,MPI_COMM_WORLD,ierr)
  1457: |                   call MPI_Bcast( IP,1,MPI_CHARACTER,0,MPI_COMM_WORLD,ierr)
  1458: |*----->            DO 13 I=1,3
  1459: ||                    SGN=UM
  1460: ||                    IF(RAT(I).LT.ZERO) SGN=-UM
  1461: ||                    RAT(I)=ABS(RAT(I))
  1462: ||                    IF(JOP(I).EQ.'S') RAT(I)=SQRT(RAT(I))
  1463: ||                    IF(JOP(I).EQ.'C') RAT(I)=RAT(I)**(UM/TRES)
  1464: ||                    IF(JOP(I).EQ.'T') RAT(I)=RAT(I)/TRES
  1465: ||                    RAT(I)=SGN*RAT(I)
  1466: |*-----      13     CONTINUE
  1467: |                   IF(IP.NE.' ') THEN
  1468: |                     if ( my_rank.eq.0 ) then
  1469: |*----->              READ(5,101) (JOP(I),DRAT(I),I=1,3)
  1470: |                     endif
  1471: |                     call MPI_Bcast(JOP,3,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1472: |                     call MPI_Bcast(DRAT,3,MPI_DOUBLE_PRECISION
  1473: |              &       ,0,MPI_COMM_WORLD,ierr)
  1474: |*----->              DO 14 I=1,3
  1475: ||                      SGN=UM
  1476: ||                      IF(DRAT(I).LT.ZERO) SGN=-UM
  1477: ||                      DRAT(I)=ABS(DRAT(I))
  1478: ||                      IF(JOP(I).EQ.'S') DRAT(I)=SQRT(DRAT(I))
  1479: ||                      IF(JOP(I).EQ.'C') DRAT(I)=DRAT(I)**(UM/TRES)
  1480: ||                      IF(JOP(I).EQ.'T') DRAT(I)=DRAT(I)/TRES
  1481: ||                      DRAT(I)=SGN*DRAT(I)
  1482: ||                      RAT(I)=RAT(I)+DRAT(I)
  1483: |*-----      14       CONTINUE
  1484: |                   ENDIF
  1485: |                   TAU(1,JA)=RAT(1)*A1(1)+RAT(2)*A2(1)+RAT(3)*A3(1)
  1486: |                   TAU(2,JA)=RAT(1)*A1(2)+RAT(2)*A2(2)+RAT(3)*A3(2)
  1487: |                   TAU(3,JA)=RAT(1)*A1(3)+RAT(2)*A2(3)+RAT(3)*A3(3)
  1488: +------      12   CONTINUE
  1489:                   if ( my_rank.eq.0 ) READ(5,*) IBRAV,PGIND
  1490:                   call MPI_Bcast(IBRAV,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1491:                   call MPI_Bcast(PGIND,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  1492:           C
  1493:                 ELSEIF(IOPT(1,2).EQ.5) THEN
  1494:           C     SI8 CUBIC STRUCTURE
  1495:                    IBRAV=1
  1496:                    PGIND=1
  1497:                    ALAT=CELLDM(1)
  1498:                    NTYPE=1
  1499:                    MXOFL(1) = 2
  1500:                    NUMTY(1)=NTAUQ
  1501: V------>           DO 31 I=1,NTAUQ
  1502: V------      31    NIDN(I,1)=I
  1503: *------>           DO 32 IR=1,3
  1504: |                  A1(IR)=0.D0
  1505: |                  A2(IR)=0.D0
  1506: *------      32    A3(IR)=0.D0
  1507:           C        CUBIC 8 ATOMS
  1508:           C        A1=(  A,  0,  0)
  1509:           C        A2=(  0,  A,  0)
  1510:           C        A3=(  0,  0,  A)
  1511:                    A1(1)=ALAT
  1512:                    A2(2)=ALAT
  1513:                    A3(3)=ALAT
  1514:           C
  1515:                   if ( my_rank.eq.0 ) then
  1516: +------>          DO 33 J=1,NTAUQ
  1517: |*----->     33   READ(76,*) (TAU(I,J),I=1,3)
  1518:                   endif
  1519:                   call MPI_Bcast(tau,3*NTAUQ,MPI_DOUBLE_PRECISION
  1520:                &   ,0,MPI_COMM_WORLD,ierr)
  1521:           C **
  1522:                 ELSEIF(IOPT(1,2).EQ.6) THEN
  1523:           C               SI SLAB
  1524:                    ALAT=CELLDM(1)
  1525:                    NTYPE=1
  1526:                    MXOFL(1) = 2
  1527:                    NUMTY(1)=NTAUQ
  1528: V------>           DO 35 I=1,NTAUQ
  1529: V------      35    NIDN(I,1)=I
  1530: *------>           DO 36 IR=1,3
  1531: |                  A1(IR)=0.D0
  1532: |                  A2(IR)=0.D0
  1533: *------      36    A3(IR)=0.D0
  1534:                    A1(1) =   0.5D+00 * ALAT
  1535:                    A1(2) =   0.5D+00 * ALAT
  1536:                    A2(1) = - 0.5D+00 * ALAT
  1537:                    A2(2) =   0.5D+00 * ALAT
  1538:           C ***       SI XTAL (5 LAYER)
  1539:           C                 A3(3) =   ALAT
  1540:           C ***       SI (100)  (5 LAYER + 6-LAYER VACUUM)
  1541:           C                 A3(3) =   2.5D+00 * ALAT
  1542:           C ***       SI (100)  (9 LAYER + 6-LAYER VACUUM)
  1543:           C                 A3(3) =   3.5D+00 * ALAT
  1544:                      if ( my_rank.eq.0 )READ(5,*) A3(3)
  1545:                      call MPI_Bcast(A3(3),1,MPI_DOUBLE_PRECISION
  1546:                &      ,0,MPI_COMM_WORLD,ierr)
  1547:                      A3(3) = A3(3) * ALAT
  1548:           C
  1549:                   if ( my_rank.eq.0 ) then
  1550: +------>          DO 37 J=1,NTAUQ
  1551: |*----->     37   READ(5,*) (TAU(I,J),I=1,3)
  1552:                   endif
  1553:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1554:                &    ,0,MPI_COMM_WORLD,ierr)
  1555:           C ***
  1556:                 ELSEIF(IOPT(1,2).EQ.9) THEN
  1557:           C     SIH4 CUBIC STRUCTURE
  1558:                    ALAT=CELLDM(1)
  1559:                    NTYPE=2
  1560:                    NUMTY(1)=1
  1561:                    MXOFL(1) = 2
  1562:           C ** FOR LOCAL POTENTIAL ONLY, SET NUMTY BE NEGATIVE.
  1563:                        NUMTY(2)= - ( NTAUQ-NUMTY(1) )
  1564:                        MXOFL(2) = 0
  1565:           C **
  1566: +------>           DO 631 I=1,ABS(NUMTY(1))
  1567: +------     631    NIDN(I,1)=I
  1568: V------>           DO 639 I=1,ABS(NUMTY(2))
  1569: V------     639    NIDN(I,2)=I + NUMTY(1)
  1570: *------>           DO 632 IR=1,3
  1571: |                  A1(IR)=0.D0
  1572: |                  A2(IR)=0.D0
  1573: *------     632    A3(IR)=0.D0
  1574:           C        CUBIC 8 ATOMS
  1575:           C        A1=(  A,  0,  0)
  1576:           C        A2=(  0,  A,  0)
  1577:           C        A3=(  0,  0,  A)
  1578:                    A1(1)=ALAT
  1579:                    A2(2)=ALAT
  1580:                    A3(3)=ALAT
  1581:           C
  1582:                   if ( my_rank.eq.0 ) then
  1583: +------>          DO 633 J=1,NTAUQ
  1584: |*----->    633   READ(5,*) (TAU(I,J),I=1,3)
  1585:                   endif
  1586:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1587:                &   ,0,MPI_COMM_WORLD,ierr)
  1588:           C **
  1589:           C
  1590:                 ELSEIF( IOPT(1,2) .EQ. 21 ) THEN
  1591:           C     SI/GE PLUS H
  1592:                    ALAT = CELLDM(1)
  1593:                    NTYPE=3
  1594:           C ** TYPE 1 = GE, TYPE 2 = SI, TYPE 3 = H
  1595:                    NUMTY(1) = 10
  1596:                    NUMTY(2) = 2
  1597:                    NUMTY(3) = - 4
  1598:                    MXOFL(1) = 2
  1599:                    MXOFL(2) = 2
  1600:                    MXOFL(3) = 0
  1601: V------>           DO 645 I=1,ABS(NUMTY(1))
  1602: V------     645    NIDN(I,1) = I + 2
  1603:                    NIDN(1,2) = 1
  1604:                    NIDN(2,2) = 2
  1605: V------>           DO 646 I=1,ABS(NUMTY(3))
  1606: V------     646    NIDN(I,3) = I + ABS(NUMTY(1)) + ABS(NUMTY(2))
  1607:                    A1(1) =   0.5D+00  *   ALAT
  1608:                    A1(2) = - 0.5D+00  *   ALAT
  1609:                    A1(3) =   0.0D+00
  1610:                    A2(1) =   1.0D+00  *   ALAT
  1611:                    A2(2) =   1.0D+00  *   ALAT
  1612:                    A2(3) =   0.0D+00
  1613:                    A3(1) =   0.0D+00
  1614:                    A3(2) =   0.0D+00
  1615:                    A3(3) =   2.75D+00 *   ALAT
  1616:           C
  1617:                   if ( my_rank.eq.0 ) then
  1618: +------>          DO 648 J=1,NTAUQ
  1619: |*----->    648   READ(76,*) (TAU(I,J),I=1,3)
  1620:                   endif
  1621:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1622:                &   ,0,MPI_COMM_WORLD,ierr)
  1623:           C **
  1624:           C
  1625:                 ELSEIF(IOPT(1,2).EQ.8) THEN
  1626:           C     SISLH1
  1627:                    ALAT=CELLDM(1)
  1628:                    NTYPE=2
  1629:                    NUMTY(1)=10
  1630:                    MXOFL(1) = 2
  1631:           C ** FOR LOCAL POTENTIAL ONLY, SET NUMTY BE NEGATIVE.
  1632:                        NUMTY(2)= - ( NTAUQ-NUMTY(1) )
  1633:                        MXOFL(2) = 0
  1634:           C **
  1635: V------>           DO 640 I=1,ABS(NUMTY(1))
  1636: V------     640    NIDN(I,1)=I
  1637: V------>           DO 641 I=1,ABS(NUMTY(2))
  1638: V------     641    NIDN(I,2)=I + NUMTY(1)
  1639: *------>           DO 642 IR=1,3
  1640: |                  A1(IR)=0.D0
  1641: |                  A2(IR)=0.D0
  1642: *------     642    A3(IR)=0.D0
  1643:           C           2X1 LATERAL CELL
  1644:                    A1(1) =   0.5D+00  * ALAT
  1645:                    A1(2) = - 0.5D+00  * ALAT
  1646:                    A2(1) =              ALAT
  1647:                    A2(2) =              ALAT
  1648:           C TEMP   A3(3) =   2.75D+00 * ALAT
  1649:                    A3(3) =   2.25D+00 * ALAT
  1650:           C
  1651:                   if ( my_rank.eq.0 ) then
  1652: +------>          DO 643 J=1,NTAUQ
  1653: |*----->    643   READ(76,*) (TAU(I,J),I=1,3)
  1654:                   endif
  1655:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1656:                &   ,0,MPI_COMM_WORLD,ierr)
  1657:           C **
  1658:           C **
  1659:           C
  1660:                 ELSEIF(IOPT(1,2).EQ.3) THEN
  1661:           C     SISLH2
  1662:                    ALAT=CELLDM(1)
  1663:                    NTYPE=2
  1664:                    NUMTY(1)=72
  1665:                    MXOFL(1) = 2
  1666:           C ** FOR LOCAL POTENTIAL ONLY, SET NUMTY BE NEGATIVE.
  1667:                        NUMTY(2)= - ( NTAUQ-NUMTY(1) )
  1668:                        MXOFL(2) = 0
  1669:           C **
  1670: V------>           DO 650 I=1,ABS(NUMTY(1))
  1671: V------     650    NIDN(I,1)=I
  1672: V------>           DO 651 I=1,ABS(NUMTY(2))
  1673: V------     651    NIDN(I,2)=I + NUMTY(1)
  1674: *------>           DO 652 IR=1,3
  1675: |                  A1(IR)=0.D0
  1676: |                  A2(IR)=0.D0
  1677: *------     652    A3(IR)=0.D0
  1678:           C           6X2 LATERAL CELL
  1679:                    A1(1) =              ALAT
  1680:                    A1(2) = -            ALAT
  1681:                    A2(1) =   3.00D+00  * ALAT
  1682:                    A2(2) =   3.00D+00  * ALAT
  1683:                    A3(3) =   3.00D+00  * ALAT
  1684:           C
  1685:                   if ( my_rank.eq.0 ) then
  1686: +------>          DO 653 J=1,NTAUQ
  1687: |*----->    653   READ(76,*) (TAU(I,J),I=1,3)
  1688:                   endif
  1689:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1690:                &    ,0,MPI_COMM_WORLD,ierr)
  1691:           C **
  1692:           C **
  1693:           C
  1694:                 ELSEIF(IOPT(1,2).EQ.4) THEN
  1695:           C     SISLH3
  1696:           C ******* CARE
  1697:                    ALAT=CELLDM(1)
  1698:                    NTYPE=2
  1699:           C 2X4    NUMTY(1)=40
  1700:           C 2X8    NUMTY(1)=80
  1701:                    NUMTY(1)=20
  1702:           C        NUMTY(1)=62
  1703:           C 2X6DBN NUMTY(1)=58
  1704:           C 2X1    NUMTY(1)=20
  1705:                    MXOFL(1) = 2
  1706:           C ** FOR LOCAL POTENTIAL ONLY, SET NUMTY BE NEGATIVE.
  1707:                        NUMTY(2)= - ( NTAUQ-NUMTY(1) )
  1708:                        MXOFL(2) = 0
  1709:           C **
  1710: V------>           DO 660 I=1,ABS(NUMTY(1))
  1711: V------     660    NIDN(I,1)=I
  1712: V------>           DO 661 I=1,ABS(NUMTY(2))
  1713: V------     661    NIDN(I,2)=I + NUMTY(1)
  1714: *------>           DO 662 IR=1,3
  1715: |                  A1(IR)=0.D0
  1716: |                  A2(IR)=0.D0
  1717: *------     662    A3(IR)=0.D0
  1718:           C           2X2  2X4  2X6  2X8  LATERAL CELL
  1719:                    A1(1) =              ALAT
  1720:                    A1(2) = -            ALAT
  1721:           CARE     A2(1) =   4.00D+00  * ALAT
  1722:           CARE     A2(2) =   4.00D+00  * ALAT
  1723:           CARE     A2(1) =   3.00D+00  * ALAT
  1724:           CARE     A2(2) =   3.00D+00  * ALAT
  1725:           CARE     A2(1) =   2.00D+00  * ALAT
  1726:           CARE     A2(2) =   2.00D+00  * ALAT
  1727:                    A2(1) =   1.00D+00  * ALAT
  1728:                    A2(2) =   1.00D+00  * ALAT
  1729:                    A3(3) =   2.75D+00  * ALAT
  1730:           CARE     A3(3) =   3.00D+00  * ALAT
  1731:           CARE     A3(3) =   2.50D+00  * ALAT
  1732:           C
  1733:                   if ( my_rank.eq.0 ) then
  1734: +------>          DO 663 J=1,NTAUQ
  1735: |*----->    663   READ(76,*) (TAU(I,J),I=1,3)
  1736:                   endif
  1737:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1738:                &    ,0,MPI_COMM_WORLD,ierr)
  1739:           C **
  1740:           C **
  1741:           C
  1742:                 ELSEIF(IOPT(1,2).EQ.10) THEN
  1743:           C     SISLH4:  VICINAL SURFACE
  1744:                    ALAT=CELLDM(1)
  1745:                    NTYPE=2
  1746:           CARE ***    NON-REBONDED DB CASE AND OTHERS
  1747:           CARE     NUMTY(1)=62
  1748:                    NUMTY(1)=63
  1749:           CARE     NUMTY(1)=64
  1750:                    MXOFL(1) = 2
  1751:           CARE END ****
  1752:           C ** FOR LOCAL POTENTIAL ONLY, SET NUMTY BE NEGATIVE.
  1753:                        NUMTY(2)= - ( NTAUQ-NUMTY(1) )
  1754:                        MXOFL(2) = 0
  1755:           C **
  1756: V------>           DO 670 I=1,ABS(NUMTY(1))
  1757: V------     670    NIDN(I,1)=I
  1758: V------>           DO 671 I=1,ABS(NUMTY(2))
  1759: V------     671    NIDN(I,2)=I + NUMTY(1)
  1760: *------>           DO 672 IR=1,3
  1761: |                  A1(IR)=0.D0
  1762: |                  A2(IR)=0.D0
  1763: *------     672    A3(IR)=0.D0
  1764:           C          (1,1,15) VICINAL SURFACE
  1765:                    A1(1) =              ALAT
  1766:                    A1(2) = -            ALAT
  1767:                    A2(1) =   3.50D+00  * ALAT
  1768:                    A2(2) =   4.00D+00  * ALAT
  1769:                    A2(3) = - 0.50D+00  * ALAT
  1770:           C ****  TEMP CARE
  1771:                          THICK =  26.0D+00
  1772:           C ****
  1773:                    A3(1) =              THICK / SQRT( 227.0D+00 )
  1774:                    A3(2) =              THICK / SQRT( 227.0D+00 )
  1775:                    A3(3) =   15.0D+00 * THICK / SQRT( 227.0D+00 )
  1776:           C
  1777:                   if ( my_rank.eq.0 ) then
  1778: +------>          DO 673 J=1,NTAUQ
  1779: |*----->    673   READ(76,*) JDUMMY, (TAU(I,J),I=1,3)
  1780:                   endif
  1781:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1782:                &   ,0,MPI_COMM_WORLD,ierr)
  1783:           CARE    DO 673 J=1,NTAUQ
  1784:           C 673   READ(76,*)         (TAU(I,J),I=1,3)
  1785:           C **
  1786:           C **
  1787:           C
  1788:                 ELSEIF(IOPT(1,2).EQ.12) THEN
  1789:           C     SISLH5:  (1,1,10) VICINAL SURFACE
  1790:                    ALAT=CELLDM(1)
  1791:                    NTYPE=2
  1792:           CARE ***    QB CASE
  1793:                    NUMTY(1)=84
  1794:                    MXOFL(1) = 2
  1795:           CARE END ****
  1796:           C ** FOR LOCAL POTENTIAL ONLY, SET NUMTY BE NEGATIVE.
  1797:                        NUMTY(2)= - ( NTAUQ-NUMTY(1) )
  1798:                        MXOFL(2) = 0
  1799:           C **
  1800: V------>           DO 680 I=1,ABS(NUMTY(1))
  1801: V------     680    NIDN(I,1)=I
  1802: V------>           DO 681 I=1,ABS(NUMTY(2))
  1803: V------     681    NIDN(I,2)=I + NUMTY(1)
  1804: *------>           DO 682 IR=1,3
  1805: |                  A1(IR)=0.D0
  1806: |                  A2(IR)=0.D0
  1807: *------     682    A3(IR)=0.D0
  1808:           C          (1,1,10) VICINAL SURFACE
  1809:                    A1(1) =              ALAT
  1810:                    A1(2) = -            ALAT
  1811:                    A2(1) =   5.0D+00  * ALAT
  1812:                    A2(2) =   5.0D+00  * ALAT
  1813:                    A2(3) = - 1.0D+00  * ALAT
  1814:           C ****  TEMP CARE
  1815:                          THICK =  26.0D+00
  1816:           C ****
  1817:                    A3(1) =              THICK / SQRT( 102.0D+00 )
  1818:                    A3(2) =              THICK / SQRT( 102.0D+00 )
  1819:                    A3(3) =   10.0D+00 * THICK / SQRT( 102.0D+00 )
  1820:           C
  1821:                   if ( my_rank.eq.0 ) then
  1822: +------>          DO 683 J=1,NTAUQ
  1823: |*----->    683   READ(76,*) (TAU(I,J),I=1,3)
  1824:                   endif
  1825:                   call MPI_Bcast(TAU,3*NTAUQ,MPI_DOUBLE_PRECISION
  1826:                &    ,0,MPI_COMM_WORLD,ierr)
  1827:           C **
  1828:           C
  1829:                 ENDIF
  1830:           C
  1831:           C
  1832:                 if ( my_rank.eq.0 ) then
  1833:                 WRITE(6,6000)
  1834:            6000 FORMAT(/
  1835:                & ' INITIAL POSITION OF ATOM IN CARTESIAN COORDINATE IN ATOMIC'
  1836:                &,' UNIT:')
  1837: +------>        DO 314 J=1,NTAUQ
  1838: |*----->    314 WRITE(6,6001) J, (TAU(I,J),I=1,3)
  1839:            6001 FORMAT(3X,I4,2X,3F15.7)
  1840: +------>        WRITE(6,6003) NTYPE, ( NUMTY(J), J=1,NTYPE )
  1841:            6003 FORMAT(5X,'  ****  NTYPE = ',I3,'  NUMTY = ',4I4)
  1842:                 endif
  1843:           C
  1844:           C     WRITE(6,*) ' BAND OCCUPATION FOR NBNDQ BANDS: '
  1845:           C     DO 322 K=1,NUMKQ
  1846:           C 322 WRITE(6,6002) K, (OCC(I,K),I=1,NBNDQ)
  1847:           C6002 FORMAT(3X,'K = ',I3/(7X,6F7.3) )
  1848:           C
  1849:           C
  1850:            1000 OMEGA=0.D0
  1851:                 S=1.D0
  1852:                 I=1
  1853:                 J=2
  1854:                 K=3
  1855: *------>   1001 DO 1002 IPERM=1,3
  1856: |               OMEGA=OMEGA+S*A1(I)*A2(J)*A3(K)
  1857: |               L=I
  1858: |               I=J
  1859: |               J=K
  1860: |               K=L
  1861: *------    1002 CONTINUE
  1862:                 I=2
  1863:                 J=1
  1864:                 K=3
  1865:                 S=-S
  1866:                 IF(S.LT.0.D0) GO TO 1001
  1867:                 OMEGA=ABS(OMEGA)
  1868:           C
  1869:           C
  1870:                 RETURN
  1871:             100 FORMAT(F12.6)
  1872:             101 FORMAT(3(2X,A1,F12.6),1X,A1)
  1873:             200 FORMAT(//,' CRYSTAL STRUCTURE :',//,' LATTICE CONSTANT ',
  1874:                &      F12.5,' (A.U.)',/)
  1875:            7100 FORMAT(3(4X,F14.7))
  1876:                 END


