NEC Fortran Compiler (3.4.2) for Vector Engine   Thu Jul 28 08:27:32 2022
FILE NAME: vpj_gen.f

PROCEDURE NAME: VPJ_GEN
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     2:                 subroutine VPJ_GEN(Gold,G2,NG2Q,NG2,SPB,VPJ,VPJWORK,VPP2
     3:                &                 ,TPIBA,NTYQ,ntype,GMHF,MXOFL
     4:                &    ,RAD,PSPOT,PSPOT2,PHIL,MESHQ,ISPD,NGNL,OMEGA,NGcont
     5:           c
     6:                &    ,mshbegin,mshend,ncpuq  )
     7:                 implicit double precision(a-h,o-z)
     8:                 include 'mpif.h'
     9:                 dimension SPB(NG2Q),G2(4,NG2Q),Gold(4,NG2Q)
    10:           c  *** for G-A version PSDATA need to be common!
    11:           c      PARAMETER(MESHQ=1000, ISPD=8, NTYQ2=4)
    12:           c      COMMON/PSDATA/RAD(MESHQ,NTYQ2),PSPOT(MESHQ,ISPD,NTYQ2),
    13:           c     &    PSPOT2(MESHQ,ISPD,NTYQ2),PHIL(MESHQ,4,NTYQ2)
    14:                 dimension RAD(MESHQ,NTYQ),PSPOT(MESHQ,ISPD,NTYQ),
    15:                &    PSPOT2(MESHQ,ISPD,NTYQ),PHIL(MESHQ,4,NTYQ)
    16:                 dimension MXOFL(ntype),NGNL(ntype)
    17:                 dimension VPJ(NGcont,3,4,NTYQ),VPJWORK(NGcont,3),VPP2(16,3,NTYQ)
    18:           c      include 'ncpuq.h'
    19:           c      common/cputask4/mshbegin(0:ncpuq),mshend(0:ncpuq),ncpu4
    20:                 dimension mshbegin(0:ncpuq),mshend(0:ncpuq)
    21:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
    22:           c ****  for smoothing !!!!
    23:           c *** temp check
    24:           c      if (my_rank.eq.0 ) then
    25:           c      write(6,*) 'in VPJ_GEN mshbegin mshend'
    26:           c       do icpu=1,ncpuq
    27:           c        write(6,*)icpu,mshbegin(icpu),mshend(icpu)
    28:           c       enddo
    29:           c      endif
    30:           c *** temp check : endk
    31:           c *** ADUMP: Smoothing factor for RHO & VHXC
    32:                 PI=dacos(-1.d0)
    33:                 FPI=4.D0*PI
    34:                 pi8=8.d0*pi
    35:                 pi16=16.d0*pi
    36:                 pi32=32.d0*pi
    37:                 GCUT=GMHF*2
    38:                 ADUMP= GCUT
    39:                 ATEMP= ADUMP/10.d0
    40:           c
    41:           c *** temp check
    42:           c      if (my_rank.eq.0 ) then
    43:           c      write(6,*)' check smoothing '
    44:           c      do ity=1,ntype
    45:           c        write(6,*)' NGNL = ',NGNL(ITY),' MXOFL = ',MXOFL(ITY)
    46:           c        if ( MXOFL(ITY).ge.1 ) then
    47:           c         do ig=1,NGNL(ITY)
    48:           c         wari=dexp( ( G2(4,ig)-ADUMP )/ATEMP ) + 1.d0
    49:           c         fac=1.d0/dsqrt(wari )
    50:           c         enddo
    51:           c         write(6,*)' loop ig for fac ended normally'
    52:           c        endif
    53:           c      enddo
    54:           c        write(6,*)' in VPJ_GEN '
    55:           c        write(6,*)' FPI = ',FPI
    56:           c        write(6,*)' GCUT= ',GCUT
    57:           cccc        stop
    58:           c      endif
    59:           c *** temp check end
    60:           c
    61:           c *** temp check
    62:           c      if (my_rank.eq.0) then
    63:           c       write(6,*)' VPJ_GEN: G2 '
    64:           c       do ig=1,NG2Q/6,1000
    65:           c        write(6,'(4F22.16)')(G2(J,IG),J=1,4)
    66:           c       enddo
    67:           c      endif
    68:           c *** temp check :  end
    69: +------>        do ity=1,ntype
    70: |         c *** temp check
    71: |         c      if (my_rank.eq.0 ) then
    72: |         c       write(6,*)' VPJ_GEN: RAD  ITY=',ITY
    73: |         c       write(6,'(4F22.16)')(RAD(K,ITY),K=1,MESHQ,100)
    74: |         c       do il=1,MXOFL(ity)
    75: |         c        write(6,*)' il=',il
    76: |         c        write(6,*)' PHIL '
    77: |         c        write(6,'(4F22.16)')(PHIL(IR,IL,ITY),IR=1,MESHQ,100)
    78: |         c        write(6,*)' PSPOT '
    79: |         c        write(6,'(4F22.16)')(PSPOT(IR,IL,ITY),IR=1,MESHQ,100)
    80: |         c       enddo
    81: |         c      endif
    82: |         c *** temp check end
    83: |         c
    84: |               if (MXOFL(ity).ge.1 ) then
    85: |+----->        do LI=1,MXOFL(ity)
    86: ||              L=LI-1
    87: ||        cc ** clean up VPJWORK for parallel mesh integration
    88: ||V---->        DO IG=1,NGNL(ity)
    89: |||              VPJWORK(IG,1)=0
    90: |||              VPJWORK(IG,2)=0
    91: |||              VPJWORK(IG,3)=0
    92: |||             ENDDO
    93: |||       c
    94: |||       c *** clean up VPJ for mesh integration
    95: |||              do ig=1,NGNL(ity)
    96: |||               VPJ(ig,1,li,ity)=0.d0
    97: |||               VPJ(ig,2,li,ity)=0.d0
    98: |||               VPJ(ig,3,li,ity)=0.d0
    99: ||V----          enddo
   100: ||        c
   101: ||*---->         do j=1,3
   102: |||               if ( LI.eq.1 ) then
   103: |||               VPP2(LI,J,ity)=0.D0
   104: |||               elseif (LI.eq.2) then
   105: |||               VPP2(LI  ,J,ity)=0.D0
   106: |||               VPP2(LI+1,J,ity)=0.D0
   107: |||               VPP2(LI+2,J,ity)=0.D0
   108: |||               elseif (LI.eq.3) then
   109: |||               VPP2(LI+2,J,ity)=0.D0
   110: |||               VPP2(LI+3,J,ity)=0.D0
   111: |||               VPP2(LI+4,J,ity)=0.D0
   112: |||               VPP2(LI+5,J,ity)=0.D0
   113: |||               VPP2(LI+6,J,ity)=0.D0
   114: |||               elseif (LI.eq.4) then
   115: |||               VPP2(LI+6,J,ity)=0.D0
   116: |||               VPP2(LI+7,J,ity)=0.D0
   117: |||               VPP2(LI+8,J,ity)=0.D0
   118: |||               VPP2(LI+9,J,ity)=0.D0
   119: |||               VPP2(LI+10,J,ity)=0.D0
   120: |||               VPP2(LI+11,J,ity)=0.D0
   121: |||               VPP2(LI+12,J,ity)=0.D0
   122: |||               endif
   123: ||*----          enddo
   124: ||        c
   125: ||        C*****LOOP OVER MESH
   126: ||              SUM=0.D0
   127: ||        c      DO 50 I=1,MESH
   128: ||+---->        DO 50 I=mshbegin(my_rank),mshend(my_rank)  ! mesh intergal is MPI para
   129: |||       C*****CONSTRUCT THE SPHERICAL BESSEL FUNCTION J_L(Q1*R)
   130: |||             IF(L.EQ.0) THEN
   131: |||       ccc         IF(G2(4,1).EQ.0.D0) THEN
   132: |||                TEMP=SQRT(G2(4,1))*RAD(I,ity)*TPIBA
   133: |||                IF(TEMP.LE.1.D-7) THEN
   134: |||                   SPB(1)=1.D0
   135: |||                   ISTA=2
   136: |||                ELSE
   137: |||                   ISTA=1
   138: |||                ENDIF
   139: |||       c         DO 42 IG=ISTA,NG2(IK)
   140: |||       c         DO 42 IG=ISTA,NG2
   141: |||       c *** temp
   142: |||       c       if (my_rank.eq.0.and.ISTA.eq.1 ) then
   143: |||       c        write(6,*)' G2*RAD=',G2(4,ISTA)*RAD(I,ITY)
   144: |||       c       endif
   145: |||       c *** temp end
   146: |||V--->           DO 42 IG=ISTA,NGNL(ITY)
   147: ||||               TEMP=SQRT(G2(4,IG))*RAD(I,ity)*TPIBA
   148: ||||      c *** temp check
   149: ||||      c         if (my_rank.eq.0 ) then
   150: ||||      c          write(6,*)' TEMP=',TEMP
   151: ||||      c         endif
   152: ||||      c *** temp check: end
   153: |||V---      42    SPB(IG)=SIN(TEMP)/TEMP
   154: |||             ELSEIF(L.EQ.1) THEN
   155: |||                IF(G2(4,1).EQ.0.D0) THEN
   156: |||                   SPB(1)=0.D0
   157: |||                   ISTA=2
   158: |||                ELSE
   159: |||                   ISTA=1
   160: |||                ENDIF
   161: |||       c         DO 44 IG=ISTA,NG2(IK)
   162: |||       c         DO 44 IG=ISTA,NG2
   163: |||V--->           DO 44 IG=ISTA,NGNL(ITY)
   164: ||||               TEMP=SQRT(G2(4,IG))*RAD(I,ity)*TPIBA
   165: |||V---      44    SPB(IG)=(SIN(TEMP)-TEMP*COS(TEMP))/TEMP**2
   166: |||             ELSEIF(L.EQ.2) THEN ! d-orbital
   167: |||                IF(G2(4,1).EQ.0.D0) THEN
   168: |||                   SPB(1)=0.D0
   169: |||                   ISTA=2
   170: |||                ELSE
   171: |||                   ISTA=1
   172: |||                ENDIF
   173: |||V--->           DO 46 IG=ISTA,NGNL(ITY)
   174: ||||               TEMP=SQRT(G2(4,IG))*RAD(I,ity)*TPIBA
   175: |||V---      46    SPB(IG)=( (3.d0-TEMP**2)*SIN(TEMP)-3.d0*TEMP*COS(TEMP) )
   176: |||            &           /TEMP**3
   177: |||             ELSEIF(L.EQ.3) THEN ! f-orbital
   178: |||                IF(G2(4,1).EQ.0.D0) THEN
   179: |||                   SPB(1)=0.D0
   180: |||                   ISTA=2
   181: |||                ELSE
   182: |||                   ISTA=1
   183: |||                ENDIF
   184: |||V--->           DO 47 IG=ISTA,NGNL(ITY)
   185: ||||               TEMP=SQRT(G2(4,IG))*RAD(I,ity)*TPIBA
   186: ||||               TEMP2=TEMP*TEMP
   187: ||||               TEMP3=TEMP*TEMP2
   188: ||||               TEMP4=TEMP2*TEMP2
   189: ||||               SPB(IG)=( (15.d0-6*TEMP2)*SIN(TEMP)+(TEMP3-15.d0*TEMP)
   190: ||||           &     *COS(TEMP) )  /TEMP4
   191: |||V---      47    CONTINUE
   192: |||             ENDIF
   193: |||       c *** Smoothing !!
   194: |||       c
   195: |||       c *** temp check
   196: |||       c      if (my_rank.eq.0) then
   197: |||       c       write(6,*)' check SPB '
   198: |||       c       write(6,'(4F22.16)')(SPB(IG),IG=1,NGNL(ity),1000)
   199: |||       c      endif
   200: |||       c *** temp check: end
   201: |||       c      do ig=1,NGNL(ITY)
   202: |||       c       wari=dexp( (G2(4,ig)-ADUMP)/ATEMP ) + 1.d0
   203: |||       c       fac=1.d0/dsqrt(wari)
   204: |||       c       SPB(ig)=fac*SPB(ig)
   205: |||       c      enddo
   206: |||       c *** temp check
   207: |||       c      if (my_rank.eq.0) then
   208: |||       c       write(6,*)' check SPB after smoothing '
   209: |||       c       write(6,'(4F22.16)')(SPB(IG),IG=1,NGNL(ity),1000)
   210: |||       c      endif
   211: |||       c *** temp check: end
   212: |||       c
   213: |||V--->        DO 52 IG=1,NGNL(ITY)
   214: ||||      c      VPJ(IG,1,li,ity)=VPJ(IG,1,li,ity)
   215: ||||            VPJWORK(IG,1)=VPJWORK(IG,1)
   216: ||||           &   +FPI*PSPOT (I,LI   ,ity )*PHIL(I,LI,ity)*RAD(I,ity)*SPB(IG)
   217: ||||      c      VPJ(IG,2,li,ity)=VPJ(IG,2,li,ity)
   218: ||||            VPJWORK(IG,2)=VPJWORK(IG,2)
   219: ||||           &   +FPI*PSPOT2(I,LI*2-1,ity)*PHIL(I,LI,ity)*RAD(I,ity)*SPB(IG)
   220: ||||      c      VPJ(IG,3,li,ity)=VPJ(IG,3,li,ity)
   221: ||||            VPJWORK(IG,3)=VPJWORK(IG,3)
   222: ||||           &   +FPI*PSPOT2(I,LI*2  ,ity)*PHIL(I,LI,ity)*RAD(I,ity)*SPB(IG)
   223: |||V---      52 CONTINUE
   224: |||       c *** temp check
   225: |||       c      if (my_rank.eq.0) then
   226: |||       c       write(6,*)' check VPJWORK '
   227: |||       c       write(6,'(4F22.16)')(VPJWORK(IG,1),IG=1,NGNL(ity),1000)
   228: |||       c      endif
   229: |||       c *** temp check
   230: |||       c
   231: ||+----      50 CONTINUE
   232: ||        c
   233: ||        c +++ 2020 begin insert
   234: ||              LngthDat=3*(NGcont)
   235: ||              call MPI_ALLReduce(VPJWORK(1,1),VPJ(1,1,li,ity),LngthDat,
   236: ||             &  MPI_DOUBLE_PRECISION,MPI_SUM, MPI_COMM_WORLD,ierr)
   237: ||        c +++ 2020 end insert
   238: ||        c *** prepare smoothing !! Here cause of the trap!!
   239: ||        c       if (my_rank.eq.0 ) then
   240: ||        c        write(6,*)' in VPJ_GEN '
   241: ||        c        write(6,*)'smoothing exponent factor at ity =',ity
   242: ||        c        write(6,*)' ADUMP ATEMP =',ADUMP,ATEMP
   243: ||        c        write(6,'(4F22.16)')
   244: ||        c     &  ( ((G2(4,ig)-ADUMP)/ATEMP),ig=1,NGNL(ITY),500)
   245: ||        c       endif
   246: ||V---->          do ig=1,NGNL(ITY)
   247: |||                wari=dexp( ( Gold(4,ig)-ADUMP )/ATEMP ) + 1.d0
   248: |||                VPJWORK(IG,1)=1.d0/dsqrt(wari )
   249: ||V----           enddo
   250: ||        c       *** smoothing of VPJ !!
   251: ||*---->         do IP=1,3
   252: |||+--->          do IG=1,NGNL(ITY)
   253: ||||              VPJ(IG,IP,li,ITY)=VPJWORK(IG,1)*VPJ(IG,IP,li,ITY)
   254: |||+---           enddo
   255: ||*----          enddo
   256: ||        c ** smoothing end
   257: ||        c
   258: ||               if ( li.eq.1 ) then  ! s-component
   259: ||*---->         do ip=1,3
   260: |||V--->           do ig=1,NGNL(ITY)
   261: ||||               VPP2(li,ip,ity)=VPP2(li,ip,ity)
   262: ||||           &  +VPJ(ig,ip,li,ity)**2
   263: |||V---            enddo
   264: |||                VPP2(li,ip,ity)=VPP2(li,ip,ity)/fpi/OMEGA
   265: ||*----          enddo
   266: ||               elseif( li.eq.2 ) then ! p-components
   267: ||                if ( G2(4,1).eq.0.D0 ) then
   268: ||                 ISTA=2
   269: ||                else
   270: ||                 ISTA=1
   271: ||                endif
   272: ||+---->         do ip=1,3
   273: |||V--->           do ig=ISTA,NGNL(ITY)
   274: ||||               VPP2(li  ,ip,ity)=VPP2(li  ,ip,ity)
   275: ||||           &  +( VPJ(ig,ip,li,ity)*G2(1,ig) )**2/G2(4,ig)
   276: ||||               VPP2(li+1,ip,ity)=VPP2(li+1,ip,ity)
   277: ||||           &  +( VPJ(ig,ip,li,ity)*G2(2,ig) )**2/G2(4,ig)
   278: ||||               VPP2(li+2,ip,ity)=VPP2(li+2,ip,ity)
   279: ||||           &  +( VPJ(ig,ip,li,ity)*G2(3,ig) )**2/G2(4,ig)
   280: |||V---            enddo
   281: |||                VPP2(li  ,ip,ity)=VPP2(li  ,ip,ity)*3.d0/fpi/OMEGA
   282: |||                VPP2(li+1,ip,ity)=VPP2(li+1,ip,ity)*3.d0/fpi/OMEGA
   283: |||                VPP2(li+2,ip,ity)=VPP2(li+2,ip,ity)*3.d0/fpi/OMEGA
   284: |||       c *** comments: factors of VPP2(3,ip) VPP2(4,ip) are corrected in exnlp  by 1/sqr2
   285: ||+----          enddo
   286: ||              elseif( li.eq.3 ) then ! d-components
   287: ||                if ( G2(4,1).eq.0.D0 ) then
   288: ||                 ISTA=2
   289: ||                else
   290: ||                 ISTA=1
   291: ||                endif
   292: ||+---->         do ip=1,3
   293: |||       c *** attention! (tentative!)
   294: |||                if (G2(4,1).eq.0.d0 ) then
   295: |||                VPP2(li+2,ip,ity)=( VPJ(1,ip,li,ity)*2.d0 )**2
   296: |||                endif
   297: |||       c *** attention end:
   298: |||V--->           do ig=ISTA,NGNL(ITY)
   299: ||||               GG2=G2(4,ig)
   300: ||||               VPP2(li+2,ip,ity)=VPP2(li+2,ip,ity)
   301: ||||           &  +( VPJ(ig,ip,li,ity)*( 3.D0*G2(3,ig)**2/GG2-1.d0 ) )**2
   302: ||||               VPP2(li+3,ip,ity)=VPP2(li+3,ip,ity)
   303: ||||           &  +( VPJ(ig,ip,li,ity)*(G2(1,ig)**2-G2(2,ig)**2)/GG2 )**2
   304: ||||               VPP2(li+4,ip,ity)=VPP2(li+4,ip,ity)
   305: ||||           &  +( VPJ(ig,ip,li,ity)*G2(1,ig)*G2(2,ig)/GG2 )**2
   306: ||||               VPP2(li+5,ip,ity)=VPP2(li+5,ip,ity)
   307: ||||           &  +( VPJ(ig,ip,li,ity)*G2(3,ig)*G2(1,ig)/GG2 )**2
   308: ||||               VPP2(li+6,ip,ity)=VPP2(li+6,ip,ity)
   309: ||||           &  +( VPJ(ig,ip,li,ity)*G2(2,ig)*G2(3,ig)/GG2 )**2
   310: |||V---            enddo
   311: |||                VPP2(li+2,ip,ity)=VPP2(li+2,ip,ity)* 5.d0/pi16/OMEGA
   312: |||                VPP2(li+3,ip,ity)=VPP2(li+3,ip,ity)*15.d0/pi16/OMEGA
   313: |||                VPP2(li+4,ip,ity)=VPP2(li+4,ip,ity)*15.d0/fpi/OMEGA
   314: |||                VPP2(li+5,ip,ity)=VPP2(li+5,ip,ity)*15.d0/fpi/OMEGA
   315: |||                VPP2(li+6,ip,ity)=VPP2(li+6,ip,ity)*15.d0/fpi/OMEGA
   316: ||+----          enddo
   317: ||               elseif( li.eq.4 ) then ! f-components
   318: ||                if ( G2(4,1).eq.0.D0 ) then
   319: ||                 ISTA=2
   320: ||                else
   321: ||                 ISTA=1
   322: ||                endif
   323: ||+---->         do ip=1,3
   324: |||       c         do ig=ISTA,ng2(ik)
   325: |||       c         do ig=ISTA,ng2
   326: |||       c *** attention! (tentative!)
   327: |||                if (G2(4,1).eq.0.d0 ) then
   328: |||                VPP2(li+6,ip,ity)=( VPJ(1,ip,li,ity)*2.d0 )**2
   329: |||                endif
   330: |||       c *** attention end:
   331: |||V--->           do ig=ISTA,NGNL(ITY)
   332: ||||               GX=G2(1,IG)
   333: ||||               GY=G2(2,IG)
   334: ||||               GZ=G2(3,IG)
   335: ||||               GG=dsqrt( G2(4,ig) )
   336: ||||               GG2=G2(4,ig)
   337: ||||               GG3=GG2*GG
   338: ||||               VPP2(li+ 6,ip,ity)=VPP2(li+ 6,ip,ity)
   339: ||||           &  +( VPJ(ig,ip,li,ity)*(5*GZ**2/GG2 -3.D0)*GZ/GG )**2
   340: ||||               VPP2(li+ 7,ip,ity)=VPP2(li+ 7,ip,ity)
   341: ||||           &  +( VPJ(ig,ip,li,ity)*GX*( GX**2 -3*GY**2 )/GG3 )**2
   342: ||||               VPP2(li+ 8,ip,ity)=VPP2(li+ 8,ip,ity)
   343: ||||           &  +( VPJ(ig,ip,li,ity)*GY*( 3*GX**2 -GY**2 )/GG3 )**2
   344: ||||               VPP2(li+ 9,ip,ity)=VPP2(li+ 9,ip,ity)
   345: ||||           &  +( VPJ(ig,ip,li,ity)*GZ*( GX**2 - GY**2  )/GG3 )**2
   346: ||||               VPP2(li+10,ip,ity)=VPP2(li+10,ip,ity)
   347: ||||           &  +( VPJ(ig,ip,li,ity)*2*GZ*GX*GY/GG3 )**2
   348: ||||               VPP2(li+11,ip,ity)=VPP2(li+11,ip,ity)
   349: ||||           &  +( VPJ(ig,ip,li,ity)*GX*(5*GZ**2 - GG2)/GG3 )**2
   350: ||||               VPP2(li+12,ip,ity)=VPP2(li+12,ip,ity)
   351: ||||           &  +( VPJ(ig,ip,li,ity)*GY*(5*GZ**2 - GG2)/GG3 )**2
   352: |||V---            enddo
   353: |||                VPP2(li+ 6,ip,ity)=VPP2(li+ 6,ip,ity)*  7.d0/pi16/OMEGA
   354: |||                VPP2(li+ 7,ip,ity)=VPP2(li+ 7,ip,ity)* 35.d0/pi32/OMEGA
   355: |||                VPP2(li+ 8,ip,ity)=VPP2(li+ 8,ip,ity)* 35.d0/pi32/OMEGA
   356: |||                VPP2(li+ 9,ip,ity)=VPP2(li+ 9,ip,ity)*105.d0/pi16/OMEGA
   357: |||                VPP2(li+10,ip,ity)=VPP2(li+10,ip,ity)*105.d0/pi16/OMEGA
   358: |||                VPP2(li+11,ip,ity)=VPP2(li+11,ip,ity)* 21.d0/pi32/OMEGA
   359: |||                VPP2(li+12,ip,ity)=VPP2(li+12,ip,ity)* 21.d0/pi32/OMEGA
   360: ||+----          enddo
   361: ||               endif
   362: |+-----         enddo  ! end of LI loop
   363: |               endif
   364: +------         enddo  ! end of ity loop
   365:           c
   366:                 return
   367:                 end


