NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: KWGT
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

     2:                 SUBROUTINE KWGT(NUMKQ,VECK,WGT,NK,IBRAV,CELLDM,OMEGA,PGIND,NKK)
     3:           C************************************************************
     4:           C     euAE][WEIGHT FACTORvZ
     5:           C                            SLAVE SUBROUTINE: BVEC, WEIGHT
     6:           C                                   (1990-04-12) OSAMU SUGINO
     7:           C
     8:                 IMPLICIT REAL*8(A-H,O-Z)
     9:                 include 'mpif.h'
    10:                 DIMENSION VECK(3,NUMKQ),WGT(NUMKQ)
    11:                 REAL*8 B(3),CELLDM(6),KVEC(3)
    12:                 INTEGER PGIND,ILOC(3)
    13:                 DATA SR3/1.73205080756888D+00/
    14:           C
    15:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
    16:           c
    17:           C     FAC ADJUSTS THE WEIGHTS SO THAT THE SUM OF UNITY OVER THE FULL
    18:           C     BRILLOUIN ZONE (INCLUDING THE POINT-GROUP ROTATIONS CARRIED OUT
    19:           C     IN SUBROUTINE RHOOFR) IS 2 (FOR SPIN).
    20:           C
    21:                 CALL BVEC(IBRAV,NK,B,CELLDM,V0,FAC,LIM,ISTR,L1,L2,L3)
    22:                 NMAX=2*NK-1
    23:                 NKK=0
    24: +------>        DO 40 J=1,NMAX,2
    25: |         C
    26: |         C        DETERMINATION OF LIM1
    27: |         C
    28: |               LIM1=J
    29: |               IF(ISTR.GE.12) LIM1=2*NMAX+1
    30: |               IF(ISTR.EQ.8) LIM1=NMAX
    31: |               IF(ISTR.EQ.6.AND.PGIND.EQ.2) LIM1=NMAX
    32: |               IF(ISTR.EQ.7.AND.PGIND.EQ.2) LIM1=NMAX
    33: |               IF(ISTR.EQ.4.AND.PGIND.EQ.2) LIM1=2*J-1
    34: |               IF(ISTR.EQ.4.AND.PGIND.EQ.3) LIM1=2*NMAX+1
    35: |+----->        DO 39 M=1,LIM1,2
    36: ||        C
    37: ||        C        DETERMINATION OF MK
    38: ||        C
    39: ||              MK=M
    40: ||              IF(ISTR.EQ.4.AND.PGIND.GT.1) MK=M-(J+1)
    41: ||              IF(ISTR.GE.12) MK=M-(NMAX+1)
    42: ||        C
    43: ||        C        DETERMINATION OF LIM2
    44: ||        C
    45: ||              LIM2=NMAX
    46: ||              IF(ISTR.LT.3.AND.PGIND.EQ.2) LIM2=J
    47: ||              IF(ISTR.EQ.3.AND.PGIND.EQ.2) LIM2=MIN0(J,LIM-J)
    48: ||              IF(ISTR.LE.3.AND.PGIND.EQ.1) LIM2=M
    49: ||              IF(ISTR.EQ.14) LIM2=2*NMAX+1
    50: ||+---->        DO 38 L=1,LIM2,2
    51: |||       C
    52: |||       C        DETERMINATION OF LK
    53: |||       C
    54: |||             LK=L
    55: |||             IF(ISTR.EQ.14) LK=L-(NMAX+1)
    56: |||       C
    57: |||       C        CALCULATION OF K-VECTOR
    58: |||       C
    59: |||             IF(L1*J+L2*M+L3*L.GT.LIM) GO TO 39
    60: |||             ILOC(1)=J
    61: |||             ILOC(2)=MK
    62: |||             ILOC(3)=LK
    63: |||             KVEC(1)=B(1)*ILOC(1)
    64: |||             KVEC(2)=B(2)*ILOC(2)
    65: |||             KVEC(3)=B(3)*ILOC(3)
    66: |||             IF(ISTR.NE.4) GO TO 31
    67: |||             SAVE=KVEC(1)
    68: |||             KVEC(1)=KVEC(2)
    69: |||             KVEC(2)=SAVE
    70: |||             IF(PGIND.NE.2.OR.MK.GT.0.) GO TO 31
    71: |||             SAVE=(KVEC(1)+SR3*KVEC(2))/2.D0
    72: |||             KVEC(2)=(KVEC(2)-SR3*KVEC(1))/2.D0
    73: |||             KVEC(1)=SAVE
    74: |||       C
    75: |||          31 NKK=NKK+1
    76: |||             VECK(1,NKK)=KVEC(1)
    77: |||             VECK(2,NKK)=KVEC(2)
    78: |||             VECK(3,NKK)=KVEC(3)
    79: |||       C     WRITE(6,*) ' ##J,L,M,NKK,NUMKQ##',J,L,M,NKK,NUMKQ
    80: |||       CTEMP WRITE(6,'(''  ##  KVEC='',3F15.7)') (KVEC(I),I=1,3)
    81: |||       ccc      IF(NKK.GT.NUMKQ) STOP '  NUMKQ TOO SMALL'
    82: |||             IF(NKK.GT.NUMKQ) then
    83: |||             if ( my_rank.eq.0 ) write(6,*)'NUMKQ TOO SMALL'
    84: |||             STOP
    85: |||             ENDIF
    86: |||             CALL WEIGHT(ISTR,PGIND,LIM,J,MK,L,W)
    87: |||             W=FAC*W
    88: |||       C
    89: |||       C        DETERMINATION OF VOL
    90: |||       C
    91: |||             VOL=W*V0
    92: |||             IF(ISTR.EQ.4.AND.PGIND.EQ.1.AND.J.EQ.M) VOL=VOL/2.D0
    93: |||             IF(ISTR.EQ.4.AND.PGIND.EQ.3.AND.(M.EQ.1.OR.M.EQ.LIM1))VOL=VOL/2.D0
    94: |||             WGT(NKK)=VOL/OMEGA
    95: |||       CTEMP WRITE(6,'(''  ##WEIGHT='',2F15.7)') VOL,VOL/OMEGA
    96: ||+----      38 CONTINUE
    97: |+-----      39 CONTINUE
    98: +------      40 CONTINUE
    99:                 RETURN
   100:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: BVEC
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   102:                 SUBROUTINE BVEC(IBRAV,NK,B,CELLDM,V0,FAC,LIM,ISTR,L1,L2,L3)
   103:           C************************************************************
   104:           C
   105:           C SYMMETRY BUSINESS
   106:           C                                   (1990-04-12) OSAMU SUGINO
   107:           C
   108:                 IMPLICIT REAL*8 (A-H,O-Z)
   109:                 include 'mpif.h'
   110:                 DIMENSION B(3),CELLDM(6)
   111:                 DATA SR3/1.73205080756888D+00/
   112:           C
   113:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
   114:           C
   115:                 N=NK
   116:                 FAC=2.D0
   117:                 BD=1.D0/(2.D0*DFLOAT(N))
   118:                 L1=0
   119:                 L2=0
   120:                 L3=0
   121:                 LIM=2*N
   122:                 ISTR=IBRAV
   123:                 GO TO (2,4,6,8,10,12,14,16,18,20,22,24,26,28),IBRAV
   124:           C
   125:           C SC LATTICE
   126:           C
   127:               2 BD=BD/2.D0
   128: *------>        DO 3 I=1,3
   129: *------       3 B(I)=BD
   130:                 GO TO 30
   131:           C
   132:           C FCC LATTICE
   133:           C
   134:               4 L1=1
   135:                 L2=1
   136:                 L3=1
   137:                 LIM=3*N+2
   138:                 FAC=FAC/4.D0
   139: *------>        DO 5 I=1,3
   140: *------       5 B(I)=BD
   141:                 GO TO 30
   142:           C
   143:           C BCC LATTICE
   144:           C
   145:               6 L1=1
   146:                 L2=1
   147:                 L3=0
   148:                 LIM=2*N
   149:                 FAC=FAC/2.D0
   150: *------>        DO 7 I=1,3
   151: *------       7 B(I)=BD
   152:                 GO TO 30
   153:           C
   154:           C HEX(P),TRIG(P) LATTICE
   155:           C
   156:               8 B(1)=BD/SR3
   157:                 B(2)=B(1)/SR3
   158:                 CBYA=CELLDM(3)
   159:                 B(3)=BD/(2.D0*CBYA)
   160:                 FAC=FAC*SR3*CBYA/2.D0
   161:                 GO TO 30
   162:           C
   163:           C TRIG(R) LATTICE
   164:           C
   165:              10 TERM1=SQRT(1.D0+2.D0*CELLDM(4))
   166:                 TERM2=SQRT(1.D0-CELLDM(4))
   167:                 B(1)=BD/(SQRT(2.D0)*TERM2)
   168:                 B(2)=B(1)/SR3
   169:                 B(3)=BD/(2.D0*SR3*TERM1)
   170:                 ISTR=4
   171:                 FAC=FAC*TERM1*TERM2*TERM2
   172:                 GO TO 30
   173:           C
   174:           C TETR(P) LATTICE
   175:           C
   176:              12 BD=BD/2.D0
   177:                 B(1)=BD
   178:                 B(2)=BD
   179:                 CBYA=CELLDM(3)
   180:                 B(3)=BD/CBYA
   181:                 FAC=FAC*CBYA
   182:                 GO TO 30
   183:           C
   184:           C TETRA(I) LATTICE
   185:           C
   186:              14 B(1)=BD
   187:                 B(2)=BD
   188:                 CBYA=CELLDM(3)
   189:                 B(3)=BD/(2.D0*CBYA)
   190:                 L1=1
   191:                 L2=1
   192:                 LIM=2*N
   193:                 FAC=FAC*CBYA/2.D0
   194:                 GO TO 30
   195:           C
   196:           C ORTH(P) LATTICE
   197:           C
   198:              16 BD=BD/2.D0
   199:                 B(1)=BD
   200:                 B(2)=BD/CELLDM(2)
   201:                 B(3)=BD/CELLDM(3)
   202:                 FAC=FAC*CELLDM(2)*CELLDM(3)
   203:                 GO TO 30
   204:           C
   205:           C XXXXX
   206:           C
   207:              18 GO TO 110
   208:           C
   209:           C XXXXX
   210:           C
   211:              20 GO TO 110
   212:           C
   213:           C XXXXX
   214:           C
   215:              22 GO TO 110
   216:           C
   217:           C MCLN(P) LATTICE
   218:           C
   219:              24 BD=BD/2.D0
   220:                 SIN=SQRT(1.D0-CELLDM(4)**2)
   221:                 B(1)=BD
   222:                 B(2)=BD/(CELLDM(2)*SIN)
   223:                 B(3)=BD/CELLDM(3)
   224:                 FAC=FAC*CELLDM(2)*CELLDM(3)*SIN
   225:                 GO TO 30
   226:           C
   227:           C XXXXX
   228:           C
   229:              26 GO TO 110
   230:           C
   231:           C TCLN(P) LATTICE
   232:           C
   233:              28 BD=BD/2.D0
   234:                 SINGAM=SQRT(1.D0-CELLDM(6)**2)
   235:                 B(1)=BD
   236:                 B(2)=BD/(CELLDM(2)*SINGAM)
   237:                 TERM=SQRT((1.D0+2.D0*CELLDM(4)*CELLDM(5)*CELLDM(6)-CELLDM(4)**2
   238:                &    -CELLDM(5)**2-CELLDM(6)**2)/(1.0-CELLDM(6)**2))
   239:                 B(3)=BD/(CELLDM(3)*TERM)
   240:                 FAC=FAC*CELLDM(2)*CELLDM(3)*SINGAM*TERM
   241:           C
   242:           C FINAL BUSINESS
   243:           C
   244:              30 V0=8.D0*B(1)*B(2)*B(3)
   245:                 RETURN
   246:           C
   247:           C***** ERROR EXIT ROUTINE***
   248:           C
   249:             110 if ( my_rank.eq.0 ) WRITE(6,120) IBRAV
   250:             120 FORMAT(' BRAVAIS LATTICE',I3,' NOT PROGRAMMED. STOPPING')
   251:                 STOP
   252:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: WEIGHT
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   254:                 SUBROUTINE WEIGHT(ISTR,PGIND,LIM,KK,LL,MM,W)
   255:           C***********************************************************
   256:           C                                   (1990-04-12) OSAMU SUGINO
   257:           C     REDUCTION OF WEIGHTS FOR SPECIAL POINTS.
   258:           C     ASSUMES K,L, AND M NONNEGATIVE.
   259:           C
   260:                 IMPLICIT REAL*8 (A-H,O-Z)
   261:                 INTEGER PGIND
   262:                 GO TO (1,1,1,25,25,10,10,25,25,25,25,25,25,25),ISTR
   263:               1 K=KK
   264:                 L=MAX0(LL,MM)
   265:                 M=MIN0(LL,MM)
   266:                 Q=2.D0
   267:                 IF(K.NE.L.AND.L.NE.M) Q=1.D0
   268:                 IF(K.EQ.L.AND.L.EQ.M) Q=6.D0
   269:                 IF(L.EQ.M) Q=Q/DFLOAT(PGIND)
   270:                 P=8.D0
   271:                 IF(M.EQ.0) P=P/2.D0
   272:                 IF(L.EQ.0) P=P/2.D0
   273:                 IF(K.EQ.0) P=P/2.D0
   274:                 W=P/(8.D0*Q)
   275:           C     REDUCTION OF WEIGHT FOR CUBES ON ZONE SURFACE.
   276:                 IF(ISTR.EQ.2.AND.K+L+M.GT.LIM-5) W=W/2.D0
   277:                 IF(ISTR.EQ.3.AND.K+L.EQ.LIM.AND.L.NE.M) W=W/2.D0
   278:                 IF(ISTR.EQ.3.AND.K+L.EQ.LIM.AND.L.EQ.M) W=W/3.D0
   279:                 IF(ISTR.EQ.3.AND.K+L.EQ.LIM.AND.K.EQ.L.AND.L.EQ.M)
   280:                &  W=3.D0*W/4.D0
   281:                 RETURN
   282:              10 W=1.D0
   283:                 IF(PGIND.EQ.1.AND.KK.EQ.LL) W=0.5D0
   284:                 IF(ISTR.EQ.7.AND.KK+LL.EQ.LIM) W=W/2.D0
   285:                 RETURN
   286:              25 W=1.D0
   287:                 RETURN
   288:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: SMAT
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   290:                 SUBROUTINE SMAT(PGIND,S,NTOT,IBRAV)
   291:           C********************************************************
   292:                 include 'mpif.h'
   293:                 INTEGER*4 S(3,3,48),PGIND,PIND(32)
   294:                 DATA PIND/1,1,3,4,5,6,6,8,9,8,11,12,11,14,15,16,14,18,19,18,21,
   295:                1 22,23,21,25,26,25,28,28,30,31,30/
   296:           C
   297:           C     PIND REMOVES INVERSION FROM THE POINT GROUP (IF THE GROUP CON-
   298:           C     TAINED IT ORIGINALLY), SAVING A FACTOR TWO BECAUSE OF TIME-
   299:           C     REVERSAL SYMMETRY.
   300:           C
   301:                 call MPI_COMM_RANK(MPI_COMM_WORD,my_rank,ierr)
   302:           C
   303:           C     GET ROTATION MATRIX S
   304:           C
   305:                 GO TO (21,22,23,21,24,21,25,21,100,100,100,21,100,21),IBRAV
   306:              21 CALL PGSYM(PIND(PGIND),S,NTOT)
   307:                 GO TO 40
   308:              22 CALL FCCSYM(PIND(PGIND),S,NTOT)
   309:                 GO TO 40
   310:              23 CALL BCCSYM(PIND(PGIND),S,NTOT)
   311:                 GO TO 40
   312:              24 CALL TRGSYM(PIND(PGIND),S,NTOT)
   313:                 GO TO 40
   314:              25 CALL BCTSYM(PIND(PGIND),S,NTOT)
   315:              40 RETURN
   316:           c  100 STOP' UNACCEPTABLE POINT GROUP SPECIFIED'
   317:             100 continue
   318:                 if ( my_rank.eq.0 )write(6,*)
   319:                &   ' UNACCEPTABLE POINT GROUP SPECIFIED'
   320:                 STOP
   321:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: PGSYM
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   323:                 SUBROUTINE PGSYM(PGIND,S,NTOT)
   324:           C   SETS UP THE POINT-GROUP ROTATION MATRICES FOR ALL 32 POINT GROUPS
   325:           C   FOR THE SIMPLE (P) BRAVAIS LATTICES.
   326:           C   THESE MATRICES ALL HAVE INTEGER ELEMENTS, AND EXPRESS THE RELATIONS
   327:           C   BETWEEN THE PRIMITIVE BASIS VECTORS DUE TO EACH POINT-GROUP
   328:           C   ROTATION.  THE SPECIAL AXIS IS ALWAYS THE Z-AXIS, ONE BASAL-PLANE
   329:           C   VECTOR IS ALWAYS ALONG X, AND THE OTHER BASAL-PLANE VECTOR IS AT
   330:           C   ANGLE BETA FOR MONOCLINIC (BETA IS NOT ACTUALLY USED), AT 120
   331:           C   DEGREES FOR TRIGONAL AND HEXAGONAL(P) GROUPS, AND AT 90 DEGREES FOR
   332:           C   REMAINING GROUPS.
   333:           C   SUBROUTINE TRGSYM TAKES CARE OF THE TRIGONAL(R) GROUPS, SUBROUTINE
   334:           C   FCCSYM TAKES CARE OF THE CUBIC (F) GROUPS, SUBROUTINE BCCSYM TAKES
   335:           C   CARE OF THE CUBIC (I) GROUPS, AND SUBROUTINE BCTSYM TAKES CARE OF
   336:           C   THE TETRAGONAL (I) GROUPS.  FOR THESE LATTER
   337:           C   GROUPS, THE CRYSTALLOGRAPHIC VECTORS ARE CHOSEN
   338:           C   DIFFERENTLY.  FOR THE TRICLINIC GROUPS, THE MATRICES ARE
   339:           C   SIMPLY IDENTITY AND INVERSION.
   340:           C
   341:           C   PGIND IS THE POINT-GROUP INDEX, DEFINED AS FOLLOWS:
   342:           C
   343:           C   PGIND   GROUP     PGIND   GROUP     PGIND   GROUP     PGIND   GROUP
   344:           C    1     1 (C1)       9     3M (C3V)    17   4/MMM(D4H)   25   222(D2)
   345:           C    2    <1>(CI)      10     <3>M(D3D)   18   6 (C6)       26  MM2(C2V)
   346:           C    3     2 (C2)      11     4 (C4)      19   <6>(C3H)     27  MMM(D2H)
   347:           C    4     M (C1H)     12     <4>(S4)     20   6/M(C6H)     28  23 (T)
   348:           C    5     2/M(C2H)    13     4/M(C4H)    21   622(D6)      29  M3 (TH)
   349:           C    6     3 (C3)      14     422(D4)     22   6MM(C6V)     30  432 (O)
   350:           C    7     <3>(C3I)    15     4MM(C4V)    23   <6>M2(D3H)   31 <4>3M(TD)
   351:           C    8     32 (D3)     16    <4>2M(D3D)   24    6/MMM(D6H)  32  M3M(OH)
   352:           C
   353:                 include 'mpif.h'
   354:                 INTEGER*4 PGIND,S(3,3,48),SUM
   355:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
   356:                 IF(PGIND.LT.1) GO TO 100
   357: V------>        DO 1 K=1,48
   358: |*----->        DO 1 J=1,3
   359: ||*---->        DO 1 I=1,3
   360: ||*----       1 S(I,J,K)=0
   361: *------>        DO 2 I=1,3
   362: *------       2 S(I,I,1)=1
   363:                 IF(PGIND.GT.2) GO TO 5
   364:           C   TRICLINIC GROUPS HERE.
   365:           C  POINT GROUP 1.
   366:                 NTOT=1
   367:                 IF(PGIND.EQ.1) RETURN
   368:           C   ADD INVERSION FOR <1>.
   369:                 NTOT=2
   370: *------>        DO 3 I=1,3
   371: *------       3 S(I,I,2)=-1
   372:                 RETURN
   373:           C   MONOCLINIC GROUPS HERE.
   374:               5 IF(PGIND.GT.5) GO TO 10
   375:                 NTOT=2
   376: *------>        DO 6 I=1,3
   377: |               S(I,I,2)=1
   378: |               S(I,I,3)=1
   379: *------       6 S(I,I,4)=1
   380:                 IF(PGIND.GT.3) GO TO 7
   381:           C  POINT GROUP 2.
   382:                 S(1,1,2)=-1
   383:                 S(2,2,2)=-1
   384:                 RETURN
   385:               7 IF(PGIND.GT.4) GO TO 8
   386:           C   POINT GROUP M.
   387:                 S(3,3,2)=-1
   388:                 RETURN
   389:               8 NTOT=4
   390:           C   POINT GROUP 2/M.
   391:                 S(1,1,2)=-1
   392:                 S(2,2,2)=-1
   393:                 S(3,3,3)=-1
   394: *------>        DO 9 I=1,3
   395: *------       9 S(I,I,4)=-1
   396:                 RETURN
   397:           C   TRIGONAL GROUPS HERE.
   398:              10 IF(PGIND.GT.10) GO TO 20
   399:           C  POINT GROUP 3.
   400:                 NTOT=3
   401:                 S(1,2,2)=1
   402:                 S(2,1,2)=-1
   403:                 S(2,2,2)=-1
   404:                 S(3,3,2)=1
   405:                 S(1,1,3)=-1
   406:                 S(1,2,3)=-1
   407:                 S(2,1,3)=1
   408:                 S(3,3,3)=1
   409:                 IF(PGIND.EQ.6) RETURN
   410:                 IF(PGIND.EQ.7.OR.PGIND.EQ.10) GO TO 15
   411:                 NTOT=6
   412:           C   SET UP C2X.
   413:                 S(1,1,4)=1
   414:                 S(3,3,4)=-1
   415:                 S(2,1,4)=-1
   416:                 S(2,2,4)=-1
   417:                 IF(PGIND.EQ.8) GO TO 12
   418:           C   SET UP MX.
   419: *------>        DO 11 J=1,3
   420: |*----->        DO 11 I=1,3
   421: |*-----      11 S(I,J,4)=-S(I,J,4)
   422:                 S(3,3,4)=1
   423:           C  POINT GROUP 32 =3(X)C2X OR 3M = 3(X)MX.
   424: +------>     12 DO 14 KIND=2,3
   425: |*----->        DO 14 I=1,3
   426: ||*---->        DO 14 J=1,3
   427: |||             SUM=0
   428: |||*--->        DO 13 K=1,3
   429: |||*---      13 SUM=SUM+S(I,K,4)*S(K,J,KIND)
   430: ||*----      14 S(I,J,KIND+3)=SUM
   431:                 RETURN
   432:              15 NTOT=6
   433:           C   POINT GROUP <3> = 3(X)I
   434: *------>        DO 16 KIND=1,3
   435: |*----->        DO 16 J=1,3
   436: ||*---->        DO 16 I=1,3
   437: ||*----      16 S(I,J,KIND+3)=-S(I,J,KIND)
   438:                 IF(PGIND.EQ.7) RETURN
   439:           C   POINT GROUP <3>M = <3>(X)MX
   440:                 NTOT=12
   441:                 S(1,1,7)=-1
   442:                 S(2,1,7)=1
   443:                 S(2,2,7)=1
   444:                 S(3,3,7)=1
   445: V------>        DO 18 KIND=2,6
   446: |*----->        DO 18 J=1,3
   447: ||*---->        DO 18 I=1,3
   448: |||             SUM=0
   449: |||*--->        DO 17 K=1,3
   450: |||*---      17 SUM=SUM+S(I,K,7)*S(K,J,KIND)
   451: ||*----      18 S(I,J,KIND+6)=SUM
   452:                 RETURN
   453:           C   HERE FOR TETRAGONAL GROUPS.
   454:              20 IF(PGIND.GT.17) GO TO 40
   455:           C   POINT GROUP 4.
   456:                 NTOT=4
   457:                 S(1,2,2)=1
   458:                 S(2,1,2)=-1
   459:                 S(3,3,2)=1
   460:                 S(1,1,3)=-1
   461:                 S(2,2,3)=-1
   462:                 S(3,3,3)=1
   463:                 S(1,2,4)=-1
   464:                 S(2,1,4)=1
   465:                 S(3,3,4)=1
   466:                 IF(PGIND.EQ.11) RETURN
   467:                 IF(PGIND.NE.12.AND.PGIND.NE.16) GO TO 25
   468:           C   POINT GROUP <4>.
   469: *------>        DO 21 KIND=2,4,2
   470: |*----->        DO 21 J=1,3
   471: ||*---->        DO 21 I=1,3
   472: ||*----      21 S(I,J,KIND)=-S(I,J,KIND)
   473:                 IF(PGIND.EQ.12) RETURN
   474:           C   POINT GROUP <4>2M = <4>(X)C2X.
   475:                 NTOT=8
   476:                 S(1,1,5)=1
   477:                 S(2,2,5)=-1
   478:                 S(3,3,5)=-1
   479: +------>        DO 23 KIND=2,4
   480: |*----->        DO 23 J=1,3
   481: ||*---->        DO 23 I=1,3
   482: |||             SUM=0
   483: |||*--->        DO 22 K=1,3
   484: |||*---      22 SUM=SUM+S(I,K,5)*S(K,J,KIND)
   485: ||*----      23 S(I,J,KIND+4)=SUM
   486:                 RETURN
   487:              25 NTOT=8
   488:                 IF(PGIND.NE.13) GO TO 26
   489:           C   POINT GROUP 4/M = MZ(X)4
   490:                 S(1,1,5)=1
   491:                 S(2,2,5)=1
   492:                 S(3,3,5)=-1
   493:                 GO TO 30
   494:              26 IF(PGIND.NE.15) GO TO 27
   495:           C   POINT GROUP 4MM = MX(X)4.
   496:                 S(1,1,5)=-1
   497:                 S(2,2,5)=1
   498:                 S(3,3,5)=1
   499:                 GO TO 30
   500:           C   POINT GROUPS 422 = C2X(X)4 AND 4/MMM = I(X)422.
   501:              27 S(1,1,5)=1
   502:                 S(2,2,5)=-1
   503:                 S(3,3,5)=-1
   504: +------>     30 DO 32 KIND=2,4
   505: |*----->        DO 32 J=1,3
   506: ||*---->        DO 32 I=1,3
   507: |||             SUM=0
   508: |||*--->        DO 31 K=1,3
   509: |||*---      31 SUM=SUM+S(I,K,5)*S(K,J,KIND)
   510: ||*----      32 S(I,J,KIND+4)=SUM
   511:                 IF(PGIND.NE.17) RETURN
   512:                 NTOT=16
   513: V------>        DO 34 KIND=1,8
   514: |*----->        DO 34 J=1,3
   515: ||*---->        DO 34 I=1,3
   516: ||*----      34 S(I,J,KIND+8)=-S(I,J,KIND)
   517:                 RETURN
   518:           C   HERE FOR HEXAGONAL POINT GROUPS.
   519:              40 IF(PGIND.GT.24) GO TO 60
   520:                 NTOT=6
   521:           C   POINT GROUP 6.
   522:                 S(1,1,2)=1
   523:                 S(1,2,2)=1
   524:                 S(2,1,2)=-1
   525:                 S(1,2,3)=1
   526:                 S(2,1,3)=-1
   527:                 S(2,2,3)=-1
   528:                 S(1,1,4)=-1
   529:                 S(2,2,4)=-1
   530:                 S(1,1,5)=-1
   531:                 S(1,2,5)=-1
   532:                 S(2,1,5)=1
   533:                 S(1,2,6)=-1
   534:                 S(2,1,6)=1
   535:                 S(2,2,6)=1
   536: *------>        DO 41 I=2,6
   537: *------      41 S(3,3,I)=1
   538:                 IF(PGIND.EQ.18) RETURN
   539:                 IF(PGIND.NE.19.AND.PGIND.NE.23) GO TO 45
   540:           C   POINT GROUP <6>.
   541: *------>        DO 42 KIND=2,6,2
   542: |*----->        DO 42 J=1,3
   543: ||*---->        DO 42 I=1,3
   544: ||*----      42 S(I,J,KIND)=-S(I,J,KIND)
   545:                 IF(PGIND.EQ.19) RETURN
   546:           C   POINT GROUP <6>M2 = C2Y(X)<6>.
   547:                 NTOT=12
   548:                 S(1,1,7)=-1
   549:                 S(2,2,7)=1
   550:                 S(3,3,7)=-1
   551: V------>        DO 44 KIND=2,6
   552: |*----->        DO 44 J=1,3
   553: ||*---->        DO 44 I=1,3
   554: |||             SUM=0
   555: |||*--->        DO 43 K=1,3
   556: |||*---      43 SUM=SUM+S(I,K,7)*S(K,J,KIND)
   557: ||*----      44 S(I,J,KIND+6)=SUM
   558:                 RETURN
   559:              45 NTOT=12
   560:                 IF(PGIND.NE.20) GO TO 47
   561:           C   POINT GROUP 6/M = I(X)6
   562: V------>        DO 46 KIND=1,6
   563: |*----->        DO 46 J=1,3
   564: ||*---->        DO 46 I=1,3
   565: ||*----      46 S(I,J,KIND+6)=-S(I,J,KIND)
   566:                 RETURN
   567:              47 IF(PGIND.NE.22) GO TO 48
   568:           C   POINT GROUP 6MM = MX(X)6
   569:                 S(1,1,7)=-1
   570:                 S(2,2,7)=1
   571:                 S(3,3,7)=1
   572:                 GO TO 50
   573:           C   POINT GROUPS 622 = C2X(X)6 AND 6/MMM = I(X)622.
   574:              48 S(1,1,7)=1
   575:                 S(2,2,7)=-1
   576:                 S(3,3,7)=-1
   577: V------>     50 DO 52 KIND=2,6
   578: |*----->        DO 52 J=1,3
   579: ||*---->        DO 52 I=1,3
   580: |||             SUM=0
   581: |||*--->        DO 51 K=1,3
   582: |||*---      51 SUM=SUM+S(I,K,7)*S(K,J,KIND)
   583: ||*----      52 S(I,J,KIND+6)=SUM
   584:                 IF(PGIND.NE.24) RETURN
   585:                 NTOT=24
   586: V------>        DO 53 KIND=1,12
   587: |*----->        DO 53 J=1,3
   588: ||*---->        DO 53 I=1,3
   589: ||*----      53 S(I,J,KIND+12)=-S(I,J,KIND)
   590:                 RETURN
   591:           C   HERE FOR ORTHORHOMBIC POINT GROUPS.
   592:              60 IF(PGIND.GT.27) GO TO 70
   593:                 NTOT=4
   594:                 IF(PGIND.NE.26) GO TO 64
   595:           C   POINT GROUP MM2.
   596: *------>        DO 61 KIND=2,4
   597: |*----->        DO 61 I=1,3
   598: |*-----      61 S(I,I,KIND)=1
   599:                 S(1,1,2)=-1
   600:                 S(2,2,3)=-1
   601:                 S(1,1,4)=-1
   602:                 S(2,2,4)=-1
   603:                 RETURN
   604:           C   POINT GROUP 222.
   605: *------>     64 DO 65 KIND=2,4
   606: |*----->        DO 65 I=1,3
   607: |*-----      65 S(I,I,KIND)=-1
   608:                 S(1,1,2)=1
   609:                 S(2,2,3)=1
   610:                 S(3,3,4)=1
   611:                 IF(PGIND.EQ.25) RETURN
   612:           C   POINT GROUP MMM = I(X)222
   613:                 NTOT=8
   614: *------>        DO 66 KIND=1,4
   615: |*----->        DO 66 J=1,3
   616: ||*---->        DO 66 I=1,3
   617: ||*----      66 S(I,J,KIND+4)=-S(I,J,KIND)
   618:                 RETURN
   619:           C   HERE FOR CUBIC POINT GROUPS.
   620:              70 IF(PGIND.GT.32) GO TO 100
   621:                 NTOT=12
   622:           C   POINT GROUP 23.
   623: *------>        DO 71 KIND=2,4
   624: |*----->        DO 71 I=1,3
   625: |*-----      71 S(I,I,KIND)=-1
   626:                 S(1,1,2)=1
   627:                 S(2,2,3)=1
   628:                 S(3,3,4)=1
   629:                 S(1,2,5)=1
   630:                 S(2,3,5)=1
   631:                 S(3,1,5)=1
   632:                 S(1,3,6)=1
   633:                 S(2,1,6)=1
   634:                 S(3,2,6)=1
   635: +------>        DO 74 KIND=5,6
   636: |+----->        DO 74 JIND=2,4
   637: ||*---->        DO 74 J=1,3
   638: |||*--->        DO 74 I=1,3
   639: ||||            SUM=0
   640: ||||*-->        DO 72 K=1,3
   641: ||||*--      72 SUM=SUM+S(I,K,JIND)*S(K,J,KIND)
   642: |||*---      74 S(I,J,KIND+2*JIND-2)=SUM
   643:                 IF(PGIND.EQ.28) RETURN
   644:                 NTOT=24
   645:                 IF(PGIND.NE.29) GO TO 76
   646:           C   POINT GROUP M3 = I(X)23
   647: V------>        DO 75 KIND=1,12
   648: |*----->        DO 75 J=1,3
   649: ||*---->        DO 75 I=1,3
   650: ||*----      75 S(I,J,KIND+12)=-S(I,J,KIND)
   651:                 RETURN
   652:              76 IF(PGIND.EQ.31) GO TO 80
   653:           C   POINT GROUP 432 = C4X(X)23
   654:                 S(1,1,13)=1
   655:                 S(2,3,13)=1
   656:                 S(3,2,13)=-1
   657: V------>        DO 78 KIND=2,12
   658: |*----->        DO 78 J=1,3
   659: ||*---->        DO 78 I=1,3
   660: |||             SUM=0
   661: |||*--->        DO 77 K=1,3
   662: |||*---      77 SUM=SUM+S(I,K,13)*S(K,J,KIND)
   663: ||*----      78 S(I,J,KIND+12)=SUM
   664:                 IF(PGIND.EQ.30) RETURN
   665:           C   POINT GROUP M3M = I(X)432
   666:                 NTOT=48
   667: V------>        DO 79 KIND=1,24
   668: |*----->        DO 79 J=1,3
   669: ||*---->        DO 79 I=1,3
   670: ||*----      79 S(I,J,KIND+24)=-S(I,J,KIND)
   671:                 RETURN
   672:           C   POINT <4>3M = <C4X>(X)23
   673:              80 S(1,1,13)=-1
   674:                 S(2,3,13)=-1
   675:                 S(3,2,13)=1
   676: V------>        DO 85 KIND=2,12
   677: |*----->        DO 85 J=1,3
   678: ||*---->        DO 85 I=1,3
   679: |||             SUM=0
   680: |||*--->        DO 84 K=1,3
   681: |||*---      84 SUM=SUM+S(I,K,13)*S(K,J,KIND)
   682: ||*----      85 S(I,J,KIND+12)=SUM
   683:                 RETURN
   684:           C   HERE IF PGIND EXCEEDS 32 OR IS LESS THAN 1.
   685:             100 if ( my_rank.eq.0 ) WRITE(6,110) PGIND
   686:             110 FORMAT(' POINT-GROUP INDEX',I4,' IS NOT BETWEEN 1 AND 32. STOPPING
   687:                1 ')
   688:                 STOP
   689:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: PGSYM2
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

   690:                 SUBROUTINE PGSYM2(PGIND,S,NTOT)
   691:           C   THIS ROUTINE TAKES CARE OF THE D2D SYMMETRY IN SUPERLATTICE
   692:           C   STRUCTURE CONSISTING OF ORIGINAL FCC LATTICE.
   693:           C   THE CASE OF PGIND=16 HS BEEN ONLY SET UP.
   694:           C        DECEMBER 4, 1986  **** AO *********
   695:           C
   696:           C   PGIND IS THE POINT-GROUP INDEX, DEFINED AS FOLLOWS:
   697:           C
   698:           C   PGIND   GROUP     PGIND   GROUP     PGIND   GROUP     PGIND   GROUP
   699:           C    1     1 (C1)       9     3M (C3V)    17   4/MMM(D4H)   25   222(D2)
   700:           C    2    <1>(CI)      10     <3>M(D3D)   18   6 (C6)       26  MM2(C2V)
   701:           C    3     2 (C2)      11     4 (C4)      19   <6>(C3H)     27  MMM(D2H)
   702:           C    4     M (C1H)     12     <4>(S4)     20   6/M(C6H)     28  23 (T)
   703:           C    5     2/M(C2H)    13     4/M(C4H)    21   622(D6)      29  M3 (TH)
   704:           C    6     3 (C3)      14     422(D4)     22   6MM(C6V)     30  432 (O)
   705:           C    7     <3>(C3I)    15     4MM(C4V)    23   <6>M2(D3H)   31 <4>3M(TD)
   706:           C    8     32 (D3)     16      D2D        24    6/MMM(D6H)  32  M3M(OH)
   707:           C
   708:                 include 'mpif.h'
   709:                 INTEGER*4 PGIND,S(3,3,48),SUM
   710:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
   711:                 IF(PGIND.LT.1) GO TO 100
   712: V------>        DO 1 K=1,48
   713: |*----->        DO 1 J=1,3
   714: ||*---->        DO 1 I=1,3
   715: ||*----       1 S(I,J,K)=0
   716: *------>        DO 2 I=1,3
   717: *------       2 S(I,I,1)=1
   718:                 IF(PGIND.GT.2) GO TO 5
   719:           C   TRICLINIC GROUPS HERE.
   720:           C  POINT GROUP 1.
   721:                 NTOT=1
   722:                 IF(PGIND.EQ.1) RETURN
   723:           C   ADD INVERSION FOR <1>.
   724:                 NTOT=2
   725: *------>        DO 3 I=1,3
   726: *------       3 S(I,I,2)=-1
   727:                 RETURN
   728:           C   MONOCLINIC GROUPS HERE.
   729:               5 IF(PGIND.GT.5) GO TO 10
   730:                 NTOT=2
   731: *------>        DO 6 I=1,3
   732: |               S(I,I,2)=1
   733: |               S(I,I,3)=1
   734: *------       6 S(I,I,4)=1
   735:                 IF(PGIND.GT.3) GO TO 7
   736:           C  POINT GROUP 2.
   737:                 S(1,1,2)=-1
   738:                 S(2,2,2)=-1
   739:                 RETURN
   740:               7 IF(PGIND.GT.4) GO TO 8
   741:           C   POINT GROUP M.
   742:                 S(3,3,2)=-1
   743:                 RETURN
   744:               8 NTOT=4
   745:           C   POINT GROUP 2/M.
   746:                 S(1,1,2)=-1
   747:                 S(2,2,2)=-1
   748:                 S(3,3,3)=-1
   749: *------>        DO 9 I=1,3
   750: *------       9 S(I,I,4)=-1
   751:                 RETURN
   752:           C   TRIGONAL GROUPS HERE.
   753:              10 IF(PGIND.GT.10) GO TO 20
   754:           C  POINT GROUP 3.
   755:                 NTOT=3
   756:                 S(1,2,2)=1
   757:                 S(2,1,2)=-1
   758:                 S(2,2,2)=-1
   759:                 S(3,3,2)=1
   760:                 S(1,1,3)=-1
   761:                 S(1,2,3)=-1
   762:                 S(2,1,3)=1
   763:                 S(3,3,3)=1
   764:                 IF(PGIND.EQ.6) RETURN
   765:                 IF(PGIND.EQ.7.OR.PGIND.EQ.10) GO TO 15
   766:                 NTOT=6
   767:           C   SET UP C2X.
   768:                 S(1,1,4)=1
   769:                 S(3,3,4)=-1
   770:                 S(2,1,4)=-1
   771:                 S(2,2,4)=-1
   772:                 IF(PGIND.EQ.8) GO TO 12
   773:           C   SET UP MX.
   774: *------>        DO 11 J=1,3
   775: |*----->        DO 11 I=1,3
   776: |*-----      11 S(I,J,4)=-S(I,J,4)
   777:                 S(3,3,4)=1
   778:           C  POINT GROUP 32 =3(X)C2X OR 3M = 3(X)MX.
   779: +------>     12 DO 14 KIND=2,3
   780: |*----->        DO 14 I=1,3
   781: ||*---->        DO 14 J=1,3
   782: |||             SUM=0
   783: |||*--->        DO 13 K=1,3
   784: |||*---      13 SUM=SUM+S(I,K,4)*S(K,J,KIND)
   785: ||*----      14 S(I,J,KIND+3)=SUM
   786:                 RETURN
   787:              15 NTOT=6
   788:           C   POINT GROUP <3> = 3(X)I
   789: *------>        DO 16 KIND=1,3
   790: |*----->        DO 16 J=1,3
   791: ||*---->        DO 16 I=1,3
   792: ||*----      16 S(I,J,KIND+3)=-S(I,J,KIND)
   793:                 IF(PGIND.EQ.7) RETURN
   794:           C   POINT GROUP <3>M = <3>(X)MX
   795:                 NTOT=12
   796:                 S(1,1,7)=-1
   797:                 S(2,1,7)=1
   798:                 S(2,2,7)=1
   799:                 S(3,3,7)=1
   800: V------>        DO 18 KIND=2,6
   801: |*----->        DO 18 J=1,3
   802: ||*---->        DO 18 I=1,3
   803: |||             SUM=0
   804: |||*--->        DO 17 K=1,3
   805: |||*---      17 SUM=SUM+S(I,K,7)*S(K,J,KIND)
   806: ||*----      18 S(I,J,KIND+6)=SUM
   807:                 RETURN
   808:           C   HERE FOR TETRAGONAL GROUPS.
   809:              20 IF(PGIND.GT.17) GO TO 40
   810:           C   POINT GROUP 4.
   811:                 NTOT=4
   812:                 S(1,2,2)=1
   813:                 S(2,1,2)=-1
   814:                 S(3,3,2)=1
   815:                 S(2,1,3)=-1
   816:                 S(1,2,3)=-1
   817:                 S(3,3,3)=-1
   818:                 S(1,2,4)=1
   819:                 S(2,1,4)=1
   820:                 S(3,3,4)=-1
   821:                 IF(PGIND.EQ.11) RETURN
   822:                 IF(PGIND.NE.12.AND.PGIND.NE.16) GO TO 25
   823:           C   POINT GROUP <4>.
   824:                 IF(PGIND.EQ.12) RETURN
   825:           C   POINT GROUP <4>2M = <4>(X)C2X.
   826:                 NTOT=8
   827:                 S(1,1,5)=1
   828:                 S(2,2,5)=-1
   829:                 S(3,3,5)=1
   830:                 S(1,1,6)=-1
   831:                 S(2,2,6)=1
   832:                 S(3,3,6)=1
   833: +------>        DO 23 KIND=5,6
   834: |*----->        DO 23 J=1,3
   835: ||*---->        DO 23 I=1,3
   836: |||             SUM=0
   837: |||*--->        DO 22 K=1,3
   838: |||*---      22 SUM=SUM+S(I,K,3)*S(K,J,KIND)
   839: ||*----      23 S(I,J,KIND+2)=SUM
   840:                 RETURN
   841:              25 NTOT=8
   842:                 IF(PGIND.EQ.16.and.my_rank.eq.0) WRITE(6,8888)
   843:            8888 FORMAT(/////' ** PGSYM2:   WRONG PATH****** '///)
   844:                 IF(PGIND.NE.13) GO TO 26
   845:           C   POINT GROUP 4/M = MZ(X)4
   846:                 S(1,1,5)=1
   847:                 S(2,2,5)=1
   848:                 S(3,3,5)=-1
   849:                 GO TO 30
   850:              26 IF(PGIND.NE.15) GO TO 27
   851:           C   POINT GROUP 4MM = MX(X)4.
   852:                 S(1,1,5)=-1
   853:                 S(2,2,5)=1
   854:                 S(3,3,5)=1
   855:                 GO TO 30
   856:           C   POINT GROUPS 422 = C2X(X)4 AND 4/MMM = I(X)422.
   857:              27 S(1,1,5)=1
   858:                 S(2,2,5)=-1
   859:                 S(3,3,5)=-1
   860: +------>     30 DO 32 KIND=2,4
   861: |*----->        DO 32 J=1,3
   862: ||*---->        DO 32 I=1,3
   863: |||             SUM=0
   864: |||*--->        DO 31 K=1,3
   865: |||*---      31 SUM=SUM+S(I,K,5)*S(K,J,KIND)
   866: ||*----      32 S(I,J,KIND+4)=SUM
   867:                 IF(PGIND.NE.17) RETURN
   868:                 NTOT=16
   869: V------>        DO 34 KIND=1,8
   870: |*----->        DO 34 J=1,3
   871: ||*---->        DO 34 I=1,3
   872: ||*----      34 S(I,J,KIND+8)=-S(I,J,KIND)
   873:                 RETURN
   874:           C   HERE FOR HEXAGONAL POINT GROUPS.
   875:              40 IF(PGIND.GT.24) GO TO 60
   876:                 NTOT=6
   877:           C   POINT GROUP 6.
   878:                 S(1,1,2)=1
   879:                 S(1,2,2)=1
   880:                 S(2,1,2)=-1
   881:                 S(1,2,3)=1
   882:                 S(2,1,3)=-1
   883:                 S(2,2,3)=-1
   884:                 S(1,1,4)=-1
   885:                 S(2,2,4)=-1
   886:                 S(1,1,5)=-1
   887:                 S(1,2,5)=-1
   888:                 S(2,1,5)=1
   889:                 S(1,2,6)=-1
   890:                 S(2,1,6)=1
   891:                 S(2,2,6)=1
   892: *------>        DO 41 I=2,6
   893: *------      41 S(3,3,I)=1
   894:                 IF(PGIND.EQ.18) RETURN
   895:                 IF(PGIND.NE.19.AND.PGIND.NE.23) GO TO 45
   896:           C   POINT GROUP <6>.
   897: *------>        DO 42 KIND=2,6,2
   898: |*----->        DO 42 J=1,3
   899: ||*---->        DO 42 I=1,3
   900: ||*----      42 S(I,J,KIND)=-S(I,J,KIND)
   901:                 IF(PGIND.EQ.19) RETURN
   902:           C   POINT GROUP <6>M2 = C2Y(X)<6>.
   903:                 NTOT=12
   904:                 S(1,1,7)=-1
   905:                 S(2,2,7)=1
   906:                 S(3,3,7)=-1
   907: V------>        DO 44 KIND=2,6
   908: |*----->        DO 44 J=1,3
   909: ||*---->        DO 44 I=1,3
   910: |||             SUM=0
   911: |||*--->        DO 43 K=1,3
   912: |||*---      43 SUM=SUM+S(I,K,7)*S(K,J,KIND)
   913: ||*----      44 S(I,J,KIND+6)=SUM
   914:                 RETURN
   915:              45 NTOT=12
   916:                 IF(PGIND.NE.20) GO TO 47
   917:           C   POINT GROUP 6/M = I(X)6
   918: V------>        DO 46 KIND=1,6
   919: |*----->        DO 46 J=1,3
   920: ||*---->        DO 46 I=1,3
   921: ||*----      46 S(I,J,KIND+6)=-S(I,J,KIND)
   922:                 RETURN
   923:              47 IF(PGIND.NE.22) GO TO 48
   924:           C   POINT GROUP 6MM = MX(X)6
   925:                 S(1,1,7)=-1
   926:                 S(2,2,7)=1
   927:                 S(3,3,7)=1
   928:                 GO TO 50
   929:           C   POINT GROUPS 622 = C2X(X)6 AND 6/MMM = I(X)622.
   930:              48 S(1,1,7)=1
   931:                 S(2,2,7)=-1
   932:                 S(3,3,7)=-1
   933: V------>     50 DO 52 KIND=2,6
   934: |*----->        DO 52 J=1,3
   935: ||*---->        DO 52 I=1,3
   936: |||             SUM=0
   937: |||*--->        DO 51 K=1,3
   938: |||*---      51 SUM=SUM+S(I,K,7)*S(K,J,KIND)
   939: ||*----      52 S(I,J,KIND+6)=SUM
   940:                 IF(PGIND.NE.24) RETURN
   941:                 NTOT=24
   942: V------>        DO 53 KIND=1,12
   943: |*----->        DO 53 J=1,3
   944: ||*---->        DO 53 I=1,3
   945: ||*----      53 S(I,J,KIND+12)=-S(I,J,KIND)
   946:                 RETURN
   947:           C   HERE FOR ORTHORHOMBIC POINT GROUPS.
   948:              60 IF(PGIND.GT.27) GO TO 70
   949:                 NTOT=4
   950:                 IF(PGIND.NE.26) GO TO 64
   951:           C   POINT GROUP MM2.
   952: *------>        DO 61 KIND=2,4
   953: |*----->        DO 61 I=1,3
   954: |*-----      61 S(I,I,KIND)=1
   955:                 S(1,1,2)=-1
   956:                 S(2,2,3)=-1
   957:                 S(1,1,4)=-1
   958:                 S(2,2,4)=-1
   959:                 RETURN
   960:           C   POINT GROUP 222.
   961: *------>     64 DO 65 KIND=2,4
   962: |*----->        DO 65 I=1,3
   963: |*-----      65 S(I,I,KIND)=-1
   964:                 S(1,1,2)=1
   965:                 S(2,2,3)=1
   966:                 S(3,3,4)=1
   967:                 IF(PGIND.EQ.25) RETURN
   968:           C   POINT GROUP MMM = I(X)222
   969:                 NTOT=8
   970: *------>        DO 66 KIND=1,4
   971: |*----->        DO 66 J=1,3
   972: ||*---->        DO 66 I=1,3
   973: ||*----      66 S(I,J,KIND+4)=-S(I,J,KIND)
   974:                 RETURN
   975:           C   HERE FOR CUBIC POINT GROUPS.
   976:              70 IF(PGIND.GT.32) GO TO 100
   977:                 NTOT=12
   978:           C   POINT GROUP 23.
   979: *------>        DO 71 KIND=2,4
   980: |*----->        DO 71 I=1,3
   981: |*-----      71 S(I,I,KIND)=-1
   982:                 S(1,1,2)=1
   983:                 S(2,2,3)=1
   984:                 S(3,3,4)=1
   985:                 S(1,2,5)=1
   986:                 S(2,3,5)=1
   987:                 S(3,1,5)=1
   988:                 S(1,3,6)=1
   989:                 S(2,1,6)=1
   990:                 S(3,2,6)=1
   991: +------>        DO 74 KIND=5,6
   992: |+----->        DO 74 JIND=2,4
   993: ||*---->        DO 74 J=1,3
   994: |||*--->        DO 74 I=1,3
   995: ||||            SUM=0
   996: ||||*-->        DO 72 K=1,3
   997: ||||*--      72 SUM=SUM+S(I,K,JIND)*S(K,J,KIND)
   998: |||*---      74 S(I,J,KIND+2*JIND-2)=SUM
   999:                 IF(PGIND.EQ.28) RETURN
  1000:                 NTOT=24
  1001:                 IF(PGIND.NE.29) GO TO 76
  1002:           C   POINT GROUP M3 = I(X)23
  1003: V------>        DO 75 KIND=1,12
  1004: |*----->        DO 75 J=1,3
  1005: ||*---->        DO 75 I=1,3
  1006: ||*----      75 S(I,J,KIND+12)=-S(I,J,KIND)
  1007:                 RETURN
  1008:              76 IF(PGIND.EQ.31) GO TO 80
  1009:           C   POINT GROUP 432 = C4X(X)23
  1010:                 S(1,1,13)=1
  1011:                 S(2,3,13)=1
  1012:                 S(3,2,13)=-1
  1013: V------>        DO 78 KIND=2,12
  1014: |*----->        DO 78 J=1,3
  1015: ||*---->        DO 78 I=1,3
  1016: |||             SUM=0
  1017: |||*--->        DO 77 K=1,3
  1018: |||*---      77 SUM=SUM+S(I,K,13)*S(K,J,KIND)
  1019: ||*----      78 S(I,J,KIND+12)=SUM
  1020:                 IF(PGIND.EQ.30) RETURN
  1021:           C   POINT GROUP M3M = I(X)432
  1022:                 NTOT=48
  1023: V------>        DO 79 KIND=1,24
  1024: |*----->        DO 79 J=1,3
  1025: ||*---->        DO 79 I=1,3
  1026: ||*----      79 S(I,J,KIND+24)=-S(I,J,KIND)
  1027:                 RETURN
  1028:           C   POINT <4>3M = <C4X>(X)23
  1029:              80 S(1,1,13)=-1
  1030:                 S(2,3,13)=-1
  1031:                 S(3,2,13)=1
  1032: V------>        DO 85 KIND=2,12
  1033: |*----->        DO 85 J=1,3
  1034: ||*---->        DO 85 I=1,3
  1035: |||             SUM=0
  1036: |||*--->        DO 84 K=1,3
  1037: |||*---      84 SUM=SUM+S(I,K,13)*S(K,J,KIND)
  1038: ||*----      85 S(I,J,KIND+12)=SUM
  1039:                 RETURN
  1040:           C   HERE IF PGIND EXCEEDS 32 OR IS LESS THAN 1.
  1041:             100 if ( my_rank.eq.0 ) WRITE(6,110) PGIND
  1042:             110 FORMAT(' POINT-GROUP INDEX',I4,' IS NOT BETWEEN 1 AND 32. STOPPING
  1043:                1 ')
  1044:                 STOP
  1045:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: TRGSYM
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1046:                 SUBROUTINE TRGSYM(PGIND,S,NTOT)
  1047:           C   SETS UP THE ROTATION MATRICES FOR TRIGONAL(R) GROUPS.  FOR THESE
  1048:           C   GROUPS, THE Z-AXIS IS CHOSEN AS THE 3-FOLD AXIS, BUT THE
  1049:           C   CRYSTALLOGRAPHIC VECTORS FORM A THREE-FOLD STAR AROUND THE Z-AXIS,
  1050:           C   AND THE PRIMITIVE CELL IS A SIMPLE RHOMBOHEDRON.
  1051:           C   IF C IS THE COSINE OF THE ANGLE BETWEEN ANY PAIR OF CRYSTALLO-
  1052:           C   GRAPHIC VECTORS, AND IF TX=SQRT((1-C)/2), TY=SQRT((1-C)/6),
  1053:           C   TZ=SQRT((1+2C)/3), THE CRYSTALLOGRAPHIC VECTORS ARE
  1054:           C         A1=A(0,2TY,TZ),  A2=A(TX,-TY,TZ),  A3=A(-TX,-TY,TZ).
  1055:           C
  1056:                 include 'mpif.h'
  1057:                 INTEGER*4 PGIND,S(3,3,48),SUM
  1058:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1059:                 IF(PGIND.LT.6.OR.PGIND.GT.10) GO TO 100
  1060: V------>        DO 1 K=1,48
  1061: |*----->        DO 1 J=1,3
  1062: ||*---->        DO 1 I=1,3
  1063: ||*----       1 S(I,J,K)=0
  1064: *------>        DO 2 I=1,3
  1065: *------       2 S(I,I,1)=1
  1066:           C  POINT GROUP 3.
  1067:                 NTOT=3
  1068:                 S(1,3,2)=1
  1069:                 S(2,1,2)=1
  1070:                 S(3,2,2)=1
  1071:                 S(1,2,3)=1
  1072:                 S(2,3,3)=1
  1073:                 S(3,1,3)=1
  1074:                 IF(PGIND.EQ.6) RETURN
  1075:                 IF(PGIND.EQ.7.OR.PGIND.EQ.10) GO TO 15
  1076:                 NTOT=6
  1077:           C   SET UP C2X.
  1078:                 S(1,1,4)=-1
  1079:                 S(3,2,4)=-1
  1080:                 S(2,3,4)=-1
  1081:                 IF(PGIND.EQ.8) GO TO 12
  1082:           C   SET UP MX.
  1083: *------>        DO 11 J=1,3
  1084: |*----->        DO 11 I=1,3
  1085: |*-----      11 S(I,J,4)=-S(I,J,4)
  1086:           C  POINT GROUP 32 =3(X)C2X OR 3M = 3(X)MX.
  1087: +------>     12 DO 14 KIND=2,3
  1088: |*----->        DO 14 I=1,3
  1089: ||*---->        DO 14 J=1,3
  1090: |||             SUM=0
  1091: |||*--->        DO 13 K=1,3
  1092: |||*---      13 SUM=SUM+S(I,K,4)*S(K,J,KIND)
  1093: ||*----      14 S(I,J,KIND+3)=SUM
  1094:                 RETURN
  1095:              15 NTOT=6
  1096:           C   POINT GROUP <3> = 3(X)I
  1097: *------>        DO 16 KIND=1,3
  1098: |*----->        DO 16 J=1,3
  1099: ||*---->        DO 16 I=1,3
  1100: ||*----      16 S(I,J,KIND+3)=-S(I,J,KIND)
  1101:                 IF(PGIND.EQ.7) RETURN
  1102:           C   POINT GROUP <3>M = <3>(X)MX
  1103:                 NTOT=12
  1104:                 S(1,1,7)=1
  1105:                 S(2,3,7)=1
  1106:                 S(3,2,7)=1
  1107: V------>        DO 18 KIND=2,6
  1108: |*----->        DO 18 J=1,3
  1109: ||*---->        DO 18 I=1,3
  1110: |||             SUM=0
  1111: |||*--->        DO 17 K=1,3
  1112: |||*---      17 SUM=SUM+S(I,K,7)*S(K,J,KIND)
  1113: ||*----      18 S(I,J,KIND+6)=SUM
  1114:                 RETURN
  1115:             100 if ( my_rank.eq.0 ) WRITE(6,110) PGIND
  1116:             110 FORMAT(' POINT GROUP',I3,' IS NOT TRIGONAL. STOPPING')
  1117:                 STOP
  1118:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: FCCSYM
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1119:                 SUBROUTINE FCCSYM(PGIND,S,NTOT)
  1120:                 include 'mpif.h'
  1121:                 INTEGER*4 PGIND,S(3,3,48),SUM
  1122:           C   POINT GROUP ROTATION MATRICES FOR THE FCC BRAVAIS LATTICE.  IT IS
  1123:           C   ASSUMED THAT A1=(A/2)(-1,0,1), A2=(A/2)(0,1,1), A3=(A/2)(-1,1,0).
  1124:           C   THE ROTATION MATRICES EXPRESS HOW THESE BASIS VECTORS ARE TRANS-
  1125:           C   FROMED INTO ONE ANOTHER BY POINT-GROUP ROTATIONS.
  1126:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1127:                 IF(PGIND.LT.28.OR.PGIND.GT.32) GO TO 100
  1128: V------>        DO 10 K=1,48
  1129: |*----->        DO 10 J=1,3
  1130: ||*---->        DO 10 I=1,3
  1131: ||*----      10 S(I,J,K)=0
  1132: *------>        DO 11 I=1,3
  1133: *------      11 S(I,I,1)=1
  1134:                 NTOT=12
  1135:           C   POINT GROUP 23.
  1136:                 S(1,2,2)=-1
  1137:                 S(1,3,2)=1
  1138:                 S(2,2,2)=-1
  1139:                 S(3,1,2)=1
  1140:                 S(3,2,2)=-1
  1141:                 S(1,1,3)=-1
  1142:                 S(2,1,3)=-1
  1143:                 S(2,3,3)=1
  1144:                 S(3,1,3)=-1
  1145:                 S(3,2,3)=1
  1146:                 S(1,2,4)=1
  1147:                 S(1,3,4)=-1
  1148:                 S(2,1,4)=1
  1149:                 S(2,3,4)=-1
  1150:                 S(3,3,4)=-1
  1151:                 S(1,3,5)=-1
  1152:                 S(2,2,5)=1
  1153:                 S(2,3,5)=-1
  1154:                 S(3,1,5)=1
  1155:                 S(3,3,5)=-1
  1156:                 S(1,1,6)=-1
  1157:                 S(1,3,6)=1
  1158:                 S(2,1,6)=-1
  1159:                 S(2,2,6)=1
  1160:                 S(3,1,6)=-1
  1161: +------>        DO 74 KIND=5,6
  1162: |+----->        DO 74 JIND=2,4
  1163: ||*---->        DO 74 J=1,3
  1164: |||*--->        DO 74 I=1,3
  1165: ||||            SUM=0
  1166: ||||*-->        DO 72 K=1,3
  1167: ||||*--      72 SUM=SUM+S(I,K,JIND)*S(K,J,KIND)
  1168: |||*---      74 S(I,J,KIND+2*JIND-2)=SUM
  1169:                 IF(PGIND.EQ.28) RETURN
  1170:                 NTOT=24
  1171:                 IF(PGIND.NE.29) GO TO 76
  1172:           C   POINT GROUP M3 = I(X)23
  1173: V------>        DO 75 KIND=1,12
  1174: |*----->        DO 75 J=1,3
  1175: ||*---->        DO 75 I=1,3
  1176: ||*----      75 S(I,J,KIND+12)=-S(I,J,KIND)
  1177:                 RETURN
  1178:              76 IF(PGIND.EQ.31) GO TO 80
  1179:           C   POINT GROUP 432 = C4X(X)23
  1180:                 S(1,3,13)=1
  1181:                 S(2,1,13)=-1
  1182:                 S(2,3,13)=1
  1183:                 S(3,2,13)=-1
  1184:                 S(3,3,13)=1
  1185: V------>        DO 78 KIND=2,12
  1186: |*----->        DO 78 J=1,3
  1187: ||*---->        DO 78 I=1,3
  1188: |||             SUM=0
  1189: |||*--->        DO 77 K=1,3
  1190: |||*---      77 SUM=SUM+S(I,K,13)*S(K,J,KIND)
  1191: ||*----      78 S(I,J,KIND+12)=SUM
  1192:                 IF(PGIND.EQ.30) RETURN
  1193:           C   POINT GROUP M3M = I(X)432
  1194:                 NTOT=48
  1195: V------>        DO 79 KIND=1,24
  1196: |*----->        DO 79 J=1,3
  1197: ||*---->        DO 79 I=1,3
  1198: ||*----      79 S(I,J,KIND+24)=-S(I,J,KIND)
  1199:                 RETURN
  1200:           C   POINT <4>3M = <C4X>(X)23
  1201:              80 S(1,3,13)=-1
  1202:                 S(2,1,13)=1
  1203:                 S(2,3,13)=-1
  1204:                 S(3,2,13)=1
  1205:                 S(3,3,13)=-1
  1206: V------>        DO 85 KIND=2,12
  1207: |*----->        DO 85 J=1,3
  1208: ||*---->        DO 85 I=1,3
  1209: |||             SUM=0
  1210: |||*--->        DO 84 K=1,3
  1211: |||*---      84 SUM=SUM+S(I,K,13)*S(K,J,KIND)
  1212: ||*----      85 S(I,J,KIND+12)=SUM
  1213:                 RETURN
  1214:           C   HERE IF PGIND EXCEEDS 32 OR IS LESS THAN 28.
  1215:             100 if (my_rank.eq.0 ) WRITE(6,110) PGIND
  1216:             110 FORMAT(' POINT-GROUP INDEX',I4,' IS NOT BETWEEN 28 AND 32 FOR A CU
  1217:                1BIC GROUP. STOPPING')
  1218:                 STOP
  1219:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: BCCSYM
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1220:                 SUBROUTINE BCCSYM(PGIND,S,NTOT)
  1221:                 include 'mpif.h'
  1222:           C   POINT GROUP ROTATION MATRICES FOR CUBIC (BCC) BRAVAIS LATTICE.
  1223:           C   IT IS ASSUMED THAT A1=(A/2)(1,1,1), A2=(A/2)(-1,1,1),
  1224:           C   A3=(A/2)(-1,-1,1).  THE ROTATION MATRICES EXPRESS HOW THESE BASIS
  1225:           C   VECTORS ARE TRANSFORMED INTO ONE ANOTHER BY POINT-GROUP ROTATIONS.
  1226:                 INTEGER*4 PGIND,S(3,3,48),SUM
  1227:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1228: V------>        DO 1 K=1,48
  1229: |*----->        DO 1 J=1,3
  1230: ||*---->        DO 1 I=1,3
  1231: ||*----       1 S(I,J,K)=0
  1232: *------>        DO 2 I=1,3
  1233: *------       2 S(I,I,1)=1
  1234:                 IF(PGIND.LT.28.OR.PGIND.GT.32) GO TO 100
  1235:                 NTOT=12
  1236:           C   POINT GROUP 23.
  1237:                 S(1,2,2)=-1
  1238:                 S(2,1,2)=-1
  1239:                 S(3,1,2)=-1
  1240:                 S(3,2,2)=1
  1241:                 S(3,3,2)=-1
  1242:                 S(1,1,3)=-1
  1243:                 S(1,2,3)=1
  1244:                 S(1,3,3)=-1
  1245:                 S(2,3,3)=-1
  1246:                 S(3,2,3)=-1
  1247:                 S(1,3,4)=1
  1248:                 S(2,1,4)=1
  1249:                 S(2,2,4)=-1
  1250:                 S(2,3,4)=1
  1251:                 S(3,1,4)=1
  1252:                 S(1,1,5)=1
  1253:                 S(2,1,5)=1
  1254:                 S(2,2,5)=-1
  1255:                 S(2,3,5)=1
  1256:                 S(3,2,5)=-1
  1257:                 S(1,1,6)=1
  1258:                 S(2,3,6)=-1
  1259:                 S(3,1,6)=-1
  1260:                 S(3,2,6)=1
  1261:                 S(3,3,6)=-1
  1262: +------>        DO 74 KIND=5,6
  1263: |+----->        DO 74 JIND=2,4
  1264: ||*---->        DO 74 J=1,3
  1265: |||*--->        DO 74 I=1,3
  1266: ||||            SUM=0
  1267: ||||*-->        DO 72 K=1,3
  1268: ||||*--      72 SUM=SUM+S(I,K,JIND)*S(K,J,KIND)
  1269: |||*---      74 S(I,J,KIND+2*JIND-2)=SUM
  1270:                 IF(PGIND.EQ.28) RETURN
  1271:                 NTOT=24
  1272:                 IF(PGIND.NE.29) GO TO 76
  1273:           C   POINT GROUP M3 = I(X)23
  1274: V------>        DO 75 KIND=1,12
  1275: |*----->        DO 75 J=1,3
  1276: ||*---->        DO 75 I=1,3
  1277: ||*----      75 S(I,J,KIND+12)=-S(I,J,KIND)
  1278:                 RETURN
  1279:              76 IF(PGIND.EQ.31) GO TO 80
  1280:           C   POINT GROUP 432 = C4X(X)23
  1281:                 S(1,3,13)=-1
  1282:                 S(2,1,13)=-1
  1283:                 S(2,2,13)=1
  1284:                 S(2,3,13)=-1
  1285:                 S(3,2,13)=1
  1286: V------>        DO 78 KIND=2,12
  1287: |*----->        DO 78 J=1,3
  1288: ||*---->        DO 78 I=1,3
  1289: |||             SUM=0
  1290: |||*--->        DO 77 K=1,3
  1291: |||*---      77 SUM=SUM+S(I,K,13)*S(K,J,KIND)
  1292: ||*----      78 S(I,J,KIND+12)=SUM
  1293:                 IF(PGIND.EQ.30) RETURN
  1294:           C   POINT GROUP M3M = I(X)432
  1295:                 NTOT=48
  1296: V------>        DO 79 KIND=1,24
  1297: |*----->        DO 79 J=1,3
  1298: ||*---->        DO 79 I=1,3
  1299: ||*----      79 S(I,J,KIND+24)=-S(I,J,KIND)
  1300:                 RETURN
  1301:           C   POINT <4>3M = <C4X>(X)23
  1302:              80 S(1,3,13)=1
  1303:                 S(2,1,13)=1
  1304:                 S(2,2,13)=-1
  1305:                 S(2,3,13)=1
  1306:                 S(3,2,13)=-1
  1307: V------>        DO 85 KIND=2,12
  1308: |*----->        DO 85 J=1,3
  1309: ||*---->        DO 85 I=1,3
  1310: |||             SUM=0
  1311: |||*--->        DO 84 K=1,3
  1312: |||*---      84 SUM=SUM+S(I,K,13)*S(K,J,KIND)
  1313: ||*----      85 S(I,J,KIND+12)=SUM
  1314:                 RETURN
  1315:           C   HERE IF PGIND EXCEEDS 32 OR IS LESS THAN 28.
  1316:             100 if ( my_rank.eq.0 )WRITE(6,110) PGIND
  1317:             110 FORMAT(' POINT-GROUP INDEX',I4,' IS NOT BETWEEN 28 AND 32 FOR A CU
  1318:                1BIC GROUP. STOPPING')
  1319:                 STOP
  1320:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: BCTSYM
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1321:                 SUBROUTINE BCTSYM(PGIND,S,NTOT)
  1322:                 include 'mpif.h'
  1323:           C   POINT GROUP ROTATION MATRICES FOR TETRAGONAL (I) BRAVAIS LATTICES.
  1324:           C   IT IS ASSUMED THAT A1=(A/2,A/2,C/2), A2=(A/2,-A/2,C/2), AND
  1325:           C   A3=(-A/2,-A/2,C/2).  THE ROTATION MATRICES EXPRESS HOW THESE
  1326:           C   BASIS VECTORS ARE TRANSFORMED INTO ONE ANOTHER BY POINT GROUP
  1327:           C   ROTATIONS.
  1328:                 INTEGER*4 PGIND,S(3,3,48),SUM
  1329:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1330: V------>        DO 1 K=1,48
  1331: |*----->        DO 1 J=1,3
  1332: ||*---->        DO 1 I=1,3
  1333: ||*----       1 S(I,J,K)=0
  1334: *------>        DO 2 I=1,3
  1335: *------       2 S(I,I,1)=1
  1336:                 IF(PGIND.LT.11.OR.PGIND.GT.17) GO TO 40
  1337:           C   POINT GROUP 4.
  1338:                 NTOT=4
  1339:                 S(1,2,2)=1
  1340:                 S(2,3,2)=1
  1341:                 S(3,1,2)=1
  1342:                 S(3,2,2)=-1
  1343:                 S(3,3,2)=1
  1344:                 S(1,3,3)=1
  1345:                 S(2,1,3)=1
  1346:                 S(2,2,3)=-1
  1347:                 S(2,3,3)=1
  1348:                 S(3,1,3)=1
  1349:                 S(1,1,4)=1
  1350:                 S(1,2,4)=-1
  1351:                 S(1,3,4)=1
  1352:                 S(2,1,4)=1
  1353:                 S(3,2,4)=1
  1354:                 IF(PGIND.EQ.11) RETURN
  1355:                 IF(PGIND.NE.12.AND.PGIND.NE.16) GO TO 25
  1356:           C   POINT GROUP <4>.
  1357: *------>        DO 21 KIND=2,4,2
  1358: |*----->        DO 21 J=1,3
  1359: ||*---->        DO 21 I=1,3
  1360: ||*----      21 S(I,J,KIND)=-S(I,J,KIND)
  1361:                 IF(PGIND.EQ.12) RETURN
  1362:           C   POINT GROUP <4>2M = <4>(X)C2X.
  1363:                 NTOT=8
  1364:                 S(1,1,5)=-1
  1365:                 S(1,2,5)=1
  1366:                 S(1,3,5)=-1
  1367:                 S(2,3,5)=-1
  1368:                 S(3,2,5)=-1
  1369: +------>        DO 23 KIND=2,4
  1370: |*----->        DO 23 J=1,3
  1371: ||*---->        DO 23 I=1,3
  1372: |||             SUM=0
  1373: |||*--->        DO 22 K=1,3
  1374: |||*---      22 SUM=SUM+S(I,K,5)*S(K,J,KIND)
  1375: ||*----      23 S(I,J,KIND+4)=SUM
  1376:                 RETURN
  1377:              25 NTOT=8
  1378:                 IF(PGIND.NE.13) GO TO 26
  1379:           C   POINT GROUP 4/M = MZ(X)4
  1380:                 S(1,3,5)=-1
  1381:                 S(2,1,5)=-1
  1382:                 S(2,2,5)=1
  1383:                 S(2,3,5)=-1
  1384:                 S(3,1,5)=-1
  1385:                 GO TO 30
  1386:              26 IF(PGIND.NE.15) GO TO 27
  1387:           C   POINT GROUP 4MM = MX(X)4.
  1388:                 S(1,1,5)=1
  1389:                 S(1,2,5)=-1
  1390:                 S(1,3,5)=1
  1391:                 S(2,3,5)=1
  1392:                 S(3,2,5)=1
  1393:                 GO TO 30
  1394:           C   POINT GROUPS 422 = C2X(X)4 AND 4/MMM = I(X)422.
  1395:              27 S(1,1,5)=-1
  1396:                 S(1,2,5)=1
  1397:                 S(1,3,5)=-1
  1398:                 S(2,3,5)=-1
  1399:                 S(3,2,5)=-1
  1400: +------>     30 DO 32 KIND=2,4
  1401: |*----->        DO 32 J=1,3
  1402: ||*---->        DO 32 I=1,3
  1403: |||             SUM=0
  1404: |||*--->        DO 31 K=1,3
  1405: |||*---      31 SUM=SUM+S(I,K,5)*S(K,J,KIND)
  1406: ||*----      32 S(I,J,KIND+4)=SUM
  1407:                 IF(PGIND.NE.17) RETURN
  1408:                 NTOT=16
  1409: V------>        DO 34 KIND=1,8
  1410: |*----->        DO 34 J=1,3
  1411: ||*---->        DO 34 I=1,3
  1412: ||*----      34 S(I,J,KIND+8)=-S(I,J,KIND)
  1413:                 RETURN
  1414:              40 if ( my_rank.eq.0 ) WRITE(6,45) PGIND
  1415:              45 FORMAT(' POINT-GROUP INDEX',I3,' IS NOT BETWEEN 11 AND 17 FOR A TE
  1416:                1TRAGONAL GROUP. STOPPING')
  1417:                 STOP
  1418:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: BCCCON
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1494:                 SUBROUTINE BCCCON(PGIND,S,SC,NTOT)
  1495:           C***  CONVERTS TO CARTESIAN ORTHOGONAL FORM THE ROTATION MATRICES S
  1496:           C***  FOR THE BCC BRAVAIS LATTICE.
  1497:           C***  THE CARTESIAN MATRICES SC ARE GIVEN IN OUTPUT.
  1498:           C***  NOTICE THAT WITHIN THE ADOPTED CONVENTIONS THE S MATRICES
  1499:           C***  OPERATE ON ROW VECTORS AND THE SC MATRICES OPERATE ON COLUMN
  1500:           C***  VECTORS.
  1501:                 IMPLICIT REAL*8 (A-H,O-Z)
  1502:                 include 'mpif.h'
  1503:                 INTEGER*4 PGIND,S(3,3,48)
  1504:                 DIMENSION SC(3,3,24)
  1505:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1506:                 if ( my_rank.eq.0 ) WRITE(6,10)
  1507:           10    FORMAT(' THE SUBROUTINE BCCCON HAS NOT YET BEEN PROGRAMMED. STOPPI
  1508:                1NG.')
  1509:                 STOP
  1510:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: TRGCON
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1511:                 SUBROUTINE TRGCON(PGIND,S,SC,NTOT)
  1512:           C***  CONVERTS TO CARTESIAN ORTHOGONAL FORM THE ROTATION MATRICES S
  1513:           C***  FOR THE TRIGONAL(R) GROUPS.
  1514:           C***  THE CARTESIAN MATRICES SC ARE GIVEN IN OUTPUT.
  1515:           C***  NOTICE THAT WITHIN THE ADOPTED CONVENTIONS THE S MATRICES
  1516:           C***  OPERATE ON ROW VECTORS AND THE SC MATRICES OPERATE ON COLUMN
  1517:           C***  VECTORS.
  1518:                 IMPLICIT REAL*8 (A-H,O-Z)
  1519:                 include 'mpif.h'
  1520:                 INTEGER*4 PGIND,S(3,3,48)
  1521:                 DIMENSION SC(3,3,24)
  1522:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1523:                 if (my_rank.eq.0 ) WRITE(6,10)
  1524:           10    FORMAT(' THE SUBROUTINE TRGCON HAS NOT YET BEEN PROGRAMMED. STOPPI
  1525:                1NG.')
  1526:                 STOP
  1527:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: BCTCON
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1528:                 SUBROUTINE BCTCON(PGIND,S,SC,NTOT)
  1529:           C***  CONVERTS TO CARTESIAN ORTHOGONAL FORM THE ROTATION MATRICES S
  1530:           C***  FOR THE TETRAGONAL (I) BRAVAIS LATTICE.
  1531:           C***  THE CARTESIAN MATRICES SC ARE GIVEN IN OUTPUT.
  1532:           C***  NOTICE THAT WITHIN THE ADOPTED CONVENTIONS THE S MATRICES
  1533:           C***  OPERATE ON ROW VECTORS AND THE SC MATRICES OPERATE ON COLUMN
  1534:           C***  VECTORS.
  1535:                 IMPLICIT REAL*8 (A-H,O-Z)
  1536:                 include 'mpif.h'
  1537:                 INTEGER*4 PGIND,S(3,3,48)
  1538:                 DIMENSION SC(3,3,24)
  1539:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1540:                 if ( my_rank.eq.0 ) WRITE(6,10)
  1541:           10    FORMAT(' THE SUBROUTINE BCTCON HAS NOT YET BEEN PROGRAMMED. STOPPI
  1542:                1NG.')
  1543:                 STOP
  1544:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: PARITY
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1678:                 SUBROUTINE PARITY(SC,SCP,IP,NROT)
  1679:           C***  COMPUTES THE PARITY IP = DET( SC ) FOR ALL THE ROTATION
  1680:           C***  MATRICES SC AND CONSTRUCTS THE PROPER ROTATION MATRICES SCP.
  1681:           C***  IF IP = 1, SCP = SC ;
  1682:           C***  IF IP =-1, SCP = (-I) * SC, WHERE I IS THE IDENTITY MATRIX.
  1683:                 IMPLICIT REAL*8 (A-H,O-Z)
  1684:                 DIMENSION  SC(3,3,24),SCP(3,3,24),IP(24)
  1685:           C
  1686: V------>        DO 10 IROT=1,NROT
  1687: |       F         DET =   SC(1,1,IROT) * SC(2,2,IROT) * SC(3,3,IROT)
  1688: |              &        + SC(1,2,IROT) * SC(2,3,IROT) * SC(3,1,IROT)
  1689: |              &        + SC(2,1,IROT) * SC(3,2,IROT) * SC(1,3,IROT)
  1690: |              &        - SC(1,3,IROT) * SC(2,2,IROT) * SC(3,1,IROT)
  1691: |              &        - SC(1,1,IROT) * SC(2,3,IROT) * SC(3,2,IROT)
  1692: |              &        - SC(1,2,IROT) * SC(2,1,IROT) * SC(3,3,IROT)
  1693: |         C
  1694: |                                 IP(IROT)=1
  1695: |                 IF(DET.LT.0.D0) IP(IROT)=-1
  1696: |*----->            DO 14 I=1,3
  1697: ||*---->            DO 14 J=1,3
  1698: ||*----      14     SCP(I,J,IROT)=SC(I,J,IROT)*DFLOAT(IP(IROT))
  1699: V------      10 CONTINUE
  1700:           C **** TEMP
  1701:           CC     WRITE(6,1000) IP
  1702:           C1000 FORMAT(//' PARITY: IP = '/(16I4))
  1703:           C **** TEMP END
  1704:                 RETURN
  1705:           CCC*************** LAST CARD OF SYMPK *********************************
  1706:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: GRAM
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1708:                 SUBROUTINE GRAM(P,M1,N1,M2,N2)
  1709:                 IMPLICIT REAL*8(A-H,O-Z)
  1710:                 include 'mpif.h'
  1711:                 COMPLEX*16 P(M1,M2),CTEMP
  1712:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1713: +------>        DO 62 I=1,N2
  1714: |+----->           DO 64 J=1,I-1
  1715: ||                    CTEMP=(0.D0,0.D0)
  1716: ||V---->              DO 66 K=1,N1
  1717: ||V---- F    66       CTEMP=CTEMP+P(K,I)*DCONJG(P(K,J))
  1718: ||V---->              DO 68 K=1,N1
  1719: ||V---- F    68       P(K,I)=P(K,I)-CTEMP*P(K,J)
  1720: ||        C           WRITE(6,*) ' ORTH ',I,J,CTEMP
  1721: |+-----      64    CONTINUE
  1722: |         C        NORMALIZATION
  1723: |                  TEMP=0.D0
  1724: |V----->           DO 70 K=1,N1
  1725: |V----- F    70    TEMP=TEMP+DBLE(P(K,I)*DCONJG(P(K,I)))
  1726: |                  IF(TEMP.LT.1.D-10 .and. my_rank.eq.0 ) THEN
  1727: |                     WRITE(6,*) ' WAVEFUNCTION NEARLY LINEAR INDEPENDENT',
  1728: |              &                 I,TEMP
  1729: |                  ENDIF
  1730: |                  TEMP=1.D0/SQRT(TEMP)
  1731: |V----->           DO 72 K=1,N1
  1732: |V-----      72    P(K,I)=P(K,I)*TEMP
  1733: +------      62 CONTINUE
  1734:                 RETURN
  1735:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: GGEN2
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1737:                 SUBROUTINE GGEN2(NGQ,NG2,NG2Q,NG,G,G2,X,TPIBA2,GCUT2)
  1738:                 IMPLICIT REAL*8 (A-H,O-Z)
  1739:                 include 'mpif.h'
  1740:                 DIMENSION G(4,NGQ),G2(4,NG2Q),X(3)
  1741:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1742:                 NG2=1
  1743: +------>        DO 1 I=1,NG
  1744: |               IF(NG2.GT.NG2Q) GOTO 100
  1745: |               G2(1,NG2)=X(1)+G(1,I)
  1746: |               G2(2,NG2)=X(2)+G(2,I)
  1747: |               G2(3,NG2)=X(3)+G(3,I)
  1748: |               G2(4,NG2)=G2(1,NG2)**2 + G2(2,NG2)**2 + G2(3,NG2)**2
  1749: |               GDIF= G2(4,NG2)*TPIBA2
  1750: |               IF(GDIF.GT.GCUT2) GOTO 1
  1751: |               NG2=NG2+1
  1752: +------       1 CONTINUE
  1753:                 NG2=NG2-1
  1754:           C     WRITE(6,200) GCUT2,NG2
  1755:           C 200 FORMAT('   PLANE WAVE BASIS SET: GCUT2= ',F12.3,'  NG2= ',I5)
  1756:           C
  1757: +------>        DO 20 IG=1,NG2
  1758: |+----->          DO 30 JG=IG,NG2
  1759: ||                  IF( G2(4,JG).GE.G2(4,IG) ) GOTO 30
  1760: ||*---->              DO 15 IR=1,4
  1761: |||                     Q=G2(IR,IG)
  1762: |||                     G2(IR,IG)=G2(IR,JG)
  1763: |||                     G2(IR,JG)=Q
  1764: ||*----      15       CONTINUE
  1765: |+-----      30   CONTINUE
  1766: +------      20 CONTINUE
  1767:                 RETURN
  1768:             100 if ( my_rank.eq.0 ) WRITE(6,110) GCUT2
  1769:             110 FORMAT(' GCUT2=',1PE12.4,' IS TOO BIG. STOPPING')
  1770:                 STOP
  1771:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: LATGEN
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1773:                 SUBROUTINE LATGEN(IBRAV,CELLDM,A1,A2,A3,OMEGA)
  1774:           C
  1775:           C   SETS UP THE CRYSTALLOGRAPHIC VECTORS A1,A2, AND A3.
  1776:           C   IBRAV AND CELLDM ARE DEFINED IN THE TABLE AT THE BEGINNING
  1777:           C   OF SUBROUTINE KSUM.
  1778:           C
  1779:                 IMPLICIT REAL*8 (A-H,O-Z)
  1780:                 include 'mpif.h'
  1781:                 REAL*8 CELLDM(6),A1(3),A2(3),A3(3)
  1782:                 DATA SR3/1.73205080756888D+00/
  1783:                 call MPI_COMM_RANK(MPI_COMM_WORLD,my_rank,ierr)
  1784: *------>        DO 50 IR=1,3
  1785: |               A1(IR)=0.D0
  1786: |               A2(IR)=0.D0
  1787: *------      50 A3(IR)=0.D0
  1788:                 GO TO (2,4,6,8,10,12,14,16,18,20,22,24,26,28),IBRAV
  1789:           C     IBRAV=1:SIMPLE CUBIC
  1790:               2 A1(1)=CELLDM(1)
  1791:                 A2(2)=CELLDM(1)
  1792:                 A3(3)=CELLDM(1)
  1793:                 GO TO 100
  1794:           C     IBRAV=2:FCC
  1795:           C     A1=(-A/2,  0,A/2)
  1796:           C     A2=(   0,A/2,A/2)
  1797:           C     A3=(-A/2,A/2,  0)
  1798:               4 TERM=CELLDM(1)/2.D0
  1799:                 A1(1)=-TERM
  1800:                 A1(3)=TERM
  1801:                 A2(2)=TERM
  1802:                 A2(3)=TERM
  1803:                 A3(1)=-TERM
  1804:                 A3(2)=TERM
  1805:                 GO TO 100
  1806:           C     IBRAV=3:BCC
  1807:           C     A1=( A/2, A/2,A/2)
  1808:           C     A2=(-A/2, A/2,A/2)
  1809:           C     A3=(-A/2,-A/2,A/2)
  1810:               6 TERM=CELLDM(1)/2.D0
  1811: *------>        DO 71 IR=1,3
  1812: |               A1(IR)=TERM
  1813: |               A2(IR)=TERM
  1814: *------      71 A3(IR)=TERM
  1815:                 A2(1)=-TERM
  1816:                 A3(1)=-TERM
  1817:                 A3(2)=-TERM
  1818:                 GO TO 100
  1819:           C     IBRAV=4:TRIG,HEX
  1820:           C     A1=( A/2, A/2,A/2)
  1821:           C     A2=( A/2, A/2,A/2)
  1822:           C     A3=( A/2, A/2,A/2)
  1823:               8 CBYA=CELLDM(3)
  1824:                 A1(1)=CELLDM(1)
  1825:                 A2(1)=-CELLDM(1)/2.D0
  1826:                 A2(2)=CELLDM(1)*SR3/2.D0
  1827:                 A3(3)=CELLDM(1)*CBYA
  1828:                 GO TO 100
  1829:              10 TERM1=SQRT(1.D0+2.D0*CELLDM(4))
  1830:                 TERM2=SQRT(1.D0-CELLDM(4))
  1831:                 A1(2)=SQRT(2.D0)*CELLDM(1)*TERM2/SR3
  1832:                 A1(3)=CELLDM(1)*TERM1/SR3
  1833:                 A2(1)=CELLDM(1)*TERM2/SQRT(2.D0)
  1834:                 A2(2)=-A2(1)/SR3
  1835:                 A2(3)=A1(3)
  1836:                 A3(1)=-A2(1)
  1837:                 A3(2)=A2(2)
  1838:                 A3(3)=A1(3)
  1839:                 GO TO 100
  1840:              12 CBYA=CELLDM(3)
  1841:                 A1(1)=CELLDM(1)
  1842:                 A2(2)=CELLDM(1)
  1843:                 A3(3)=CELLDM(1)*CBYA
  1844:                 GO TO 100
  1845:              14 CBYA=CELLDM(3)
  1846:                 A1(1)=CELLDM(1)/2.D0
  1847:                 A1(2)=A1(1)
  1848:                 A1(3)=CBYA*CELLDM(1)/2.D0
  1849:                 A2(1)=A1(1)
  1850:                 A2(2)=-A1(1)
  1851:                 A2(3)=A1(3)
  1852:                 A3(1)=-A1(1)
  1853:                 A3(2)=-A1(1)
  1854:                 A3(3)=A1(3)
  1855:                 GO TO 100
  1856:              16 A1(1)=CELLDM(1)
  1857:                 A2(2)=CELLDM(1)*CELLDM(2)
  1858:                 A3(3)=CELLDM(1)*CELLDM(3)
  1859:                 GO TO 100
  1860:              18 GO TO 110
  1861:              20 GO TO 110
  1862:              22 GO TO 110
  1863:              24 SIN=SQRT(1.D0-CELLDM(4)**2)
  1864:                 A1(1)=CELLDM(1)
  1865:                 A2(1)=CELLDM(1)*CELLDM(2)*CELLDM(4)
  1866:                 A2(2)=CELLDM(1)*CELLDM(2)*SIN
  1867:                 A3(3)=CELLDM(1)*CELLDM(3)
  1868:                 GO TO 100
  1869:              26 GO TO 110
  1870:              28 SINGAM=SQRT(1.D0-CELLDM(6)**2)
  1871:                 TERM=SQRT((1.D0+2.D0*CELLDM(4)*CELLDM(5)*CELLDM(6)
  1872:                1 -CELLDM(4)**2-CELLDM(5)**2-CELLDM(6)**2)/(1.D0-CELLDM(6)**2))
  1873:                 A1(1)=CELLDM(1)
  1874:                 A2(1)=CELLDM(1)*CELLDM(2)*CELLDM(6)
  1875:                 A2(2)=CELLDM(1)*CELLDM(2)*SINGAM
  1876:                 A3(1)=CELLDM(1)*CELLDM(3)*CELLDM(5)
  1877:                 A3(2)=CELLDM(1)*CELLDM(3)*(CELLDM(4)-CELLDM(5)*CELLDM(6))/SINGAM
  1878:                 A3(3)=CELLDM(1)*CELLDM(3)*TERM
  1879:             100 OMEGA=0.D0
  1880:                 S=1.D0
  1881:                 I=1
  1882:                 J=2
  1883:                 K=3
  1884: *------>    101 DO 102 IPERM=1,3
  1885: |               OMEGA=OMEGA+S*A1(I)*A2(J)*A3(K)
  1886: |               L=I
  1887: |               I=J
  1888: |               J=K
  1889: |               K=L
  1890: *------     102 CONTINUE
  1891:                 I=2
  1892:                 J=1
  1893:                 K=3
  1894:                 S=-S
  1895:                 IF(S.LT.0.D0) GO TO 101
  1896:                 OMEGA=ABS(OMEGA)
  1897:                 RETURN
  1898:             110 if ( my_rank.eq.0 ) WRITE(6,120) IBRAV
  1899:             120 FORMAT(' BRAVAIS LATTICE',I3,' NOT PROGRAMMED. STOPPING')
  1900:                 STOP
  1901:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: RECIPS
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  1973:                 SUBROUTINE RECIPS(A,A1,A2,A3,B1,B2,B3)
  1974:           C
  1975:           C   GENERATES THE RECIPROCAL LATTICE VECTORS B1,B2,B3 GIVEN THE REAL
  1976:           C   SPACE VECTORS A1,A2,A3.  THE B'S ARE UNITS OF 2PI/A.
  1977:           C
  1978:                 IMPLICIT REAL*8 (A-H,O-Z)
  1979:                 REAL*8 A1(3),A2(3),A3(3),B1(3),B2(3),B3(3)
  1980:           C
  1981:           C CALCULATE THE VOLUME OF UNIT CELL 'DEN'
  1982:           C
  1983:                 DEN=0.D0
  1984:                 I=1
  1985:                 J=2
  1986:                 K=3
  1987:                 S=1.D0
  1988: *------>      1 DO 2 IPERM=1,3
  1989: |                  DEN=DEN+S*A1(I)*A2(J)*A3(K)
  1990: |                  L=I
  1991: |                  I=J
  1992: |                  J=K
  1993: |                  K=L
  1994: *------       2 CONTINUE
  1995:                 I=2
  1996:                 J=1
  1997:                 K=3
  1998:                 S=-S
  1999:                 IF(S.LT.0.) GO TO 1
  2000:           c
  2001:           c  UNIT VECTORS FOR THE RECIPROCAL LATTICE B1,B2,B3
  2002:           C  THE B'S ARE MADE DIMENSION-LESS BY MULTIPLYING WITH 'A'
  2003:           C
  2004:                 I=1
  2005:                 J=2
  2006:                 K=3
  2007:                 DEN=A/ABS(DEN)
  2008: *------>        DO 5 IR=1,3
  2009: |                  B1(IR)=DEN*(A2(J)*A3(K)-A2(K)*A3(J))
  2010: |                  B2(IR)=DEN*(A3(J)*A1(K)-A3(K)*A1(J))
  2011: |                  B3(IR)=DEN*(A1(J)*A2(K)-A1(K)*A2(J))
  2012: |                  L=I
  2013: |                  I=J
  2014: |                  J=K
  2015: |                  K=L
  2016: *------       5 CONTINUE
  2017:                 RETURN
  2018:                 END


NEC Fortran Compiler (3.5.0) for Vector Engine   Wed Oct 19 09:08:39 2022
FILE NAME: pack.f

PROCEDURE NAME: SUCOM0
FORMAT LIST

 Loop Mark                              Line Mark
 ---------                              ---------
 C - Conditionally Vectorized           C - Vector Scatter
 P - Parallelized                       F - Fused-multiply-add
 S - Partially Vectorized               G - Vector Gather
 U - Unrolled                           I - Inlined
 V - Vectorized                         M - Vector Matrix Multiply
 W - Collapsed and Vectorized           R - Retain
 Y - Parallelized and Vectorized        V - Vreg
 X - Interchanged and Vectorized        
 + - Not Vectorized                     
 * - Expanded                           

 LINE   LOOP      STATEMENT

  2020:                 SUBROUTINE SUCOM0
  2021:           C     BLOCK DATA
  2022:                 COMMON /ZSUCOM/ MLEVEL, NOUT
  2023:           C     DATA MLEVEL, NOUT / 1, 6/
  2024:                 MLEVEL=1
  2025:                 NOUT=6
  2026:                 END


